<!--- 
	This file includes a comma delimited list of 'variable scope prefixes' which 
	is used in the Code Generator dropdown for automating variable naming
	
	when a scope prefix is selected in the Code Generator view, in conjunction with 
	CFQUERYPARAM, the value attribute of the tag will reflect the prefix + the columnname, 
	wrapped in # signs, e.g.: 
	
		<cfqueryparam cfsqltype="CF_SQL_INTEGER" value="#arguments.myColumnName#" null="No">
	
	note: if you pass structs in as arguments to cfc methods (i do often) note that you can have dotted prefixes 
	as well, such as: arguments.args or this.that (just be sure to leave off the ending . as it is added by the routine)
	
	add or modify the list below as you see fit
 --->
 
<cfset scopes="args,arguments,arguments.in,request,attributes,form,url">
