<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
------------------------------------------------------------------ --->

	<!--- if mx, get datasource service dsn's --->		
	<cfset dbxr.enumDSNerror = "">

		<cfset dbxr.mx_dsns = querynew("name,driver,lcasename,hasLoginInfo")>
		<cftry>
			<cflock name="serviceFactory" type="exclusive" timeout="10">
			  <cfscript>
			    dbxr.factory = CreateObject("java", "coldfusion.server.ServiceFactory");
				dbxr.ds_service = dbxr.factory.datasourceservice; 
				dbxr.tmx_dsns = querynew("name,driver,lcasename,hasLoginInfo");
				for (dbxdatasource in dbxr.ds_service.datasources) {
					dbxr.tempDS = dbxr.ds_service.datasources["#dbxdatasource#"]; 
					tempDSName = dbxr.tempDS.getDatasourceDef().getExtraData().datasource;
					//check in case there's no driver specified, thanks to Aaron Longnion for finding this 
                    try { 
                    	tempDSDriver = dbxr.tempDS.getConnection().getMetaData().getDatabaseProductName(); 
					}
					catch (any e) {
						tempDSDriver = "N/A";
					}
					queryaddrow(dbxr.tmx_dsns,1);
					querysetcell(dbxr.tmx_dsns,"name",tempDSName);
					querysetcell(dbxr.tmx_dsns,"driver",tempDSDriver);
					querysetcell(dbxr.tmx_dsns,"lcasename",lcase(tempDSName));
					querysetcell(dbxr.tmx_dsns,"hasLoginInfo",0);					 
				}			
			  </cfscript> 
			</cflock>

			<cfquery dbtype="query" name="dbxr.mx_dsns">
				SELECT * FROM dbxr.tmx_dsns 
				WHERE driver LIKE '%Microsoft%'  AND driver LIKE '%SQL%'
				ORDER BY lcasename
			</cfquery>

		<cfcatch type="any">
			<cfset dbxr.enumDSNerror = cfcatch.message>
		</cfcatch>
		
		</cftry>

<cfsetting enablecfoutputonly = "no">