<cfif not dbx.guestmode>
<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
		9.0.4 - 3/3/2006 - Kevin MIller - added output formatting options
------------------------------------------------------------------ --->

<cfparam name="f" type="string" default="">
<cfparam name="form.sqltoexec" type="string" default="">
<cfparam name="form.resulttarget" type="string" default="_self">
<cfparam name="form.outputFormat" type="string" default="dump"><!--- table / dump / csv / tsv --->
	<cfif not listfindnocase("table,dump,csv,tsv",form.outputFormat)>
		<cfset form.outputFormat = "dump">
	</cfif>
<cfparam name="form.forceExcel" type="string" default="false"><!--- whether to force excel content type for csv/tsv --->
<cfparam name="form.forceDL" type="string" default="false"><!--- whether to force download for csv/tsv --->
<cfparam name="form.qloaded" type="string" default="">

<cfset dbxr.message = "">

<cfsetting enablecfoutputonly = "no">

<cfif not len(f)><!--- frameset --->
<html>
	<head>
	<title>DBX - Exec SQL</title><cfoutput>
	<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#style.css"></cfoutput>
	</head>
		<frameset rows="50%,*,0" framespacing="0"><cfoutput>
		    <frame src="#dbxr.fullfilepathprefix#?se=1&f=t" name="exectop" id="exectop" scrolling="no" marginwidth="0" marginheight="0">
		    <frame src="#dbxr.fullfilepathprefix#?se=1&f=b" name="execbottom" id="execbottom" scrolling="yes" marginwidth="0" marginheight="0">
			<frame src="about:blank" name="execcontrol" id="execcontrol" noresize scrolling="no" marginwidth="0" marginheight="0" border="0"></cfoutput>
		</frameset>
</html>

<cfelseif f eq "t"><!--- top area --->

<!--- verify cffile/cfdirectory are available --->
<cfset fileTagsEnabled = true>
<cftry>
	
	<!--- if either fail, we cannot use the query save feature; if successful, we have the currently saved query packets --->
	<cfdirectory action="LIST" directory="#expandpath("./genetics")#" name="genetics" filter="*.txt" sort="name">
	<cffile action="READ" file="#expandpath("./readme/version_history.txt")#" variable="history">
	
	<cfcatch>
		<cfset fileTagsEnabled = false>
	</cfcatch>
</cftry>

<cfif fileTagsEnabled and isdefined("form.qmode")><!--- loading or saving a query --->
	
	<cfif form.qmode eq "load">
		
		<cffile action="READ" file="#expandpath("./genetics/#form.qpacket#.txt")#" variable="loadedquery">
		<cfset form.qloaded = form.qpacket>
	
	<cfelseif form.qmode eq "save"><!--- saving --->

		<cffile action="WRITE" file="#expandpath("./genetics/#urlencodedformat(form.qname)#.txt")#" output="#form.qcontent#" addnewline="No"> 
		<cfset form.qloaded = urlencodedformat(form.qname)>
		<cfset loadedquery = form.qcontent>
		<cfdirectory action="LIST" directory="#expandpath("./genetics")#" name="genetics" filter="*.txt" sort="name">
	
	<cfelseif form.qmode eq "update">

		<cffile action="WRITE" file="#expandpath("./genetics/#urlencodedformat(form.qname)#.txt")#" output="#form.qcontent#" addnewline="No"> 
		<cfset form.qloaded = urlencodedformat(form.qname)>
		<cfset loadedquery = form.qcontent>
		<cfdirectory action="LIST" directory="#expandpath("./genetics")#" name="genetics" filter="*.txt" sort="name">
	
	<cfelseif form.qmode eq "delete">
	
		<cffile action="DELETE" file="#expandpath("./genetics/#form.qpacket#.txt")#">
		<cfdirectory action="LIST" directory="#expandpath("./genetics")#" name="genetics" filter="*.txt" sort="name">
	
	</cfif>
	
</cfif>

	<html>
	<head>
		<title>Execute SQL Window</title><cfoutput>
		<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>
		<script><cfoutput>
			var fileTagsEnabled = #fileTagsEnabled#; </cfoutput>
			
			function submitSQLForm( which ) {
				theForm = document.forms[which];
				if(!theForm.sqltoexec.value.length) { document.form_sql.sqltoexec.focus(); return false; }
				else {
					if(!theForm.resulttarget.checked) { parent.exectop.showStatus('Working...'); }
					theForm.target = (theForm.resulttarget.checked) ? '_blank' : 'execbottom'; 
					theForm.action = (theForm.resulttarget.checked) ? theForm.action + '&nnw=1' : theForm.action;
					theForm.submit();
				}
			}
			
			function checkLoader() {<cfoutput>
				document.form_sql.sqltoexec.value = '<cfif isdefined("loadedquery")>#jsstringformat(loadedquery)#</cfif>';</cfoutput>
			}
			
			function checkOpener() {
				if(parent.opener.top.frames['detail'].frames.length) {
					if(parent.opener.top.frames['detail'].frames['detailtop'].sqlForExecWin != null) {
						document.form_sql.sqltoexec.value = parent.opener.top.frames['detail'].frames['detailtop'].sqlForExecWin;
					}
				}
			}
			
			function getElement(id){
				if (document.getElementById)
					return document.getElementById(id);
				if (document.all)
					return document.all[id];
				
				return null;
			}

			function initTab(id){
				oTA = getElement(id);
				if (oTA.attachEvent)
					oTA.attachEvent("onkeydown",function (event) { if (event.keyCode==9) { document.selection.createRange().text="\t"; return false; } });
				if (oTA.addEventListener)
					oTA.addEventListener(
					"keypress",
					function (event) {
						if (event.keyCode==9) {
							var oTA=this,
								iStart=oTA.selectionStart;
			
							oTA.value=this.value.substring(0,iStart)+"\t"+this.value.substr(oTA.selectionEnd);
							// setTimeout(function () { oTA.focus(); oTA.selectionStart=iStart+1; oTA.selectionEnd=iStart+1; },1);
							oTA.selectionStart=iStart+1; 
							oTA.selectionEnd=iStart+1;
							event.preventDefault()
						}
					},
					false
				)
			}

			function initRemappedKeys(id){
				te = getElement(id);
				if (te.attachEvent)
					te.attachEvent("onkeydown",function (event) { if (event.ctrlKey && (event.keyCode==82 || event.keyCode==114)) { document.form_sql.submit(); return false; } });
				if (te.addEventListener)
					te.addEventListener("keypress",function (event) { if (event.ctrlKey && (event.charCode==82 || event.charCode==114)) { event.preventDefault(); document.form_sql.submit() } }, false)
			}

			var showtext = "Idle";
			function showStatus(text) {
				thisdiv = document.getElementById('working');
		    	thisdiv.innerHTML = text;
			}
			
			function saveQuery() { 
				if(!getElement('sqltoexec').value.length) { 
					alert('Cannot save an empty query statement.  Please enter text in the query window to proceed.'); 
					return false;
				}
				else { 
					var qn = prompt('Enter a reference name for this saved query:'); 
					if(qn == null || !qn.length) { 
						return false; 
					}
					getElement('qname').value = qn; 
					getElement('qcontent').value = getElement('sqltoexec').value; 
					getElement('qmode').value = 'save'; 
					setTimeout("getElement('form_saver').submit()",500); 
				}
			}
			
			function validateQueryLoad() { 
				if(!getElement('qpacket').value.length) { 
					return false; 
				}
				else { 
					getElement('form_saver').submit(); 
				}
			}
			
			function validateQueryUpdate() { 
				if(!getElement('qpacket').value.length) { 
					return false; 
				}
				else { 
					var okUpdate = confirm('Are you sure you wish to update this saved query with the currently displayed statement?'); 
					if(okUpdate) { 
						getElement('qmode').value = 'update'; 
						getElement('qname').value = unescape(getElement('qpacket').value); 
						getElement('qcontent').value = getElement('sqltoexec').value;  
						setTimeout("getElement('form_saver').submit()",500); 
					}
				}
			}
			
			function validateQueryDelete() { 
				if(!getElement('qpacket').value.length) { 
					return false; 
				}
				else { 
					var okDelete = confirm('Are you sure you wish to delete this saved query?  This action is irreversible.'); 
					if(okDelete) { 
						getElement('qmode').value = 'delete'; 
						getElement('qname').value = unescape(getElement('qpacket').value); 
						setTimeout("getElement('form_saver').submit()",500); 
					}
				}
			}
			
			function toggleLoadButtons() { 
				if(fileTagsEnabled && getElement('qpacket')) { 
					if(getElement('qpacket').value.length) { 
						getElement('qupdate').disabled = false; 
						getElement('qupdate').style.color = '#000000'; 
						getElement('qdelete').disabled = false; 
						getElement('qdelete').style.color = '#000000'; 
					}
					else { 
						getElement('qupdate').disabled = true; 
						getElement('qupdate').style.color = '#999999'; 
						getElement('qdelete').disabled = true; 
						getElement('qdelete').style.color = '#999999'; 
					}
				}
			}
		</script>
	</head>
	<body onload="checkLoader(); toggleLoadButtons(); <cfif not isdefined("loadedquery")>checkOpener(); </cfif>initRemappedKeys('sqltoexec'); initTab('sqltoexec'); document.form_sql.sqltoexec.focus();" class="inner">

	<table class="navbar" cellspacing="0" width="100%" height="100%">
	<cfif fileTagsEnabled><cfoutput><form action="#dbxr.fullfilepathprefix#?se=1&f=t" method="post" name="form_saver" id="form_saver" target="exectop"></cfoutput>
	<tr><td height="20" class="pad3" colspan="2"> <cfif genetics.recordcount>Load Saved Query: <select name="qpacket" id="qpacket" class="select" onchange="toggleLoadButtons();"><option value="">Select a saved query to load</option><cfoutput query="genetics"><option value="#listfirst(name,".")#"<cfif form.qloaded eq listfirst(name,".")> selected</cfif>>#urldecode(listfirst(name,"."))#</option></cfoutput></select> <input type="button" value="Load" class="button" onclick="validateQueryLoad();"> <input type="button" value="Update" id="qupdate" class="button" onclick="validateQueryUpdate();" disabled> <input type="button" value="Delete" id="qdelete" class="button" onclick="validateQueryDelete();" disabled><cfelse>&nbsp;</cfif><input type="hidden" name="qmode" id="qmode" value="load"></td>
	<td height="20" class="r pad3"><input type="hidden" name="qcontent" id="qcontent" value=""><input type="hidden" name="qname" id="qname" value=""><input type="button" value="Save Current Statement" class="button" onclick="saveQuery();" title="Save the current sql statement below to load in future sessions"></td>
	</tr></form></cfif>
	<cfoutput><form action="#dbxr.fullfilepathprefix#?se=1&f=b" method="post" name="form_sql" id="form_sql" target="execbottom"></cfoutput>
	<tr><td height="20" colspan="3" class="c pad3">Output Format: <input type="radio" id="of0" name="outputFormat" value="table"<cfif form.outputFormat eq "table"> checked</cfif>> <label for="of0" title="Display results in an HTML table">TABLE</label> &nbsp; <input type="radio" id="of1" name="outputFormat" value="dump"<cfif form.outputFormat eq "dump"> checked</cfif>> <label for="of1" title="Display results using CFDUMP">CFDUMP</label> &nbsp; <input type="radio" id="of2" name="outputFormat" value="csv"<cfif form.outputFormat eq "csv"> checked</cfif>> <label for="of2" title="Generate Comma-separated Value file from results">CSV</label> &nbsp; <input type="radio" id="of3" name="outputFormat" value="tsv"<cfif form.outputFormat eq "tsv"> checked</cfif>> <label for="of3" title="Generate Tab-separated Value file from results">TSV</label> &nbsp;&nbsp;|&nbsp;&nbsp; <label for="forceExcel" title="Attempts to force the resulting CSV/TSV to open in Excel">Force Excel Content-type for CSV/TSV</label> <input type="checkbox" id="forceExcel" name="forceExcel" value="true"<cfif form.forceExcel> checked</cfif>> &nbsp;&nbsp;|&nbsp;&nbsp; <label for="forceDL" title="Attempts to force the download of the resulting file rather than being opened in Excel">Force Download for CSV/TSV</label> <input type="checkbox" id="forceDL" name="forceDL" value="true"<cfif form.forceDL> checked</cfif>></td></tr>
		<tr><td width="100%" height="100%" colspan="3"><textarea id="sqltoexec" name="sqltoexec"><cfoutput>#form.sqltoexec#</cfoutput></textarea></td></tr>
		<tr><td height="20" class="pad3" style="width: 40%"><span class="italic">tab-enabled textarea above | ctrl+r submits form</span></td><td height="20" class="c pad3" style="width: 20%"><input type="button" value="EXECUTE SQL"  class="button" onclick="submitSQLForm('form_sql');"></td><td height="20" class="r pad3" style="width: 40%"><input type="checkbox" class="checkbox" id="resulttarget" name="resulttarget" value="_blank"<cfif form.resulttarget eq "_blank"> checked</cfif>> <span class="light"><label for="resulttarget" title="Open results in a new window">Open in New Window</label></span><br></td></tr>
		<tr><td colspan="3"><div class="tabbox" id="working" style="display: block; margin: 0;">Idle</div></td></tr></table></form>
</body>
</html>
	
<cfelseif f eq "b"><!--- results --->
	<html>
	<head>
		<title>Execute SQL Window</title><cfoutput>
		<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>
	</head>
	<body class="inner">
	<cfset thestatustext = "">
	<cfif isdefined("form.sqltoexec") and len(trim(form.sqltoexec))>
			
		<cftry>
			
			<cfset userSQL = querynew("nothing")>
			
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="userSQL">
				#preservesinglequotes(sqltoexec)#
			</cfquery>
			
			<cfif isquery(userSQL) and userSQL.recordcount>
			
			<cfset thestatustext = "Query execution time: " & cfquery.executionTime & "ms">
			
				<cfswitch expression="#form.outputFormat#">
					
					<cfcase value="table">
					<table border="0" cellpadding="0" cellspacing="1" class="stable">
					<tr><cfoutput><cfloop list="#userSQL.columnlist#" index="c"><td class="stableh">#c#</td></cfloop></cfoutput></tr>
					<cfoutput query="userSQL"><cfset gdsrow = currentrow>
					<tr><cfloop list="#userSQL.columnlist#" index="c"><td>#userSQL[c][gdsrow]#</td></cfloop></tr>
					</cfoutput>
					</table>					
					</cfcase>
					
					<cfcase value="dump">
						<cfdump var="#userSQL#">
					</cfcase>
					
					<cfcase value="csv">
<cfset outputText = ""><cfset tempRow = ""><cfloop list="#userSQL.columnlist#" index="c"><cfset tempRow = listappend(tempRow,c,",")></cfloop><cfset outputText = listappend(outputText,tempRow,chr(13))><cfloop query="userSQL"><cfset tempRow = ""><cfloop list="#userSQL.columnlist#" index="c"><cfset tempRow = listappend(tempRow,userSQL[c][currentrow],",")></cfloop><cfset outputText = listappend(outputText,tempRow,chr(13))></cfloop>
<cfif not form.forceExcel><cfoutput>
<pre class="pad" style="background-color: ##fff;">#outputText#</cfoutput>
</pre>
<cfelse><cfset dltype = "inline"><cfif form.forceDL><cfset dltype = "attachment"></cfif>
<cfheader name="Content-Disposition" value="#dltype#; filename=#dbdsn#_Report.csv">
<cfcontent type="vnd/ms-excel"><cfoutput>#outputText#</cfoutput><cfabort>
</cfif>
					</cfcase>
					
					<cfcase value="tsv">
<cfset outputText = ""><cfset tempRow = ""><cfloop list="#userSQL.columnlist#" index="c"><cfset tempRow = listappend(tempRow,c,chr(9))></cfloop><cfset outputText = listappend(outputText,tempRow,chr(13))><cfloop query="userSQL"><cfset tempRow = ""><cfloop list="#userSQL.columnlist#" index="c"><cfset tempRow = listappend(tempRow,userSQL[c][currentrow],chr(9))></cfloop><cfset outputText = listappend(outputText,tempRow,chr(13))></cfloop>
<cfif not form.forceExcel><cfoutput>
<pre class="pad" style="background-color: ##fff;">#outputText#</cfoutput>
</pre>
<cfelse><cfset dltype = "inline"><cfif form.forceDL><cfset dltype = "attachment"></cfif>
<cfheader name="Content-Disposition" value="#dltype#; filename=#dbdsn#_Report.csv">
<cfcontent type="vnd/ms-excel"><cfoutput>#outputText#</cfoutput><cfabort>
</cfif>
					</cfcase>
					
					<cfdefaultcase>
						<cfdump var="#userSQL#">
					</cfdefaultcase>
				
				</cfswitch>
			
			<cfelse>
				<cfset dbxr.message = "SQL Execution complete, no resultset.">
			</cfif>

			<cfcatch>
				<cfset thestatustext = "Error occurred.">
				<cfset dbxr.message = dbxr.message & cfcatch.message & "<br><br>" & cfcatch.detail>
			</cfcatch>
		
		</cftry>
		
		<cfif len(dbxr.message)>
		<div class="error"><p><cfoutput>#dbxr.message#</cfoutput></p></div>
		</cfif>
	</cfif>
	<cfif len(thestatustext) and not isdefined("url.nnw")>
	<script><cfoutput>
		parent.exectop.showStatus('#jsstringformat(thestatustext)#');</cfoutput>
	</script>
	</cfif>
	</body>
	</html>
</cfif>

</cfif>
<cfif not dbx.debugging>
	<cfsetting showdebugoutput="no">
</cfif>
<cfabort>
