<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
------------------------------------------------------------------ --->

<cfsetting enablecfoutputonly = "no">

	<cfif not isdefined("form.doCreateNow")>
	<!--- get the tables rowcount --->
	<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="ciRowcount">
		SELECT count(*) as numrows FROM #url.t#;
	</cfquery>

	<html>
	<head><cfoutput>
		<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>
	</head>
	<body class="codeview">
	<cfif not ciRowcount.numrows>
	<div class="pad">
	<table border=0 cellpadding=0 cellspacing=0 height="100%" width="80%" align="center">
		<tr><td align="center"><cfoutput>The <span class="heavy">#url.t#</span> table currently has <span class="heavy">0</span> rows of data.  No insert statements to create.<br><br><a href="##" onclick="self.close();">&laquo; Close Window &raquo;</a></cfoutput></td></tr>
	</table>
	</div>
	<cfelse><!--- we have some data --->
	<div class="pad">
	<table border=0 cellpadding=0 cellspacing=0 width="80%" align="center">
		<tr><td align="center"><cfoutput>The <span class="heavy">#url.t#</span> table currently has <span class="heavy">#ciRowcount.numrows#</span> row<cfif ciRowcount.numrows neq 1>s</cfif> of data.</cfoutput><br><br></td></tr>
		<tr><td align="center">
			<table border="0" cellpadding="3" cellspacing="0">
				<cfoutput><form action="#dbxr.fullfilepathprefix#?ci=1&t=#url.t#" method="post"></cfoutput>
					<tr><td>This will create a series of INSERT statements for the <span class="heavy"><cfoutput>#url.t#</cfoutput></span> table.  You have the option of using Identity Insert which will insert the current identity value for appropriate columns.  Deselecting the box will create standard insert statements.<br><br></td></tr>
					<tr><td align="center"><input type="checkbox" id="useIDInsert" name="useIDInsert" value="1"> <label for="useIDInsert">Use Identity Insert?</label></td></tr>
					<tr><td align="center"><br><br><input type="hidden" value="1" name="doCreateNow"><input type="submit" value="CREATE INSERTS" class="button">&nbsp;&nbsp;<input type="button" value="CANCEL" class="button" onclick="self.close();"></td></tr>
				</form>
			</table>
		</td></tr>
	</table>
	</div>
	</cfif>
	</body>
	</html>
	<cfelse>

			<cftry>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject">
					EXEC sp_columns '#trim(url.t)#';
				</cfquery>
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getdata">
					SELECT * FROM #url.t#;
				</cfquery>
			<cfcatch type="Any">
				<cfset getobject = querynew("nothing")>
			</cfcatch>
			</cftry>	
			<cfif not isquery(getobject) or not getobject.recordcount>
				Error occurred.
				<cfabort>
			</cfif>
			
				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="theDB">
					SELECT db_name() AS theDBName;
				</cfquery>
				
	<!--- outputting the inserts here --->
		<cfscript>
			insertHEADER = "USE [#theDB.theDBName#]#chr(13)##chr(10)##chr(13)##chr(10)#";
				if( isdefined("form.useIDInsert") ) {
					insertHEADER = insertHEADER & "SET IDENTITY_INSERT [#url.t#] ON#chr(13)##chr(10)##chr(13)##chr(10)#";
				}
			insertBODY = ""; 
			insertBODY2 = "";
			insertFOOTER = "";
				if( isdefined("form.useIDInsert") ) {
					insertFOOTER = insertFOOTER & "#chr(13)##chr(10)#SET IDENTITY_INSERT [#url.t#] OFF#chr(13)##chr(10)#";
				}
			insertFOOTER = insertFOOTER & "#chr(13)##chr(10)##chr(13)##chr(10)#/*#chr(13)##chr(10)#Description: Inserts values into the #getobject.table_name# table#chr(13)##chr(10)#Created by: DBX #dbx.version##chr(13)##chr(10)#Version: 1.0#chr(13)##chr(10)#Created: #dateformat(now(),'mm/dd/yyyy')##chr(13)##chr(10)#Last changed: #dateformat(now(),'mm/dd/yyyy')##chr(13)##chr(10)#*/";
			insertFINAL = "";
		</cfscript>
	
	<cfset outerCR = 0><!--- currentrow for data query --->
	<cfloop query ="getdata">
		<cfset outerCR = outerCR + 1>
		<cfloop query="getobject">
	
				<!--- build the template sql for the query output --->
				<cfscript>						
					if(not listfindnocase("timestamp,varbinary,image",type_name)) {
						if( type_name eq "int identity" ) {
							if( isdefined("form.useIDInsert") ) {
								insertBODY = insertBODY & "#column_name#,";
								insertBODY2 = insertBODY2 & "#evaluate("getdata.#column_name#[#outerCR#]")#,";
							}
						}
						else if(listfindnocase("char,nchar,varchar,nvarchar,text,ntext",type_name)) {
								insertBODY = insertBODY & "#column_name#,";
								if(len(evaluate("getdata.#column_name#[#outerCR#]"))) {	tB2 = "'" & replace(evaluate("getdata.#column_name#[#outerCR#]"),"'","''","all") & "'";	}
								else { tB2 = "NULL"; }
								insertBODY2 = insertBODY2 & "#tB2#,";
						}
						else if(listfindnocase("datetime,smalldatetime",type_name)) {
								insertBODY = insertBODY & "#column_name#,";
								if(len(evaluate("getdata.#column_name#[#outerCR#]"))) {	tB2 = "'" & dateformat(evaluate("getdata.#column_name#[#outerCR#]"),"yyyy-mm-dd") & "'";	}
								else { tB2 = "NULL"; }
								insertBODY2 = insertBODY2 & "#tB2#,";
						}
						else {
								insertBODY = insertBODY & "#column_name#,";
								if(len(evaluate("getdata.#column_name#[#outerCR#]"))) {	tB2 = evaluate("getdata.#column_name#[#outerCR#]");	}
								else { tB2 = "NULL"; }
								insertBODY2 = insertBODY2 & "#tB2#,";
						}
					}
				</cfscript>

		</cfloop>
				
		<cfscript>
			insertFINAL = insertFINAL & "INSERT INTO #getobject.table_name# (" & mid(insertBODY,1,(len(insertBODY)-1)) & ") VALUES (" & mid(insertBODY2,1,(len(insertBODY2)-1)) & ");#chr(13)##chr(10)#"; 
		</cfscript>
		<cfset insertBODY = ""><cfset insertBODY2 = "">
	</cfloop>
	

				<cfscript>
					insertFINAL = insertHEADER & insertFINAL & insertFOOTER; 
				</cfscript>

<pre>
<cfoutput>
#insertFINAL#</cfoutput>
</pre>
<cfif not dbx.debugging>
	<cfsetting showdebugoutput="no">
</cfif>
<cfabort>
</cfif>