<cfsetting enablecfoutputonly = "yes">

<cfinclude template="udf/udf_secsToTime.cfm">

<cfset formatSizeMode = "simple"><!--- controls the manner in which filesizes are rendered below --->

<cfsetting enablecfoutputonly = "no">

<cfif not dbx.guestmode>
<html>
<head>
	<title>DBX</title><cfoutput>
	<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css">
	<script type="text/javascript" src="#dbxr.fullpathprefix#js/jquery-1.2.6.min.js"></script>
	<script type="text/javascript" src="#dbxr.fullpathprefix#js/jquery.tablesorter.min.js"></script></cfoutput>
	<script type="text/javascript">
		APP = top; 

			// page tabs
			var proftabs = new Array('dsn','table','fulltext','extprop');
			var activetab = 'dsn'; 
			
			function switchTab(which) { 
				var which = (which != null) ? which : activetab; 
				
				for(var i=0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div') && document.getElementById(proftabs[i] + 'tab')) { 
						if(proftabs[i] == which) { 
							document.getElementById(proftabs[i] + 'div').className = 'pagedivon'; 
							document.getElementById(proftabs[i] + 'tab').className = 'pagetab on';
							activetab = which; 
						}
						else { 
							document.getElementById(proftabs[i] + 'div').className = 'pagediv'; 
							document.getElementById(proftabs[i] + 'tab').className = 'pagetab';		
						}
					}
				}
			}
	
			function setDivScrollers() { 
				var thirdheight = document.getElementById('third').offsetHeight; 
				for(var i = 0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div')) { 
							document.getElementById(proftabs[i] + 'div').style.height = thirdheight; 
					}
				}
			}
	
			function doresize() { 
				for(var i = 0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div')) { 
						document.getElementById(proftabs[i] + 'div').style.height = '1px'; 
					}
				}
				setDivScrollers(); 
				switchTab(activetab); 
			}
			onresize = doresize;
			
			// handle differing formats in table cells
			var formatting = function(node) { 
				var value = node.innerHTML; 
				if(isNaN(parseFloat(value))) { 
					return value; 
				}
				else { // treat as numbers 
					var modifier = 1.00; // bytes
					var patt = new RegExp(/kb$/i); 
					if(patt.test(node.innerHTML)) { 
						modifier = 1024.00; 
					}
					else { 
						patt = new RegExp(/mb$/i); 
						if(patt.test(node.innerHTML)) { 
							modifier = 1048576.00;
						}
						else { 
							patt = new RegExp(/gb$/i); 
							if(patt.test(node.innerHTML)) { 
								modifier = 1073741824.00;
							}
							else { // tb
								modifier = 1099511627776.00; 
							}
						}
					}
					// return node.innerHTML; 
					value = parseFloat(node.innerHTML.replace(/[^0-9.]/g,'')) * modifier;   
					return value.toString();
					
				}
			} 
			function printTab() { 
				if(document.getElementById(activetab + 'div')) { 
					var pwindow = window.open('about:blank','pwindow'); 
					var ptitle = activetab.toUpperCase(); <cfoutput>
					var writeme = '<html><head>	<title>DBX - Print Window</title><link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"><scr' + 'ipt>APP = null;</scr' + 'ipt><style>body { background: ##fff; color: ##000; padding: 20px; } div.pagedivon { scrolling: auto; height: auto; }</style></he' + 'ad><body><div class="pagedivon"><div class="stableh">' + ptitle + '</div><br>'; </cfoutput>
					writeme += document.getElementById(activetab + 'div').innerHTML; 
					writeme += '</div></body></html>';
					pwindow.document.write(writeme); 
					pwindow.print(); 
				} 
				else { 
					return false; 
				}
			}
			$(document).ready(function() { APP.writeStatus(0); setDivScrollers(); switchTab(activetab); $('#db-table-info').tablesorter( {textExtraction: formatting} ) });
	</script>
</head>

	<body>

	<table id="sourcelayout" border="0" cellpadding="0" cellspacing="0">
	<tr><td class="first">
		<table border="0" cellspacing="0" class="navbar2">
		<tr><td><div class="tab">Database Information</div></td><td class="r"><a href="#" onclick="printTab(); return false;" class="nav" title="Print currently open tab">Print</a></td></tr>
		</table>
	</td>
	</tr>
	<tr><td class="second">
	<div id="pagetabs">
		<a id="dsntab" href="#" class="pagetab on" onclick="switchTab('dsn'); return false;">Database Info</a>
		<a id="tabletab" href="#" class="pagetab" onclick="switchTab('table'); return false;">Table Info</a>
		<a id="fulltexttab" href="#" class="pagetab" onclick="switchTab('fulltext'); return false;">Fulltext Info</a>
		<a id="extproptab" href="#" class="pagetab" onclick="switchTab('extprop'); return false;">Extended Properties</a>
	</div>
	</td></tr>
	<tr><td class="third" id="third">
		
	<div id="dsndiv" class="pagediv">
	<cfoutput><div class="stableh">CURRENT VALUES [#dateformat(now(),'mm/dd/yyyy')# #lcase(timeformat(now(),'hh:mm:ss tt'))#]</div></cfoutput>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
		<tr><td class="stableh" align=center>Item</td><td class="stableh" align=center>Detail</td><td class="stableh">Value</td></tr>
		<cfoutput>
		<tr><td width="30%">DB_NAME()</td><td width="30%">Currently selected database</td><td width="40%">#dbconfig.databaseName[1]#&nbsp;</td></tr>
		<cfloop from="1" to="#dbconfig.numValues#" index="c">
		<tr><td width="20%">#dbconfig["label#c#"][1]#</td><td width="40%">#dbconfig["text#c#"][1]#</td><td width="40%">#dbconfig["data#c#"][1]#&nbsp;</td></tr>
		</cfloop>
		</cfoutput>
	</table>
	<br><br>
	</div>	
		
	<div id="tablediv" class="pagediv">
	<cfoutput><div class="stableh">CURRENT VALUES [#dateformat(now(),'mm/dd/yyyy')# #lcase(timeformat(now(),'hh:mm:ss tt'))#]</div></cfoutput>
	<table border="0" cellpadding="0" cellspacing="1" class="stable" id="db-table-info">
		<thead>
		<tr><th width="2%">#</th><th>Table</th><th class="c" width="12%">Rows</th><th class="c" width="12%">Data</th><th class="c" width="12%">Indexes</th><th class="c" width="12%">Unused</th><th class="c" width="12%">Reserved</th></tr>
		</thead>
		<tbody>
		<cfscript>lc = 0; runRowtotal = 0; runData = 0; runReserved = 0; runIndexSize = 0; runUnused = 0; runThisRowTotal = 0; </cfscript>
		<cfif tablerowtotals.recordcount>
		<cfoutput query="tablerowtotals"><cfscript>lc = lc + 1; runRowtotal = runRowtotal + rowTotal; runData = runData + val(data); runReserved = runReserved + val(reserved); runIndexSize = runIndexSize + val(index_size); runUnused = runUnused + val(unused); runThisRowTotal = runThisRowTotal + val(reserved); </cfscript>
		<tr><td class="r">#lc#</td><td title="Table name">#tblName#</td><td class="r" title="Rowcount">#numberformat(rowTotal)#</td><td class="r" title="Data">#formatSize(val(data),"kb",formatSizeMode)#</td><td class="r" title="Index Size">#formatSize(val(index_size),"kb",formatSizeMode)#</td><td class="r" title="Unused">#formatSize(val(unused),"kb",formatSizeMode)#</td><td class="r" title="Total">#formatSize(val(reserved),"kb",formatSizeMode)#</td></tr>
		</cfoutput>
		</tbody>
		<cfoutput>
		<tr><td class="stableh" colspan="2">Totals</td><td class="stableh r" title="Rowcount">#numberformat(runrowTotal)#</td><td class="stableh r" title="Data">#formatSize(rundata,"kb",formatSizeMode)#</td><td class="stableh r" title="Index Size">#formatSize(runindexsize,"kb",formatSizeMode)#</td><td class="stableh r" title="Unused">#formatSize(rununused,"kb",formatSizeMode)#</td><td class="stableh r" title="Total">#formatSize(runThisRowTotal,"kb",formatSizeMode)#</td></tr></cfoutput>
		<cfelse>
		<tr><td colspan="8" class="c">No data to display</td></tr>
		</cfif>
	</table>
	<br><br>
	</div>	

	<div id="fulltextdiv" class="pagediv">
		<cfif fulltextconfig.recordcount>
	<cfoutput><div class="stableh">CURRENT VALUES [#dateformat(now(),'mm/dd/yyyy')# #lcase(timeformat(now(),'hh:mm:ss tt'))#]</div></cfoutput>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
		<tr>
			<td class="stableh">Catalog Name</td>
			<td class="stableh" align="center">Current Status</td>
			<td class="stableh" align="center"><a href="#" onclick="return false;" class="stableh" title="The number of full-text indexed items currently in this full-text catalog">Item Count</a></td>
			<td class="stableh" align="center"><a href="#" onclick="return false;" class="stableh" title="The size of this full-text index">Index Size</a></td>
			<td class="stableh" align="center"><a href="#" onclick="return false;" class="stableh" title="The number of unique words that make up the full text index in this catalog">Unique Key Count</a></td>
			<td class="stableh" align="center"><a href="#" onclick="return false;" class="stableh" title="The size of the combined set of error logs associated with this full-text catalog">Log Size</a></td>
			<td class="stableh" align="center"><a href="#" onclick="return false;" class="stableh" title="Time since the completion of the last full-text index population">Last Population</a></td>
		</tr>
		<cfoutput query="fulltextconfig">
		<tr>
			<td>#name#</td>
			<td>#populatestatus#&nbsp;</td>
			<td align="right">&nbsp;#itemcount#</td>
			<td align="right">&nbsp;#indexsize# MB</td>
			<td align="right">&nbsp;#uniquekeycount#</td>
			<td align="right"><cfif val(logsize)>[#decimalformat(evaluate(logsize / 1024))# MB]</cfif> #logsize# bytes</td>
			<td align="right">&nbsp;#secsToTime(val(agenow) - val(populatecompletionage))#</td>
		</tr>
		</cfoutput>	
		</table>
		<cfelse>
		<div class="stableh">No Fulltext Catalogs detected</div>
		</cfif>

	</div>	
		
	<div id="extpropdiv" class="pagediv">
	<cfoutput><div class="stableh">CURRENT VALUES [#dateformat(now(),'mm/dd/yyyy')# #lcase(timeformat(now(),'hh:mm:ss tt'))#]</div></cfoutput>
	<cfif getobject_extprops.recordcount>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<tr>
		<td class="stableh">NAME</td><td class="stableh">VALUE</td><td class="stableh">RETRIEVAL SQL</td>
	</tr>
	<cfoutput query="getobject_extprops">
	<tr>
		<td>#name#</td>
		<td>#value#</td>
		<td>SELECT value<br>FROM <cfif sqlServerVersion eq 2000>::</cfif>fn_listextendedproperty(null, null, null, null, null, null, null)<br>WHERE [name] = '#name#'</td>
	</tr>
	</cfoutput>
	</table>
	<cfelse>
	<div class="stableh">None</div>
	</cfif>
	</div>	
	
	</td></tr>
	</table>
	</body>
	</html>

</cfif>
<cfif not dbx.debugging>
	<cfsetting showdebugoutput="no">
</cfif>
<cfabort>