<cfif not dbx.guestmode>
<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
------------------------------------------------------------------ --->

<cfparam name="f" type="string" default="">
<cfparam name="url.oid" type="string" default="">
<cfparam name="type" type="string" default="table"><!--- table/view/procedure/function --->
	<cfif isdefined("url.v")>
		<cfset type = "view">
	<cfelseif isdefined("url.fn")>
		<cfset type="function">
	<cfelseif isdefined("url.sp")>
		<cfset type="procedure">
	</cfif>
<cfif type eq "table">
	<cfset tablename = url.oid>
<cfelseif type eq "view">
	<cfset tablename = url.oid>
<cfelseif type eq "procedure" or type eq "function">
	<cfset procname = url.oid>
</cfif>
<cfparam name="theobject" type="string" default="">
<cfif listlen(theobject,"`") eq 2>
	<cfif listgetat(theobject,1,"`") eq "co">
		<cfset theobject = listgetat(theobject,2,"`")>
	<cfelseif listgetat(theobject,1,"`") eq "ta">
		<cfset tablename = listgetat(theobject,2,"`")>
		<cfset theobject = "">
	<cfelseif listgetat(theobject,1,"`") eq "vi">
		<cfset tablename = listgetat(theobject,2,"`")>
		<cfset theobject = "">
	<cfelseif listgetat(theobject,1,"`") eq "pr">
		<cfset procname = listgetat(theobject,2,"`")>
		<cfset theobject = "">
	<cfelseif listgetat(theobject,1,"`") eq "fu">
		<cfset procname = listgetat(theobject,2,"`")>
		<cfset theobject = "">
	<cfelseif listgetat(theobject,1,"`") eq "pa">
		<cfset theobject = listgetat(theobject,2,"`")>
	</cfif>
</cfif>
<cfparam name="epName" type="string" default="#dbx.defaultExtPropName#">
<cfparam name="epValue" type="string" default="">
<cfif isdefined("url.dep")><!--- drop --->
	<cfset form.mode = "drop">
</cfif>

<cfset dbxr.message = "">

<cfif type eq "table" or type eq "view">
	<cftry>
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject">
			EXEC sp_columns '#trim(url.oid)#';
		</cfquery>
		<cfset theOwner = getobject.table_owner[1]>
		
		<cfcatch>
			<cfset getobject = querynew("nothing")>
			<cfset theOwner = "">
			<cfoutput><script>alert('Unable to get object data:\n\n#jsstringformat(cfcatch.message & chr(13) & chr(10) & cfcatch.detail)#');</script></cfoutput>
		</cfcatch>
	</cftry>

<cfelseif type eq "procedure" or type eq "function">
	<cftry>
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject">
				EXEC sp_sproc_columns '#trim(url.oid)#';
		</cfquery>
		<cfset theOwner = getobject.procedure_owner[1]>
	<cfcatch type="Any">
		<cfset getobject = querynew("nothing")>
		<cfset theOwner = "">
	</cfcatch>
	</cftry>
	
</cfif>

<cfsetting enablecfoutputonly = "no">

<cfif not len(f)><!--- frameset --->
<html>
	<head>
	<title>DBX - Extended Property Manager</title><cfoutput>
	<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>
	</head>
		<frameset cols="30%,*,0" framespacing="0" frameborder="0" border=0><cfoutput>
		    <frame src="#dbxr.fullfilepathprefix#?aep=1&f=t&oid=#urlencodedformat(url.oid)#&type=#type#" name="aeptop" id="aeptop" scrolling="no" marginwidth="0" marginheight="0" noresize>
		    <frame src="#dbxr.fullfilepathprefix#?aep=1&f=b&oid=#urlencodedformat(url.oid)#&type=#type#" name="aepbottom" id="aepbottom" scrolling="yes" marginwidth="0" marginheight="0">
			<frame src="about:blank" name="aepcontrol" id="aepcontrol" noresize scrolling="no" marginwidth="0" marginheight="0" border="0"></cfoutput>
		</frameset>
</html>

<cfelseif f eq "t"><!--- top area --->
	<html>
	<head>
		<title>Extended Property Manager</title><cfoutput>
		<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>
		<script>
			function validateListForm() {
				theform = document.form_ext;
				if(theform.theobject.selectedIndex > -1 && theform.theobject.options[theform.theobject.selectedIndex].value.length > 0) {
					return true;
				}
				else {
					alert('Please select a column from the list to continue.'); return false;
				}
			}
		</script>
	</head>
	<body class="inner" onload="parent.focus();">
	<table border="0" cellpadding="0" cellspacing="0" class="beveled">
	<tr><td height="20" class="beveled"><div class="tab"><cfoutput>#url.oid# [#type#]</cfoutput></div></td></tr>
	</table>
	
	<cfoutput><form action="#dbxr.fullfilepathprefix#?aep=1&f=b&do=1&oid=#urlencodedformat(url.oid)#" method="post" name="form_ext" id="form_ext" target="aepbottom" onsubmit="return validateListForm();"></cfoutput>
	<select name="theobject" size="50" class="aep" onclick="this.form.submit();">
	<cfoutput><option value="#left(type,2)#`#url.oid#">[#type#] #url.oid#</option></cfoutput>
	<cfif type eq "table" or type eq "view">
	<cfoutput query="getobject">
	<option value="co`#column_name#">&nbsp;&nbsp;&nbsp;[column] #column_name#</option>
	</cfoutput>
	<cfelse>
	<cfoutput query="getobject">
	<option value="pa`#column_name#">&nbsp;&nbsp;&nbsp;[parameter] #column_name#</option>
	</cfoutput>
	</cfif>
	</select>
	<cfoutput><input type="hidden" name="type" value="#type#"></cfoutput>

	</body>
</html>

<cfelseif f eq "b">
<cfsetting enablecfoutputonly="yes">

<cfif isdefined("form.mode")>
	<cfif type eq "table" or type eq "view">
	<cftry>
		<cfif form.mode eq "add">
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="addprop">
				EXEC sp_addextendedproperty '#epName#', '#epValue#', 'user', '#theOwner#', '#type#', '#trim(url.oid)#', <cfif len(theobject)>'column', '#theobject#'<cfelse>null, null</cfif>;
			</cfquery>
		
		<cfelseif form.mode eq "update">
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="updateprop">
				EXEC sp_updateextendedproperty '#epName#', '#epValue#', 'user', '#theOwner#', '#type#', '#trim(url.oid)#', <cfif len(theobject)>'column', '#theobject#'<cfelse>null, null</cfif>;
			</cfquery>
		
		<cfelseif form.mode eq "drop">
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="dropprop">
				EXEC sp_dropextendedproperty '#epName#','user', '#theOwner#', '#type#', '#trim(url.oid)#', <cfif len(theobject)>'column', '#theobject#'<cfelse>null, null</cfif>;
			</cfquery>
			
		</cfif>
		<cfcatch>
			<cfoutput><script>alert('Property operation unsucessful.  Note that some operations are not permitted on built in or automatic variables.  Other causes may be insufficient priveleges for the user account.\n\nThe specific error returned was:\n\n#jsstringformat(cfcatch.message & chr(13) & chr(10) & cfcatch.detail)#');</script></cfoutput>
		</cfcatch>
	</cftry>
	<cfelse>
		<cftry>
		<cfif form.mode eq "add">
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="addprop">
				EXEC sp_addextendedproperty '#epName#', '#epValue#', 'user', '#theOwner#', '#type#', '#trim(url.oid)#', <cfif len(theobject)>'parameter', '#theobject#'<cfelse>null, null</cfif>;
			</cfquery>
		
		<cfelseif form.mode eq "update">
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="updateprop">
				EXEC sp_updateextendedproperty '#epName#', '#epValue#', 'user', '#theOwner#', '#type#', '#trim(url.oid)#', <cfif len(theobject)>'parameter', '#theobject#'<cfelse>null, null</cfif>;
			</cfquery>
		
		<cfelseif form.mode eq "drop">
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="dropprop">
				EXEC sp_dropextendedproperty '#epName#','user', '#theOwner#', '#type#', '#trim(url.oid)#', <cfif len(theobject)>'parameter', '#theobject#'<cfelse>null, null</cfif>;
			</cfquery>
			
		</cfif>
		<cfcatch>
			<cfoutput><script>alert('Property operation unsucessful.  Note that some operations are not permitted on built in or automatic variables, such as RETURN_VALUE from stored procedures.  Other causes may be insufficient priveleges for the user account.\n\nThe specific error returned was:\n\n#jsstringformat(cfcatch.message & chr(13) & chr(10) & cfcatch.detail)#');</script></cfoutput>
		</cfcatch>
	</cftry>
	</cfif>
</cfif>

<cfif isdefined("url.do")>
	<cfif type eq "table" or type eq "view">
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="extprops">
			SELECT * FROM   ::fn_listextendedproperty (null, 'user', '#theOwner#', '#type#', '#trim(url.oid)#',<cfif len(theobject)>'column', '#theobject#'<cfelse>null, null</cfif>);
		</cfquery>
	<cfelse>
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="extprops">
			SELECT * FROM   ::fn_listextendedproperty (null, 'user', '#theOwner#', '#type#', '#trim(url.oid)#',<cfif len(theobject)>'parameter', '#theobject#'<cfelse>null, null</cfif>);
		</cfquery>
	</cfif>
</cfif>

<cfsetting enablecfoutputonly="no">
	<html>
	<head>
		<title>Extended Property Manager</title><cfoutput>
		<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>
		<script>
			function editProp( epname, value) {
				document.form_extp.epName.value = epname;
				document.form_extp.epValue.value = value;
				document.form_extp.epBtn.value = 'Edit Property';
				document.form_extp.mode.value='update';
				document.getElementById('addedit').innerHTML = 'EDIT';
				document.form_extp.epValue.focus();
			}
			function resetForm() {
				document.form_extp.epBtn.value = 'Add Property';
				document.getElementById('addedit').innerHTML = 'ADD';
				document.form_extp.reset();
			}
			function dropProp( epname,theobject ) {
				var okDrop = confirm('Are you sure you want to drop this extended property?');
				if(!okDrop) { return false; }<cfoutput>
				else { location.href='#dbxr.fullfilepathprefix#?aep=1&f=b&do=1&type=#type#&dep=1&oid=#urlencodedformat(url.oid)#&epname=' + epname + '&theobject=' + theobject; }			</cfoutput>
			}
		</script>
	</head>
	<body class="inner"<cfif isdefined("url.do") and (len(theobject) or isdefined("tablename") or isdefined("procname"))> onload="document.getElementById('epValue').focus();"</cfif>>
	<table border="0" cellpadding="0" cellspacing="0" class="beveled">
	<tr><td height="20" class="beveled"><div class="tab">EXTENDED PROPERTY MANAGER</div></td></tr>
	</table>
	<br>
	<cfif isdefined("url.do")>
	<cfif len(theobject) or isdefined("tablename") or isdefined("procname")>
	<table border="0" cellpadding="3" cellspacing="0" width="90%" align="center">
	<cfoutput><form action="#dbxr.fullfilepathprefix#?aep=1&f=b&do=1&oid=#urlencodedformat(url.oid)#" method="post" name="form_extp" id="form_extp" target="aepbottom"></cfoutput>
	<tr><td colspan="2" class="beveled"><span id="addedit">ADD</span> EXTENDED PROPERTY - <cfoutput>#url.oid#<cfif len(theobject)>.#theobject#</cfif></cfoutput></td></tr>
	<tr><td width="10%">Name:</td><td><input type="text" style="width: 100%;" name="epName" id="epName" value="<cfif not isdefined("form.epName")><cfoutput>#epName#</cfoutput></cfif>"></td></tr>
	<tr><td width="10%">Value:</td><td><input type="text" style="width: 100%;" name="epValue" id="epValue" value=""></td></tr>
	<tr><td colspan="2" align="center"><cfoutput><input type="hidden" name="type" value="#type#"><input type="hidden" name="theobject" value="#theobject#"></cfoutput><input type="hidden" name="mode" value="add"><input type="submit" value="Add Property" name="epBtn" class="button">&nbsp;<input type="button" value="Cancel" onclick="resetForm();" class="button"></td></tr>
	</form>
	</table>
	<!--- <cfif len(theobject) or isdefined("tablename) or len(procname)> --->
	<br><br>
		<cfif extprops.recordcount>
		<table border="0" cellpadding="2" cellspacing="0" class="beveledleft" width="90%" align="center">
		<tr><td class="beveled" colspan="3">CURRENT EXTENDED PROPERTIES - <cfoutput>#trim(url.oid)#<cfif len(theobject)>.#theobject#</cfif></cfoutput></td></tr>
		<tr>
			<td class="header2" width="30%">NAME</td><td class="header2" width="50%">VALUE</td><td class="header2" width="20%" align="center">ACTION</td>
		</tr>
		<cfoutput query="extprops">
		<tr>
			<td class="td3" valign="top"><a href="##" onclick="editProp('#name#','#value#');">#name#</a></td>
			<td class="td3" valign="top">#value#</td>
			<td class="td3" valign="top" align="center" nowrap><a href="##" onclick="editProp('#name#','#value#');">edit</a> | <a href="##" onclick="dropProp('#name#','#theobject#');">drop</a></td>
		</tr>
		</cfoutput>
		</table>
		</cfif>
	<!--- </cfif> --->
	</cfif>
	<cfelse>
	<div align="center"><br><br>Please select an object from the list to begin</div>
	</cfif>
	</body>
	</html>
</cfif>

</cfif>
<cfif not dbx.debugging>
	<cfsetting showdebugoutput="no">
</cfif>
<cfabort>
