<cfsetting enablecfoutputonly = "yes">

		<!--- we need this to set the db back to the default dsn db after querying master objects --->
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="defaultdb">
			SELECT DB_NAME() AS name;
		</cfquery>
		
		<!--- verify version --->
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="ver">
			SELECT ServerProperty('ProductVersion') AS theVersion
		</cfquery>
		
		<!--- parse the version --->
		<cfset sqlServerVersion = "0">
		<cfset tempVersion = listfirst(ver.theVersion,".")>
		<cfif val(tempVersion) gte 11>
			<cfset sqlServerVersion = "2012">
		<cfelseif tempVersion eq "10">
			<cfset sqlServerVersion = "2008">
		<cfelseif tempVersion eq "9">
			<cfset sqlServerVersion = "2005">
		<cfelseif tempVersion eq "8">
			<cfset sqlServerVersion = "2000"> 
		</cfif> 

<cfsetting enablecfoutputonly = "no">