<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
		9.0.2 - 12/11/2006 - Kevin Miller - added @ prefix for dbvarname attributes
------------------------------------------------------------------ --->

<cfsetting enablecfoutputonly = "no">

<cfif url.sg eq 1>

<cfif isdefined("url.dsp")><!--- delete the stored proc --->
	<cftry>
		<cfquery name="deleteSP" datasource="#dbdsn#" username="#dbuser#" password="#dbpass#">
			DROP PROCEDURE dbx_generate_script;
		</cfquery>
		<cfoutput>
		<script>
			parent.list.location.reload(true);
		</script>
		</cfoutput>
		
		<cfcatch>
			<cfif not isdefined("url.subframe") or url.subframe eq "top">
				<cfhtmlhead text="<script>APP.writeErrors('Unable to delete proc: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
			</cfif>
		</cfcatch>
	</cftry>
</cfif>

<cfif isdefined("url.msp")><!--- make the stored proc now --->
	<cftry>
	
		<!--- generating the script here --->
		<cfquery name="createSP" datasource="#dbdsn#" username="#dbuser#" password="#dbpass#">
		<cfinclude template="i_scriptgenerator_script.sql">
		</cfquery>
		<cfoutput>
		<script>
			parent.list.location.reload(true);
		</script>
		</cfoutput>
		
		<cfcatch>
			<cfif not isdefined("url.subframe") or url.subframe eq "top">
				<cfhtmlhead text="<script>APP.writeErrors('Unable to create proc: #jsstringformat(cfcatch.message & chr(10) & cfcatch.detail)#');</script>">
			</cfif>
		</cfcatch>
	</cftry>
</cfif>

<!--- see if the sp exists already within the db --->
<cfstoredproc procedure="sp_stored_procedures" datasource="#dbdsn#" username="#dbuser#" password="#dbpass#">
	<cfprocparam type="IN" cfsqltype="CF_SQL_VARCHAR" dbvarname="@sp_name" value="dbx_generate_script" null="No">
	<cfprocresult name="checkGenScript" resultset="1">
</cfstoredproc> 	


	<cfparam name="SQLDMOScript_OwnerQualify" type="numeric" default=262144>
	<cfparam name="SQLDMOScript_Default" type="numeric" default=4>
	<cfparam name="SQLDMOScript_Triggers" type="numeric" default=16>
	<cfparam name="SQLDMOScript_Bindings" type="numeric" default=128>
	<cfparam name="SQLDMOScript_DatabasePermissions" type="numeric" default=32>
	<cfparam name="SQLDMOScript_Permissions" type="numeric" default=34>
	<cfparam name="SQLDMOScript_ObjectPermissions" type="numeric" default=2>
	<cfparam name="SQLDMOScript_ClusteredIndexes" type="numeric" default=8>
	<cfparam name="SQLDMOScript_Indexes" type="numeric" default=73736>
	<cfparam name="SQLDMOScript_Aliases" type="numeric" default=16384>
	<cfparam name="SQLDMOScript_DRI_All" type="numeric" default=532676608>
	<cfparam name="SQLDMOScript_IncludeHeaders" type="numeric" default=131072>
		
	<cfif checkGenScript.recordcount>
			<!--- need to add support for triggers and functions 12/11/2003 --->
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="scriptableObjects">
				SELECT 	ltrim(rtrim(s.name)) as name, 
					ltrim(rtrim(s.type)) as type, 
					strType = CASE ltrim(rtrim(s.type)) 
						WHEN 'FN' THEN 'Functions' 
						WHEN 'TF' THEN 'Functions' 
						WHEN 'IF' THEN 'Functions' 
						WHEN 'P' THEN 'Procedures' 
						WHEN 'U' THEN 'Tables' 
						WHEN 'V' THEN 'Views' 
						WHEN 'TR' THEN 'Triggers' 
					ELSE 'Other' END, 
					dOrder = CASE ltrim(rtrim(s.type)) 
						WHEN 'FN' THEN 4  
						WHEN 'TF' THEN 4 
						WHEN 'P' THEN 3  
						WHEN 'U' THEN 1  
						WHEN 'V' THEN 2 
						WHEN 'TR' THEN 5 
					ELSE 99 END, 
					ltrim(rtrim(s.status)) as status, 
					ltrim(rtrim(su.name)) AS owner 
				FROM sysobjects s INNER JOIN sysusers su ON s.uid = su.uid 
				WHERE ltrim(rtrim(s.status)) >= 0 AND type IN ('P','U','V','TR'<!--- ,'FN','TF','IF' --->) <!--- removed functions from listing --->
				ORDER BY dOrder, name
			</cfquery>
	</cfif>
		
<cfsetting enablecfoutputonly="no">
<html>
<head>
	<title>DBX</title><cfoutput>
	<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>
	<script>
		APP = top; 
		
		function okContinue() {
		okc = confirm('Create the user procedure dbx_generate_script in the current database now?\n\nThis only creates the stored procedure itself, it does not execute it in anyway.  Usage of the routine still requires you to enter appropriate username and password information when prompted.\n\nClick OK to continue.');
		if(!okc) { return false; }
		else { return true; }
		}
		
		function okDelete() {
		okd = confirm('Delete the user procedure dbx_generate_script in the current database now?\n\nThis will remove the previously created stored procedure from the current database.\n\nClick OK to delete the procedure and continue.');
		if(!okd) { return false; }
		else { return true; }
		}
		
		function validateForm() {
			if(document.forms[0].scriptObject.options[document.forms[0].scriptObject.selectedIndex].value.length == 0) {
				alert('You must select which object to script.  Choose Script All Objects to script the entire database.');
				document.forms[0].scriptObject.options[0].selected = true;
				document.forms[0].scriptObject.focus();
				return false; 
			}
		}
		
		function enableForAll() { 
			with (document.forms[0]) {
				SQLDMOScript_OwnerQualify.disabled = false;
				scriptUsers.disabled = false;
				scriptLogins.disabled = false;
				SQLDMOScript_DatabasePermissions.disabled = false;
				SQLDMOScript_Permissions.disabled = false;
				SQLDMOScript_ObjectPermissions.disabled = false;
			}
		}
		
		function disableForObject() { 
			with (document.forms[0]) {
				SQLDMOScript_OwnerQualify.disabled = true;
				scriptUsers.disabled = true;
				scriptLogins.disabled = true;
				SQLDMOScript_DatabasePermissions.disabled = true;
				SQLDMOScript_Permissions.disabled = true;
				SQLDMOScript_ObjectPermissions.disabled = true;
			}
		}
		
		function handleOptions() {
			if(document.forms[0].scriptObject.options[document.forms[0].scriptObject.selectedIndex].value == 'scriptAllObjects') {
				enableForAll();
			}
			else {
				disableForObject();
			}
		}

			// page tabs
			var proftabs = new Array('gen');
			var activetab = 'gen'; 
			
			function switchTab(which) { 
				var which = (which != null) ? which : activetab; 
				
				for(var i=0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div') /* && document.getElementById(proftabs[i] + 'tab') */) { 
						if(proftabs[i] == which) { 
							document.getElementById(proftabs[i] + 'div').className = 'pagedivon'; 
							// document.getElementById(proftabs[i] + 'tab').className = 'pagetab on';
							activetab = which; 
						}
						else { 
							document.getElementById(proftabs[i] + 'div').className = 'pagediv'; 
							// document.getElementById(proftabs[i] + 'tab').className = 'pagetab';		
						}
					}
				}
			}
	
			function setDivScrollers() { 
				var thirdheight = document.getElementById('third').offsetHeight; 
				for(var i = 0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div')) { 
							document.getElementById(proftabs[i] + 'div').style.height = thirdheight; 
					}
				}
			}
	
			function doresize() { 
				for(var i = 0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div')) { 
						document.getElementById(proftabs[i] + 'div').style.height = '1px'; 
					}
				}
				setDivScrollers(); 
				switchTab(activetab); 
			}
			onresize = doresize;
	</script>
</head>

<body onload="setDivScrollers(); switchTab(activetab);">

<table id="sourcelayout" border="0" cellpadding="0" cellspacing="0">
<tr><td class="first">
	<table border="0" cellspacing="0" class="navbar2">
	<tr><td><div class="tab">Script Generator</div></td></tr>
	</table>
</td>
</tr>
<tr><td class="third" id="third">
<div id="gendiv" class="pagediv">

	<cfif checkGenScript.recordcount><!--- sp has already been installed --->
	<table border="0" cellpadding="0" cellspacing="0" align="center">
	<tr><td>
	<span class="heavy">Script Generator Usage:</span><br>
	Enter in a username and password with sufficient permissions to execute the script properly (I haven't tested the full spectrum of what constitutes a valid permission set - but I believe that members of the fixed sysadmin role or dbo are required due to the types of objects being used here).<br><br>
	You may choose to script the entire database (Script All Objects) or a single object you select.  There is currently no method for selecting multiple objects.<br><br>
	<span class="heavy">Note:</span> From what I have seen, User Defined Functions *ARE* scripted when selecting All Objects, however I have not found a way to allow scripting a single UDF from this routine reliably (and are therefore not shown in the object listing below).  To script a single function, you can always view the function's schema in detail view.<br><br>
	Select your scripting options on the right, and click the button.  The generated script will appear in a new window, from which you can print or save the result.<br><br>
	</td></tr>
	</table>
	
	<table border="0" cellpadding="10" cellspacing="0" align="center">
	<tr><td valign="top" colspan="2">
	<table border="0" cellpadding="3" cellspacing="0">
	<tr><td colspan="4"><span class="heavy">Enter Login Information:</span></td></tr>
	<cfoutput><form action="#dbxr.fullfilepathprefix#?frame=detail&sg=2" method="post" target="script_results" onsubmit="return validateForm();"></cfoutput>
	<tr><td>Username:</td><td><cfoutput><input type="text" name="spusername" value="#dbuser#"></td><td>Password:</td><td><input type="password" name="sppassword" value="#dbpass#"></cfoutput></td></tr>
	</table>
	</td></tr>
	<tr><td valign="top">
	<table border="0" cellpadding="3" cellspacing="0">
	<tr><td colspan="2"><span class="heavy">Object to Script:</span></td></tr>
	<tr><td colspan="2" align="center"><select name="scriptObject" size="10" onchange="handleOptions();"><option value="scriptAllObjects" selected>-- Script All Objects --</option><cfoutput query="scriptableObjects" group="strType"><option value=""></option><option value="">#strType#</option><!--- <option value="">#repeatstring("-",40)#</option> ---><cfoutput><option value="#owner#.#name#">&nbsp;-&nbsp;&nbsp;#owner#.#name#</option></cfoutput></cfoutput></select></td></tr>
	</table>
	</td><td valign="top">
	<table border="0" cellpadding="3" cellspacing="0">
	<tr><td colspan="2"><span class="heavy">Scripting Options:</span></td></tr>
	<tr><td><label for="a1">Qualify Owner:</label></td><td><input type="checkbox" id="a1" name="SQLDMOScript_OwnerQualify" value="262144"></td></tr>
	<tr><td><label for="a2">Script Users:</label></td><td><input type="checkbox" id="a2" name="scriptUsers" value="true"></td></tr>
	<tr><td><label for="a3">Script Logins:</label></td><td><input type="checkbox" id="a3" name="scriptLogins" value="true"></td></tr>
	<tr><td><label for="a4">Script DB Permissions:</label></td><td><input type="checkbox" id="a4" name="SQLDMOScript_DatabasePermissions" value="32"></td></tr>
	<tr><td><label for="a5">Script Permissions:</label></td><td><input type="checkbox" id="a5" name="SQLDMOScript_Permissions" value="34"></td></tr>
	<tr><td><label for="a6">Script Object Permissions:</label></td><td><input type="checkbox" id="a6" name="SQLDMOScript_ObjectPermissions" value="2"></td></tr>
	</table>
	</td>
	<td valign="top">
	<table border="0" cellpadding="3" cellspacing="0">
	<tr><td colspan="2"><br></td></tr>
	<tr><td><label for="a7">Script Triggers:</label></td><td><input type="checkbox" id="a7" name="SQLDMOScript_Triggers" value="16" checked></td></tr>
	<tr><td><label for="a8">Script Clustered Indexes:</label></td><td><input type="checkbox" id="a8" name="SQLDMOScript_ClusteredIndexes" value="8" checked></td></tr>
	<tr><td><label for="a9">Script Indexes:</label></td><td><input type="checkbox" id="a9" name="SQLDMOScript_Indexes" value="73736" checked></td></tr>
	<tr><td><label for="a10">Script Aliases:</label></td><td><input type="checkbox" id="a10" name="SQLDMOScript_Aliases" value="16384" checked></td></tr>
	<tr><td><label for="a11">Include Descriptive Headers:</label></td><td><input type="checkbox" id="a11" name="SQLDMOScript_IncludeHeaders" value="131072"></td></tr>
	</table>
	</td></tr>
	<tr><td colspan="3" align="center"><input type="hidden" name="SQLDMOScript_Default" value="4"><input type="hidden" name="SQLDMOScript_Bindings" value="128"><input type="hidden" name="SQLDMOScript_DRI_All" value="532676608">
	<input type="submit" name="genScriptBTN" value=" GENERATE SQL SCRIPT " class="button">
	</td></tr>
	</form>
	</table>
	<br>	
	<hr size="1" width="100%" align="center">
	<br>
	</cfif>
<div class="haze">
	<span class="heavy">Author's Note</span><br>
	Script Generator is <span class="heavy">Experimental</span>, and should be used at your own risk.  It is the only invasive (yet optional) feature in DBX (it creates a stored proc in the target database), and while I would have preferred to keep the app completely non-invasive, using only commonly available catalog procedures, the feature had been requested and I've been wanting something like this for myself for a long while.<br><br>
<span class="heavy">Background</span><br>
	The Script Generator is an idea I had been toying with since version 1 of the app.  If DBX was going to show the type of information it could, then why couldn't it also be used to generate a sql script similar to the Generate SQL Script functionality found in Enterprise Manager?  The idea was hardly novel, I had come across a t-sql stored procedure about three years ago that could do just that, and I even attempted to integrate it into DBX around version 2, but it just never really fit well.<br><br>
Well, here is the most recent incarnation, and while its not as super streamlined as I'd like it to be, it does the job pretty well.  It is a hack of the same stored proc code I had seen way back when, in Ken Henderson's Guru's Guide to Transact SQL (for MSSQL 7).  If it doesn't work (it *does* work), I'm to blame, not him, since I've removed some error checking and other things that didn't fit into DBX's 'one template app' or 'non-invasive db descriptor' approach.  I had always striven to keep DBX from *relying* on non standard routines, and to that extent it still does, but this feature pretty much requires it and it is up to you as the user to decide whether you want to use it.<br><br>
Using Ken's stored proc as the basis for the routine, DBX creates a stored proc in the target database with the name 'dbx_generate_script'.  It is a user proc (Ken's original was intended as a system proc), and doesn't really represent too much of a security hazard since it will NOT work if the username and password credentials provided do not have the necessary permissions to do so.  It does NOT use the username/password you may have used for the datasource creation in CF or the code generator defaults; it requires you to enter the information each time you run it.<br><br>
<cfif not checkGenScript.recordcount><!--- still need to create the proc --->
<span class="heavy">Setup</span><br>
So, all of this having been said, it has already been determined that the current database does not contain the dbx_generate_script stored procedure.  You may create it by clicking the button below.  Should you want to see the source of the proc before doing so, just view the source of this template.
	<div align="center"><br>
	<cfoutput><form action="#dbxr.fullfilepathprefix#?frame=detail&sg=1&msp=1" method="post" onSubmit="return okContinue();"></cfoutput>
	<input type="submit" value=" CREATE dbx_generate_script PROCEDURE NOW " class="button">
	</form>
	</div>
	<cfelse><!--- let them delete it --->
<span class="heavy">Remove the dbx_generate_script Procedure</span><br>
OK, so you're a bit skittish, or just flat out too anal retentive for all this web based db interaction stuff.  Go ahead and delete the stored proc we created before by clicking the button below.  It's ok, you can always create it again later.
	<div align="center"><br>
	<cfoutput><form action="#dbxr.fullfilepathprefix#?frame=detail&sg=1&dsp=1" method="post" onSubmit="return okDelete();"></cfoutput>
	<input type="submit" value=" DELETE dbx_generate_script PROCEDURE NOW " class="button">
	</form>
	</div>
	</cfif>
</div></div>
</td></tr>
</table>
</body>
</html>
<cfelse>

<cfparam name="spusername" type="string" default="">
<cfparam name="sppassword" type="string" default="">

<cfif not len(spusername) and len(dbuser)>
	<cfset spusername = dbuser>
</cfif>
<cfif not len(sppassword) and len(dbpass)>
	<cfset sppassword = dbpass>
</cfif>

<cfparam name="dbobject" type="string" default="">
<cfif len(form.scriptObject) and form.scriptObject neq "scriptAllObjects">
	<cfset dbobject = form.scriptObject>
</cfif>
<cfparam name="SQLDMOScript_OwnerQualify" type="numeric" default=0>
<cfparam name="SQLDMOScript_Default" type="numeric" default=0>
<cfparam name="SQLDMOScript_Triggers" type="numeric" default=0>
<cfparam name="SQLDMOScript_Bindings" type="numeric" default=0>
<cfparam name="SQLDMOScript_DatabasePermissions" type="numeric" default=0>
<cfparam name="SQLDMOScript_Permissions" type="numeric" default=0>
<cfparam name="SQLDMOScript_ObjectPermissions" type="numeric" default=0>
<cfparam name="SQLDMOScript_ClusteredIndexes" type="numeric" default=0>
<cfparam name="SQLDMOScript_Indexes" type="numeric" default=0>
<cfparam name="SQLDMOScript_Aliases" type="numeric" default=0>
<cfparam name="SQLDMOScript_DRI_All" type="numeric" default=0>
<cfparam name="SQLDMOScript_IncludeHeaders" type="numeric" default=0>

<!--- calc the bitmap for scriptoptions --->
<cfset scriptoptions = bitor(bitor(bitor(bitor(bitor(bitor(bitor(bitor(bitor(bitor(bitor(SQLDMOScript_OwnerQualify,SQLDMOScript_Default),SQLDMOScript_Triggers),SQLDMOScript_Bindings),SQLDMOScript_DatabasePermissions),SQLDMOScript_Permissions),SQLDMOScript_ObjectPermissions),SQLDMOScript_ClusteredIndexes),SQLDMOScript_Indexes),SQLDMOScript_Aliases),SQLDMOScript_DRI_All),SQLDMOScript_IncludeHeaders)>

<cftry>
	<cfset result = querynew("line")>

	<cfstoredproc datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" procedure="dbx_generate_script">
		<cfprocparam type="IN" cfsqltype="CF_SQL_VARCHAR" dbvarname="@objectname" value="#dbobject#" null="#iif(len(dbobject),de("No"),de("Yes"))#">
		<cfprocparam type="IN" cfsqltype="CF_SQL_VARCHAR" dbvarname="@outputname" value="" null="Yes">
		<cfprocparam type="IN" cfsqltype="CF_SQL_INTEGER" dbvarname="@scriptoptions" value="#scriptoptions#" null="No">
		<cfprocparam type="IN" cfsqltype="CF_SQL_VARCHAR" dbvarname="@resultset" value="YES" null="No">
		<cfprocparam type="IN" cfsqltype="CF_SQL_VARCHAR" dbvarname="@server" value="(local)" null="No">
		<cfprocparam type="IN" cfsqltype="CF_SQL_VARCHAR" dbvarname="@username" value="#spusername#" null="No">
		<cfprocparam type="IN" cfsqltype="CF_SQL_VARCHAR" dbvarname="@password" value="#sppassword#" null="No">
		<cfprocparam type="IN" cfsqltype="CF_SQL_BIT" dbvarname="@scriptUsers" value="#iif(isdefined("form.scriptUsers"),1,0)#" null="No">
		<cfprocparam type="IN" cfsqltype="CF_SQL_BIT" dbvarname="@scriptLogins" value="#iif(isdefined("form.scriptLogins"),1,0)#" null="No">
		<cfprocresult name="result" resultset="2">
	</cfstoredproc>
	


<cfsavecontent variable="form.code">
<cfoutput query="result">
#line##chr(10)#
</cfoutput>
</cfsavecontent>
<cfset form.itemname = "Script Generator Result">

<cfinclude template="../core/i_codeview.cfm">
	
	<cfcatch>
		</pre>
		<div align="center">Process unsuccessful.  May be a permissions problem [check and see under which account the dbx_generate_proc procedure was created].<br>Please check the username and password provided and try again.<br><br>Specific Error Reported:<br><div style="border: 1px solid black; width: 100%; padding: 10px;"><cfoutput>#cfcatch.message#<br><br>#cfcatch.detail#</cfoutput></div><br><a href="#" onclick="self.close(); return false;">Close</a></div>
	</cfcatch>
</cftry>

</cfif>
<cfif not dbx.debugging>
	<cfsetting showdebugoutput="no">
</cfif>
