<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
		9.0.3 - 1/3/2006 - Kevin Miller - added triggers to scope and changed default to all items
------------------------------------------------------------------ --->

<cfinclude template="../core/udf/udf_formatObjectLink.cfm">
<cfparam name="ss" type="string" default="">

<cfsetting enablecfoutputonly = "no">

<cfif not isdefined("form.ss")><!--- not searching, show options page --->
<html>
<head>
	<title>DBX</title><cfoutput>
	<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>

	<script>
		function validateForm() {
			errors = "";
			with(document.search_form) {
				if(!ss.value.length) {
					errors += 'Please enter a string upon which to search.\n';
				}
				itsOK = false;
				for (i = 0; i < inclObjects.length; i++ ) {
					if(inclObjects[i].checked) {
						itsOK = true;
						break;
					}
				}
				for (i = 0; i < inclOtherObjects.length; i++ ) {
					if(inclOtherObjects[i].checked) {
						itsOK = true;
						break;
					}
				}
				if(!itsOK) {
					errors += 'Please select at least one object scope within which to search.\n';
				}
			}
			if(errors.length) {
				alert(errors);
				document.search_form.ss.focus();
				return false;
			}
			else {
				return true; 
			}
		}
		
		function load() {
			setTimeout('document.search_form.ss.focus()',200);
		} 

			// page tabs
			var proftabs = new Array('search');
			var activetab = 'search'; 
			
			function switchTab(which) { 
				var which = (which != null) ? which : activetab; 
				
				for(var i=0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div') /* && document.getElementById(proftabs[i] + 'tab') */) { 
						if(proftabs[i] == which) { 
							document.getElementById(proftabs[i] + 'div').className = 'pagedivon'; 
							// document.getElementById(proftabs[i] + 'tab').className = 'pagetab on';
							activetab = which; 
						}
						else { 
							document.getElementById(proftabs[i] + 'div').className = 'pagediv'; 
							// document.getElementById(proftabs[i] + 'tab').className = 'pagetab';		
						}
					}
				}
			}
	
			function setDivScrollers() { 
				var thirdheight = document.getElementById('third').offsetHeight; 
				for(var i = 0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div')) { 
							document.getElementById(proftabs[i] + 'div').style.height = thirdheight; 
					}
				}
			}
	
			function doresize() { 
				for(var i = 0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div')) { 
						document.getElementById(proftabs[i] + 'div').style.height = '1px'; 
					}
				}
				setDivScrollers(); 
				switchTab(activetab); 
			}
			onresize = doresize;
	</script>
</head>

<body onload="setDivScrollers(); switchTab(activetab);load(); ">

<table id="sourcelayout" border="0" cellpadding="0" cellspacing="0">
<tr><td class="first">
	<table border="0" cellspacing="0" class="navbar2">
	<tr><td><div class="tab">Object Search</div></td></tr>
	</table>
</td>
</tr>
<tr><td class="third" id="third">
<div id="searchdiv" class="pagediv">

<table border="0" cellpadding="3" cellspacing="0" align="center" width="100%">
<tr><td colspan="2"><div class="stitle">Search DB Objects for String</div></td></tr>
<tr><td colspan="2"><p>
Search Objects for String allows you to search selected types of database objects for a given string.  Select or de-select the types of objects you wish to search below.  The scope of the search is as follows:
<ul>
<li><span class="heavy">Tables</span>: column names</li>
<li><span class="heavy">Views</span>: column names</li>
<li><span class="heavy">Stored Procedures</span>: entire schema</li>
<li><span class="heavy">User Defined Functions</span>: entire schema</li>
<li><span class="heavy">Triggers</span>: entire schema</li>
</ul>
<br>
Note that the search uses simple string matching via the LIKE predicate, specifically: '%searchterm%', so phrase your search term accordingly.
</p>
</td></tr>
</table>
<table border="0" cellpadding="3" cellspacing="0" align="center">
<cfoutput><form action="#dbxr.fullfilepathprefix#?search=1" name="search_form" method="post" target="searchResults" onsubmit="return validateForm();"></cfoutput>
<tr><td><br><span class="heavy">Search For:</span></td><td width="10">&nbsp;</td><td><br><span class="heavy">Objects to Include in Search Scope:</span></td></tr>
<tr>
<td valign="top">
&nbsp;&nbsp;<cfoutput><input type="text" size="50" name="ss" value="#ss#"></cfoutput><div align="center"><input type="checkbox" id="a1" name="showVerbose" value="1"><label for="a1">Verbose Results (shows detailed hits in schema)</label><br><br><input type="submit" value=" SEARCH NOW " class="button"></div>
</td>
<td width="10">&nbsp;</td>
<td valign="top">
<table border="0" cellpadding="3" cellspacing="0">
<tr><td><label for="a2">User Tables:</label></td><td><input type="checkbox" id="a2" name="inclObjects" value="U" checked></td></tr>
<tr><td><label for="a3">User Views:</label></td><td><input type="checkbox" id="a3" name="inclObjects" value="V" checked></td></tr>
<tr><td><label for="a4">User Procedures:</label></td><td><input type="checkbox" id="a4" name="inclOtherObjects" value="P" checked></td></tr>
<tr><td><label for="a5">User Functions:</label></td><td><input type="checkbox" id="a5" name="inclOtherObjects" value="FN" checked></td></tr>
<tr><td><label for="a6">Triggers:</label></td><td><input type="checkbox" id="a6" name="inclOtherObjects" value="TR" checked></td></tr>
</table>
</td></tr>
</form>
</table>
</div>
</td></tr>
</table>
</body>
</html>
<cfelse><!--- generating report --->

<cfparam name="form.inclObjects" type="string" default="">
<cfparam name="form.inclOtherObjects" type="string" default="">
<cfset theTextList = "">

<cfif listlen(form.inclObjects)>
	<cfif listfindnocase(form.inclObjects,"U")>
		<cfset theTextList = listappend(theTextList," User Tables")>
	</cfif>
	<cfif listfindnocase(form.inclObjects,"V")>
		<cfset theTextList = listappend(theTextList," User Views")>
	</cfif>
	<cfset form.inclObjects = listqualify(form.inclObjects,"'",",","all")>
</cfif>

<cfif listlen(form.inclOtherObjects)>
	<cfif listfindnocase(form.inclOtherObjects,"P")>
		<cfset theTextList = listappend(theTextList," User Procedures")>
	</cfif>
	<cfif listfindnocase(form.inclOtherObjects,"FN")>
		<cfset theTextList = listappend(theTextList," User Functions")>
	</cfif>
	<cfif listfindnocase(form.inclOtherObjects,"TR")>
		<cfset theTextList = listappend(theTextList," Triggers")>
	</cfif>
	<cfset form.inclOtherObjects = listqualify(form.inclOtherObjects,"'",",","all")>
</cfif>
	
	<cfif listlen(form.inclObjects) or listlen(form.inclOtherObjects)>
		<!--- much better routine 5/10/2003 --->
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="search">
			<cfif listlen(form.inclObjects)>
			SELECT 
				OBJECT_ORDER = (CASE o.type WHEN 'U' THEN 1 WHEN 'V' THEN 2 WHEN 'P' THEN 3 WHEN 'FN' THEN 4 WHEN 'TR' THEN 5 ELSE 6 END), 
				OBJECT_TYPE = (CASE o.type WHEN 'U' THEN 'table' WHEN 'V' THEN 'view' WHEN 'P' THEN 'procedure' WHEN 'FN' THEN 'function' WHEN 'TR' THEN 'trigger' ELSE 'unknown' END), 
				TABLE_OWNER = convert(sysname,USER_Name(o.uid)),
				TABLE_NAME = convert(sysname,o.name),
				COLUMN_NAME = convert(sysname,c.name) + ' (column)', 
				PARENT_OBJ = NULL 
			FROM 
				sysobjects o INNER JOIN syscolumns c ON o.id = c.id 
			WHERE o.type IN (#preservesinglequotes(form.inclObjects)#) AND o.status >= 0 
				AND convert(sysname,c.name) LIKE '%#form.ss#%' 
			<cfif listlen(form.inclOtherObjects)>
			UNION 
			</cfif>	
			</cfif>
			<cfif listlen(form.inclOtherObjects)>
			SELECT 
				OBJECT_ORDER = (CASE o.type WHEN 'U' THEN 1 WHEN 'V' THEN 2 WHEN 'P' THEN 3 WHEN 'FN' THEN 4 WHEN 'TR' THEN 5 ELSE 6 END), 
				OBJECT_TYPE = (CASE o.type WHEN 'U' THEN 'table' WHEN 'V' THEN 'view' WHEN 'P' THEN 'procedure' WHEN 'FN' THEN 'function' WHEN 'TR' THEN 'trigger' ELSE 'unknown' END), 
				TABLE_OWNER = convert(sysname,USER_Name(o.uid)),
				TABLE_NAME = convert(sysname,o.name),
				COLUMN_NAME = c.text, 
				PARENT_OBJ = object_name(o.parent_obj) 
			FROM 
				sysobjects o INNER JOIN syscomments c ON o.id = c.id 
			WHERE o.type IN (#preservesinglequotes(form.inclOtherObjects)#) AND o.status >= 0 
				AND c.text LIKE '%#form.ss#%' 
			</cfif>
			ORDER BY 1,4,5 		
		</cfquery>
	<cfelse>
	<cfoutput><script>self.close();</script></cfoutput>
	<cfabort>
	</cfif>
	
	<!--- prep the regular expression --->
	<cfset regex = rereplace(ss,'[ ]+',' ','all')>
	<cfset regex = replace(ss," ","|","all")>
	
	<!--- prep the results display --->
	<cfset resultsText = "">
	<cfif search.recordcount>
		<cfset numObjects = 0><cfset numHits = 0>
		<cfoutput query="search" group="table_name">
			<cfset numObjects = numObjects + 1>
			<cfoutput>
				<cfset numHits = numHits + 1>
			</cfoutput>
		</cfoutput>
		<cfset resultsText = numHits & " hit#iif(numHits neq 1,de("s"),de(""))# in " & numObjects & " object#iif(numObjects neq 1,de("s"),de(""))#">
	<cfelse>
		<cfset resultsText = "0 hits in 0 objects">
	</cfif>
<html>
<head>
	<title>DBX</title>
	<style>
			body { background-color: #ffffff; font-family : sans-serif; font-size : 10px; color : #000000; }	
			table,ul,p,li,div,span,a { font-family : sans-serif; font-size : 11px; color : #000000; }
			td.header { background-color: #666666; font-family : sans-serif; font-size : 11px; color : #ffffff; font-weight: bold; }
			td.subheader { background-color: #e9e9e9; font-family : sans-serif; font-size : 11px; color : #000000; font-weight: bold; }
			table.bordered { background-color: #222222; }	
			td { background-color: #ffffff; font-family : sans-serif; font-size : 11px; color : #000000; }
			.heavy { font-weight: bold; }
			a { color: blue; text-decoration: none; } 
			.hit { background-color: #ffff99; font-weight: bold; }
	</style>
	<body onload="self.focus();">
	<p>
	<span class="heavy">Search Results</span><br><br><cfoutput>
	<span class="heavy">Datasource</span>: #dbdsn#<br>
	<span class="heavy">Searching For</span>: #ss#<br>
	<cfif len(trim(theTextList))><span class="heavy">Scope</span>: #trim(theTextList)#</span></cfif>
	</p>
	<p>
	<span class="heavy">Search Returned</span>: #resultsText# 
	</p>
	</cfoutput>
	<table border=0 cellpadding=3 cellspacing=1 class="bordered" width="100%">
	<tr><td width="10%" class="header">Type:</td><td width="90%" class="header">[Owner] Object Name<cfif isdefined("form.showVerbose")> / Location</cfif>:</td></tr>
	<cfoutput query="search" group="table_name">
	<tr><td width="10%" valign="top" class="subheader"<cfif isdefined("form.showVerbose")> rowspan="2"</cfif>>#ucase(object_type)#</td><td width="90%" class="subheader" valign="top">
	#formatObjectLink(text=table_name,type=object_type,owner=table_owner,target="opener")#
	<!--- <cfswitch expression="#ucase(object_type)#"><cfcase value="TABLE"><a href="##" onclick="window.opener.location.href='index.cfm?frame=detail&oid=#urlencodedformat(table_name)#&owid=#table_owner#'; window.opener.focus(); return false;">[#table_owner#] #table_name#</a></cfcase><cfcase value="VIEW"><a href="##" onclick="window.opener.location.href='index.cfm?frame=detail&oid=#urlencodedformat(table_name)#&owid=#table_owner#&v=1'; window.opener.focus(); return false;">[#table_owner#] #table_name#</a></cfcase><cfcase value="PROCEDURE"><a href="##" onclick="window.opener.location.href='index.cfm?frame=detail&oid=#urlencodedformat(table_name)#&owid=#table_owner#&sp=1'; window.opener.focus(); return false;">[#table_owner#] #table_name#</a></cfcase><cfcase value="FUNCTION"><a href="##" onclick="window.opener.location.href='index.cfm?frame=detail&oid=#urlencodedformat(table_name)#&owid=#table_owner#&sp=1&fn=1'; window.opener.focus(); return false;">[#table_owner#] #table_name#</a></cfcase><cfcase value="TRIGGER"><a href="##" onclick="window.opener.location.href='index.cfm?frame=detail&oid=#urlencodedformat(parent_obj)#&owid=#table_owner#'; window.opener.focus(); return false;">[#table_owner#] #table_name#</a></cfcase><cfdefaultcase>&nbsp;</cfdefaultcase></cfswitch> --->

	</td></tr>
	<cfif isdefined("form.showVerbose")><tr><td width="90%" valign="top" style="padding: 10px;"><cfoutput><cfif listfindnocase("TABLE,VIEW",ucase(object_type))>#replace(rereplacenocase(column_name,'(#regex#)','<span class="hit">\1</span>',"all"),chr(10),'<br>','all')#<br><cfelse>#rereplacenocase(replace(replace(replace(trim(column_name),chr(10),'<br>','all')," ","&nbsp;","all"),chr(9),"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;","all"),'(#regex#)','<span class="hit">\1</span>',"all")#</cfif></cfoutput></td></tr></cfif>
	</cfoutput>
	</table>

	
	</body>
	</html>

</cfif>
<cfif not dbx.debugging>
	<cfsetting showdebugoutput="no">
</cfif>
<cfabort>