<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
		9.0.2 - 3/24/2006 - Kevin Miller - added value/prefixing, modified indentation 
		9.0.3 - 5/8/2006 - Kevin Miller - added crud option for table/view codegen, xml hidden form
------------------------------------------------------------------ --->

<cfinclude template="../core/udf/udf_formatObjectLink.cfm">
<cfinclude template="udf/udf_getCFSQLType.cfm"><!--- function for converting to CF_SQL_TYPE values --->
<cfinclude template="udf/udf_getNULLHandler.cfm"><!--- function for converting to CF_SQL_TYPE values --->

<cfsetting enablecfoutputonly = "no">

<!--- viewing the source page --->
<html>
<head>
	<title>DBX</title><cfoutput>
	<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>
	<cfset oidname = url.oid>
	<script>
			APP = top; 
	</script><cfoutput>
	<script type="text/javascript" src="#dbxr.fullpathprefix#js/jquery-1.2.6.min.js"></script>
	<script type="text/javascript" src="#dbxr.fullpathprefix#js/jquery.tablesorter.min.js"></script>
	<script type="text/javascript" src="#dbxr.fullpathprefix#js/dbx_local.js"></script></cfoutput>
	
	<!--- column/param js lists --->
	<script>
		topLoaded = false;

		Array.prototype.append = function (val) {
			this[this.length] = val;
		}
		jsCols = new Array();
		jsQParam1 = new Array();
		jsQParam2 = new Array();
		jsQParam3 = new Array(); 
		jscrQParam1 = new Array();
		jscrQParam2 = new Array();
		jscrQParam3 = new Array(); 
		jsNULLHandler = new Array(); 
		<cfif isdefined("url.sp")>jsVarType = new Array();
		jsQParamType = new Array();</cfif>
		<cfoutput query="getobject">
		jsCols.append('#column_name#');<cfsilent>
		<cfif isdefined("url.sp")>
			<cfswitch expression="#column_type#">
				<cfcase value="1"><cfset thistype = "IN"></cfcase><!--- SQL_PARAM_TYPE_INPUT --->
				<cfcase value="2"><cfset thistype = "OUT"></cfcase><!--- SQL_PARAM_TYPE_OUTPUT --->
				<cfcase value="3"><cfset thistype = "RESULT COL"></cfcase><!--- SQL_RESULT_COL --->
				<cfcase value="4"><cfset thistype = "OUT"></cfcase><!--- SQL_PARAM_OUTPUT --->
				<cfcase value="5"><cfset thistype = "RETURN VAL"></cfcase><!--- SQL_RETURN_VALUE --->
				<cfdefaultcase><cfset thistype = "?"></cfdefaultcase><!--- SQL_PARAM_TYPE_UNKNOWN --->
			</cfswitch>
		</cfif></cfsilent><cfif isdefined("url.sp")>jsVarType.append('#thistype#');</cfif><cfsilent>
		<cfset thiscfsqltypeparam = getCFSQLType(type_name)><cfset thiscfnullhandler = getNULLHandler(type_name)>
		</cfsilent>
			jsQParam1.append('<cf' + 'queryparam cfsqltype="#thiscfsqltypeparam#" value="'); jsQParam2.append('" null="'); jsQParam3.append('">');<cfif isdefined("url.sp")>jsQParamType.append('#thiscfsqltypeparam#');</cfif> jsNULLHandler.append('#thiscfnullhandler#'); 
			jscrQParam1.append('{ #column_name# : { value : "", cfsqltype : "#thiscfsqltypeparam#"'); jscrQParam2.append(', null="'); jscrQParam3.append(' } }'); jsNULLHandler.append('#thiscfnullhandler#');</cfoutput>
	</script>

	<script>
	
    <!--
    function doQuickCopy(which,typeOverride) {
		var which = (which == null) ? 'form' : 'string'; // how to output the result, to the form or as a return string  
		var typeOverride = (which == 'string' && typeOverride != null) ? typeOverride : null; // which type to extract
		var qcform = parent.detailbottom.document.qcform;
		var usetabs = qcform.usetabs.options[qcform.usetabs.selectedIndex].value;
		var placeholders = qcform.placeholders.options[qcform.placeholders.selectedIndex].value;
		var scopeprefix = qcform.scopeprefix.options[qcform.scopeprefix.selectedIndex].value;
			if(scopeprefix == 'None') { scopeprefix = ""; }
		var nullhandler = qcform.nullhandler.options[qcform.nullhandler.selectedIndex].value;
		var nullreplacetext = ""; 
		var style = qcform.qc.options[qcform.qc.selectedIndex].value;
		if(style == 'all' && typeOverride==null) { doCRUD(); return true; } // if crud output, bail from this function
		if(usetabs == 2) { spacer = ""; } else if(usetabs == 1) { spacer = "\t"; } else { spacer = " "; }
		if(typeOverride) { 
			style = typeOverride; // override the form's style selection when doing crud output
		}
	<cfif not isdefined("url.sp")>
		var usebrackets = qcform.usebrackets.options[qcform.usebrackets.selectedIndex].value;
		var usecf = qcform.usecf.options[qcform.usecf.selectedIndex].value;
		var qualifiers = qcform.qualifiers.options[qcform.qualifiers.selectedIndex].value;
		if(usebrackets == 1) { lb = "["; rb = "]";} else { lb = ""; rb = ""; }
		
		<cfset cleanTableName = "#rereplace(getobject.table_name,'[^[:alnum:]]','','all')#">
		<cfoutput>
		tableName = '#getobject.table_name#';
		ownerName = '#getobject.table_owner#';
		cleanTableName = '#ucase(left(cleanTableName,1))##right(cleanTableName,(len(cleanTableName)-1))#';
		qre = /%method%/gi;		
		qprefix = '#dbxcodegenprefix#';</cfoutput>

		// set the prefs cookie
		// usetabs | usebrackets | usecf | qualifiers
		APP.setCookie("QUICKCOPY",usetabs + "|" + usebrackets + "|" + usecf + "|" +  qualifiers + "|" + placeholders + "|" + style + "|" + scopeprefix + "|" + nullhandler);
		

	<cfif not isdefined("url.master")>
		switch (qualifiers) {
			case "0":
				qual = ""; tqual = ""; aqual = ""; 
				break;
			case "1":
				qual = lb + tableName + rb + "."; tqual = ""; aqual = ""; 
				break; 
			case "2":
				qual = lb + ownerName + rb + "." + lb + tableName + rb + "."; tqual = lb + ownerName + rb + "."; aqual = ""; 
				break;
			case "3":
				qual = lb + ownerName + rb + "." + lb + tableName + rb + "."; tqual = lb + ownerName + rb + "."; aqual = tableName.substr(0,1); 
				break;
			default:
				qual =""; tqual = ""; aqual = ""; 
			}
	<cfelse>
			qual = lb + "master" + rb + ".." + lb + tableName + rb + "."; tqual = lb + "master" + rb + ".."; aqual = ""; 
	</cfif>
	
		cfheader1 = '<cfoutput><' + 'cfquery result="';
		cfheader2 = '';
		cfheader3 = '" datasource="#dbxcodegendsn#"<cfif len(dbxcodegenuser) and len(dbxcodegenpass)> username="#dbxcodegenuser#" password="#dbxcodegenpass#"</cfif>></cfoutput>\n';
		cffooter = '\n<' + '/cfquery>\n';

		if(style.length == 0) { return false; }

		if(style.indexOf("select") > -1) { // use name attribute if its a select query
			cfheader1 = '<' + 'cfquery name="';
		}

		switch (style) { 
			case "select0": 
				qcform.placeholders.disabled = true;
				qcform.scopeprefix.disabled = true;
				qcform.nullhandler.disabled = true; 
				writethis = spacer + "SELECT \n";
				for(i=0; i < document.codeInclude.include.length; i++) {
					if(document.codeInclude.include[i].checked) {
						writethis += spacer + spacer + ((!aqual.length) ? qual : aqual + '.') + lb + jsCols[i] + rb + ",\n"; 
					}
				}
				writethis = writethis.substring(0,(writethis.length-2)) + "\n";
				writethis += spacer + "FROM " + tqual + lb + tableName + rb + ' ' + aqual;  
				cfheader2 = qprefix.replace(qre, "Select") + cleanTableName;
				break;	
				
			case "select1": 
				qcform.placeholders.disabled = true;
				qcform.scopeprefix.disabled = true;
				qcform.nullhandler.disabled = true; 
				writethis = spacer + "SELECT";
				for(i=0; i < document.codeInclude.include.length; i++) {
					if(document.codeInclude.include[i].checked) {
						writethis += " " + ((!aqual.length) ? qual : aqual + '.') + lb + jsCols[i] + rb + ", "; 
					}
				}
				if(writethis.substring(writethis.length-2) == ", ") {
					writethis = writethis.substring(0,(writethis.length-2));
				}
				writethis += " FROM " + tqual + lb + tableName + rb + ' ' + aqual;  
				cfheader2 = qprefix.replace(qre, "Select") + cleanTableName;
				break;	
				
			case "update0": 
				qcform.placeholders.disabled = false;
				qcform.scopeprefix.disabled = (placeholders == 2) ? false : true;
				qcform.nullhandler.disabled = (placeholders == 2) ? false : true;
				writethis = spacer + "UPDATE " + ((!aqual.length) ? tqual + lb + tableName + rb : aqual) + "  \n" + spacer + "SET \n";
				for(i=0; i < document.codeInclude.include.length; i++) {
					if(document.codeInclude.include[i].checked) {
						writethis += spacer + spacer + ((!aqual.length) ? qual : aqual + '.') + lb + jsCols[i] + rb + " = "; 
						if(placeholders == 1) {
							writethis +=  jsCols[i];
						}
						else if(placeholders == 2) {
							writethis += jsQParam1[i];
							if(scopeprefix.length) { 
								if(scopeprefix != 'Colname') { 
									nullreplacetext = scopeprefix + '.' + jsCols[i];
									writethis += '#' + nullreplacetext + '#';
								}
								else { 
									nullreplacetext = jsCols[i]; 
									writethis += '#' + nullreplacetext + '#';
								}
							}
							writethis += jsQParam2[i]; 
							if(nullhandler == 'true') { 
								writethis += jsNULLHandler[i].replace(/```REPLACEME```/,nullreplacetext);
							}
							else { 
								writethis += 'false'; 
							}
							writethis += jsQParam3[i]; 
						}
						writethis += ",\n"; 
					}
				}
				writethis = writethis.substring(0,(writethis.length-2)) + "\n";
				if(qualifiers == 3) { 
					writethis += spacer + "FROM " + tqual + lb + tableName + rb + " " + aqual; 
				}
				cfheader2 = qprefix.replace(qre, "Update") + cleanTableName;
				break;	
				
			case "update1": 
				qcform.placeholders.disabled = false;
				qcform.scopeprefix.disabled = (placeholders == 2) ? false : true;
				qcform.nullhandler.disabled = (placeholders == 2) ? false : true;
				writethis = spacer + "UPDATE " + ((!aqual.length) ? tqual + lb + tableName + rb : aqual) + " SET ";
				for(i=0; i < document.codeInclude.include.length; i++) {
					if(document.codeInclude.include[i].checked) {
						writethis += ((!aqual.length) ? qual : aqual + '.') + lb + jsCols[i] + rb + " = ";
						if(placeholders == 1) {
							writethis +=  jsCols[i];
						}
						else if(placeholders == 2) {
							writethis += jsQParam1[i];
							if(scopeprefix.length) { 
								if(scopeprefix != 'Colname') { 
									nullreplacetext = scopeprefix + '.' + jsCols[i];
									writethis += '#' + nullreplacetext + '#';
								}
								else { 
									nullreplacetext = jsCols[i]; 
									writethis += '#' + nullreplacetext + '#';
								}
							}
							writethis += jsQParam2[i]; 
							if(nullhandler == 'true') { 
								writethis += jsNULLHandler[i].replace(/```REPLACEME```/,nullreplacetext);
							}
							else { 
								writethis += 'false'; 
							}
							writethis += jsQParam3[i]; 
						}
						writethis += ", "; 
					}
				}
				if(writethis.substring(writethis.length-2) == ", ") {
					writethis = writethis.substring(0,(writethis.length-2));
				}
				if(qualifiers == 3) { 
					writethis += " FROM " + tqual + lb + tableName + rb + " " + aqual; 
				}
				cfheader2 = qprefix.replace(qre, "Update") + cleanTableName;
				break;	
				
			case "insert0": 
				qcform.placeholders.disabled = false;
				qcform.scopeprefix.disabled = (placeholders == 2) ? false : true;
				qcform.nullhandler.disabled = (placeholders == 2) ? false : true;
				writethis = spacer + "INSERT INTO "  + tqual + lb + tableName + rb + " (\n";
				for(i=0; i < document.codeInclude.include.length; i++) {
					if(document.codeInclude.include[i].checked) {
						writethis += spacer + spacer + qual + lb + jsCols[i] + rb + ",\n"; 
					}
				}
				if(writethis.substring(writethis.length-2) == ",\n") {
					writethis = writethis.substring(0,(writethis.length-2));
				}
				writethis +=  "\n" + spacer + ")\n" + spacer + "VALUES (\n";
				for(i=0; i < document.codeInclude.include.length; i++) {
					if(document.codeInclude.include[i].checked) {
						writethis += spacer + spacer;
						if(placeholders == 1) {
							writethis +=  jsCols[i];
						}
						else if(placeholders == 2) {
							writethis += jsQParam1[i];
							if(scopeprefix.length) { 
								if(scopeprefix != 'Colname') { 
									nullreplacetext = scopeprefix + '.' + jsCols[i];
									writethis += '#' + nullreplacetext + '#';
								}
								else { 
									nullreplacetext = jsCols[i]; 
									writethis += '#' + nullreplacetext + '#';
								}
							}
							writethis += jsQParam2[i]; 
							if(nullhandler == 'true') { 
								writethis += jsNULLHandler[i].replace(/```REPLACEME```/,nullreplacetext);
							}
							else { 
								writethis += 'false'; 
							}
							writethis += jsQParam3[i]; 
						}
						writethis += ",\n"; 
					}
				}
				if(writethis.substring(writethis.length-2) == ",\n") {
					writethis = writethis.substring(0,(writethis.length-2));
				}
				writethis +=  "\n" + spacer + ")";
				cfheader2 = qprefix.replace(qre, "Insert") + cleanTableName;
				break;	
	
			case "insert1": 
				qcform.placeholders.disabled = false;
				qcform.scopeprefix.disabled = (placeholders == 2) ? false : true;
				qcform.nullhandler.disabled = (placeholders == 2) ? false : true;
				writethis = spacer + "INSERT INTO "  + tqual + lb + tableName + rb + " (";
				for(i=0; i < document.codeInclude.include.length; i++) {
					if(document.codeInclude.include[i].checked) {
						writethis += qual + lb + jsCols[i] + rb + ", "; 
					}
				}
				if(writethis.substring(writethis.length-2) == ", ") {
					writethis = writethis.substring(0,(writethis.length-2));
				}
				writethis +=  ") VALUES (";
				for(i=0; i < document.codeInclude.include.length; i++) {
					if(document.codeInclude.include[i].checked) {
						// writethis += jsCols[i] + ", "; 
						if(placeholders == 1) {
							writethis +=  jsCols[i];
						}
						else if(placeholders == 2) {
							writethis += jsQParam1[i];
							if(scopeprefix.length) { 
								if(scopeprefix != 'Colname') { 
									nullreplacetext = scopeprefix + '.' + jsCols[i];
									writethis += '#' + nullreplacetext + '#';
								}
								else { 
									nullreplacetext = jsCols[i]; 
									writethis += '#' + nullreplacetext + '#';
								}
							}
							writethis += jsQParam2[i]; 
							if(nullhandler == 'true') { 
								writethis += jsNULLHandler[i].replace(/```REPLACEME```/,nullreplacetext);
							}
							else { 
								writethis += 'false'; 
							}
							writethis += jsQParam3[i]; 
						}
						writethis += ", "; 
					}
				}
				if(writethis.substring(writethis.length-2) == ", ") {
					writethis = writethis.substring(0,(writethis.length-2));
				}
				writethis +=  ")";
				cfheader2 = qprefix.replace(qre, "Insert") + cleanTableName;
				break;	
				
			case "delete0": 
				qcform.placeholders.disabled = true;
				qcform.scopeprefix.disabled = true;
				qcform.nullhandler.disabled = true; 
				writethis = spacer + "DELETE";/* 
				for(i=0; i < document.codeInclude.include.length; i++) {
					if(document.codeInclude.include[i].checked) {
						writethis += " " + qual + lb + jsCols[i] + rb + ", "; 
					}
				}
				if(writethis.substring(writethis.length-2) == ", ") {
					writethis = writethis.substring(0,(writethis.length-2));
				} */
				writethis += " FROM " + tqual + lb + tableName + rb;
				cfheader2 = qprefix.replace(qre, "Delete") + cleanTableName;
				break;	
				
			default: 
				writethis = '';
		}
			
		if(usecf == 1) {
			writethis = cfheader1 + cfheader2 + cfheader3 + writethis + cffooter;	
		}
		
		if(which == 'form') { 
			parent.detailbottom.document.getElementById('QuickCopy').value = writethis; 
		}
		else { 
			return writethis; // when doing an 'all' generation we'll be returning the value itself
		}
		
	<cfelse><!--- sp specific code --->
		var resulttags = qcform.resulttags.options[qcform.resulttags.selectedIndex].value;
		if(style.length == 0) { return false; }
		
	switch (style) { 
		case "cfstoredproc": 
		qcform.placeholders.disabled = true;
		qcform.scopeprefix.disabled = false; 
		qcform.nullhandler.disabled = false; 
		tempprocresults = "";
		qcform.resulttags.disabled = false;
		for(i=0; i < resulttags; i=i+1) {
		tempprocresults += spacer + '<cf' + 'procresult name="QUERYNAME' + (i+1) + '" resultset="' + (i+1) + '">\n';
		}

		cfheader = '<cfoutput><' + 'cfstoredproc procedure="#oidname#" datasource="#dbxcodegendsn#"<cfif len(dbxcodegenuser) and len(dbxcodegenpass)> username="#dbxcodegenuser#" password="#dbxcodegenpass#"</cfif>></cfoutput>\n';
		cffooter = tempprocresults + '<' + '/cfstoredproc>\n';
		writethis = '';
		for(i=0; i < jsCols.length; i++) {
			if(jsVarType[i] != "RETURN VAL") {
				writethis += spacer + '<' + 'cfprocparam type="' + jsVarType[i] + '" cfsqltype="' + jsQParamType[i] + '" dbvarname="@' + jsCols[i].substring(1,jsCols[i].length) + '"';
				if(jsVarType[i] == 'OUT') {
					writethis += ' variable=""';
				}
				else {
					if(scopeprefix.length) { 
						if(scopeprefix != 'Colname') { 
							nullreplacetext = scopeprefix + '.' + jsCols[i].substring(1,jsCols[i].length);
							writethis += ' value="#' + nullreplacetext + '#"'; 
						}
						else { 
							nullreplacetext = jsCols[i].substring(1,jsCols[i].length); 
							writethis += ' value="#' + nullreplacetext + '#"'; 
						}
					}
					else { 
						writethis += ' value=""';
					}
				}
				writethis += ' null="';
				if(nullhandler == 'true') { 
					writethis += jsNULLHandler[i].replace(/```REPLACEME```/,nullreplacetext);
				}
				else { 
					writethis += 'false'; 
				}
				writethis += '">\n';		
			}
		}
		break;	
			
		case "cfquery": 
			qcform.resulttags.disabled = true;
			qcform.placeholders.disabled = false;
			qcform.scopeprefix.disabled = (placeholders == 2) ? false : true;
			qcform.nullhandler.disabled = (placeholders == 2) ? false : true;
			cfheader = '<cfoutput><' + 'cfquery name="#rereplace(oidname,'[^[:alnum:]]','','all')#" datasource="#dbxcodegendsn#"<cfif len(dbxcodegenuser) and len(dbxcodegenpass)> username="#dbxcodegenuser#" password="#dbxcodegenpass#"</cfif>></cfoutput>\n';
			cffooter = '\n<' + '/cfquery>';
			writethis = '';
			for(i=0; i < jsCols.length; i++) {
				if(jsVarType[i] == "IN") {
					if(placeholders == 1) {
						writethis += jsCols[i] + ', ';
					}
					else if(placeholders == 2) { 
						writethis += jsQParam1[i];
							if(scopeprefix.length) { 
								if(scopeprefix != 'Colname') { 
									nullreplacetext = scopeprefix + '.' + jsCols[i].substring(1,jsCols[i].length);
									writethis += '#' + nullreplacetext + '#';
								}
								else { 
									nullreplacetext = jsCols[i].substring(1,jsCols[i].length); 
									writethis += '#' + nullreplacetext + '#'; 
								}
							}
							writethis += jsQParam2[i] + ', '; 
							if(nullhandler == 'true') { 
								writethis += jsNULLHandler[i].replace(/```REPLACEME```/,nullreplacetext);
							}
							else { 
								writethis += 'false'; 
							}
							writethis += jsQParam3[i]; 
					}
				}
			}
			if(writethis.substring(writethis.length-2) == ", ") {
				writethis = writethis.substring(0,(writethis.length-2));
			}
			if(writethis.length) {
				writethis = spacer + 'EXEC <cfoutput>#oidname#</cfoutput> ' + writethis;
			}
			else {
				writethis = spacer + 'EXEC <cfoutput>#oidname#</cfoutput>';
			}
			writethis += ';';
			break; 
			
		case "cfquery_multi": 
			qcform.resulttags.disabled = true;
			qcform.placeholders.disabled = false;
			qcform.scopeprefix.disabled = (placeholders == 2) ? false : true;
			qcform.nullhandler.disabled = (placeholders == 2) ? false : true;
			cfheader = '<cfoutput><' + 'cfquery name="#rereplace(oidname,'[^[:alnum:]]','','all')#" datasource="#dbxcodegendsn#"<cfif len(dbxcodegenuser) and len(dbxcodegenpass)> username="#dbxcodegenuser#" password="#dbxcodegenpass#"</cfif>></cfoutput>\n';
			cffooter = '\n<' + '/cfquery>';
			writethis = '';
			for(i=0; i < jsCols.length; i++) {
				if(jsVarType[i] == "IN") {
					if(placeholders == 1) {
						writethis += spacer + spacer + jsCols[i] + ',\n';
					}
					else if(placeholders == 2) { 
						writethis += jsQParam1[i];
							if(scopeprefix.length) { 
								if(scopeprefix != 'Colname') { 
									nullreplacetext = scopeprefix + '.' + jsCols[i].substring(1,jsCols[i].length);
									writethis += '#' + nullreplacetext + '#';
								}
								else { 
									nullreplacetext = jsCols[i].substring(1,jsCols[i].length); 
									writethis += '#' + nullreplacetext + '#'; 
								}
							}
							writethis += jsQParam2[i] + ', '; 
							if(nullhandler == 'true') { 
								writethis += jsNULLHandler[i].replace(/```REPLACEME```/,nullreplacetext);
							}
							else { 
								writethis += 'false'; 
							}
							writethis += jsQParam3[i] + "\n"; 
					}
				}
			}
			if(writethis.substring(writethis.length-2) == ",\n") {
				writethis = writethis.substring(0,(writethis.length-2));
			}
			if(writethis.length) {
				writethis = spacer + 'EXEC <cfoutput>#oidname#</cfoutput> \n' + writethis;
			}
			else {
				writethis = spacer + 'EXEC <cfoutput>#oidname#</cfoutput>';
			}
			writethis += ';';
			break; 
			
		default: 
			writethis = '';
	}
		
	writethis = cfheader + writethis + cffooter;	
	parent.detailbottom.document.getElementById('QuickCopy').value = writethis; 
	
	</cfif>
}	

function doCRUD() { 
	var writethis = ""; 
	writethis += doQuickCopy('string','select0'); 
	writethis += '\n\n';
	writethis += doQuickCopy('string','insert0'); 
	writethis += '\n\n';
	writethis += doQuickCopy('string','update0'); 
	writethis += '\n\n';
	writethis += doQuickCopy('string','delete0'); 
	parent.detailbottom.document.getElementById('QuickCopy').value = writethis; 
}

sqlForExecWin = '';

function getRand() {
	return Math.random();
}

function launchSQLExecWindow() {
	var winName = getRand().toString();
	winName = 'sqlexec' + winName.substr(2);
	spacer = "\t";
	writethis = "SELECT \n";
	for(i=0; i < document.codeInclude.include.length; i++) {
		if(document.codeInclude.include[i].checked) {
			writethis += spacer + '[' + jsCols[i] + ']' + ",\n"; 
		}
	}
	writethis = writethis.substring(0,(writethis.length-2)) + "\n";
	writethis += "FROM " + tableName;
	sqlForExecWin = writethis;
	<cfoutput>openWindow('#dbxr.fullfilepathprefix#?se=1',winName);</cfoutput>
}

function addExtProperty(obj,addlparam,objwinname) {
	<cfoutput>openWindow('#dbxr.fullfilepathprefix#?aep=1&oid=' + obj + '&' + addlparam,objwinname);</cfoutput>
}

codeCheckboxesOn = true;

function toggleCodeCheckboxes() {
	if(codeCheckboxesOn) {
		for(i=0; i < document.codeInclude.include.length; i++) {
			document.codeInclude.include[i].checked = false;
		}
		codeCheckboxesOn = false;
		doQuickCopy();
	}
	else {
		for(i=0; i < document.codeInclude.include.length; i++) {
			document.codeInclude.include[i].checked = true;
		}
		codeCheckboxesOn = true;
		doQuickCopy();
	}
}

	// page tabs
	var proftabs = new Array('columns','parameters','keys','indexes','references','dependencies','triggers','space','fulltext','extprops','ddl','datasample');
	var activetab = <cfif not isdefined("url.sp") and not isdefined("url.fn")>'columns'<cfelse>'parameters'</cfif>; 
	
	function switchTab(which) { 
		var which = (which != null) ? which : activetab; 
		
		for(var i=0; i < proftabs.length; i++) { 
			if(document.getElementById(proftabs[i] + 'div') && document.getElementById(proftabs[i] + 'tab')) { 
				if(proftabs[i] == which) { 
					document.getElementById(proftabs[i] + 'div').className = 'pagedivon'; 
					document.getElementById(proftabs[i] + 'tab').className = 'pagetab on';
					activetab = which; 
				}
				else { 
					document.getElementById(proftabs[i] + 'div').className = 'pagediv'; 
					document.getElementById(proftabs[i] + 'tab').className = 'pagetab';		
				}
			}
		}
	}
	
	function setDivScrollers() { 
		var thirdheight = document.getElementById('third').offsetHeight; 
		var thirdwidth = document.getElementById('third').offsetWidth; 
		for(var i = 0; i < proftabs.length; i++) { 
			if(document.getElementById(proftabs[i] + 'div')) { 
					document.getElementById(proftabs[i] + 'div').style.height = thirdheight; 
					document.getElementById(proftabs[i] + 'div').style.width = thirdwidth; 
			}
		}
		switchTab(activetab); 
	}
		
	function setDDLTextareaSize() { 
		if(document.getElementById('ddldisplay')) { 
			document.getElementById('ddldisplay').style.height = document.getElementById('third').offsetHeight - 20; 
			document.getElementById('ddldisplay').style.width = document.getElementById('third').offsetWidth - 30; 
		}
	}	
	
	function doresize() { 
		for(var i = 0; i < proftabs.length; i++) { 
			if(document.getElementById(proftabs[i] + 'div')) { 
				document.getElementById(proftabs[i] + 'div').style.height = '1px'; 
			}
		}
		setDivScrollers(); 
		setDDLTextareaSize();
		switchTab(activetab); 
	}
	onresize = doresize;
	 
	function printTab() { 
		if(document.getElementById(activetab + 'div')) { 
			var pwindow = window.open('about:blank','pwindow'); <cfoutput>
			var ptitle = '[<cfif not isdefined("url.sp") and not isdefined("url.fn")>#jsstringformat(getobject.table_name)#<cfelse>#jsstringformat(oidname)#</cfif>] : ' + activetab.toUpperCase(); 
			var writeme = '<html><head>	<title>DBX - Print Window</title><link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"><scr' + 'ipt>APP = null;</scr' + 'ipt><style>body { background: ##fff; color: ##000; padding: 20px; } div.pagedivon { scrolling: auto; height: auto; }</style></he' + 'ad><body><div class="pagedivon"><div class="stableh">' + ptitle + '</div><br>'; </cfoutput>
			writeme += document.getElementById(activetab + 'div').innerHTML; 
			writeme += '</div></body></html>';
			pwindow.document.write(writeme); 
			pwindow.print(); 
		} 
		else { 
			return false; 
		}
	}

	$(document).ready(function() { $('#column-info').tablesorter({ headers : { 0 : { sorter: false } } }); });
    //-->
    </script><!--- 
	<style type="text/css">
		html { height: 100%; overflow: hidden; }
	</style> --->
</head>

<body onload="topLoaded = true;APP.writeStatus(0); setDivScrollers(); setDDLTextareaSize(); " class="sourcepage">
<table id="sourcelayout" border="0" cellpadding="0" cellspacing="0"<!---  width="100%" height="100%" --->>
<cfif not isdefined("url.sp") and not isdefined("url.fn")><!--- table or view --->
<tr><td class="first">
	<table border="0" cellspacing="0" class="navbar2">
	<tr><td><div class="tab"><cfoutput><cfif isdefined("url.master")>master..</cfif>#getobject.table_name#</cfoutput> <cfif isdefined("url.v")>[View]<cfelse>[Table]</cfif></div></td>
	<td class="r"><cfif not dbx.guestmode and dbx.showExecSQL><a href="#" onclick="launchSQLExecWindow(); return false;" class="nav" title="Open Exec SQL Window for this object">SQL*EXEC</a></cfif><cfif isdefined("url.v")><a href="#" onclick="viewFormCode('code_form','detailtop'); return false;" class="nav" title="View this object's schema">SCHEMA</a></cfif><cfif not isdefined("url.v")><cfoutput><a href="##" onclick="openWindow('#dbxr.fullfilepathprefix#?ci=1&t=#getobject.table_name#','insertWin'); return false;" class="nav" title="Create SQL Insert statements for current data"></cfoutput>INSERTS</a><a href="#" onclick="viewFormCode('spgencode_form','detailtop'); return false;" class="nav" title="Generate 'seed' stored proc templates">GEN PROCS</a><a href="#" onclick="viewFormCode('xmlgencode_form','detailtop'); return false;" class="nav" title="Generate XML schema-type code">GEN XML</a></cfif><a href="#" onclick="viewFormCode('arggencode_form','detailtop'); return false;" class="nav" title="Generate CFC arguments">GEN CFC ARGS</a><cfif not dbx.guestmode><cfoutput><a href="##" onclick="addExtProperty('#urlencodedformat(trim(url.oid))#',<cfif not isdefined("url.v")>''<cfelse>'v=1'</cfif>,'extpropmgr'); return false;" class="nav" title="Manage Extended Properties">EXT PROP MGR</a></cfoutput></cfif><a href="#" onclick="printTab(); return false;" class="nav" title="Print currently open tab">Print</a></td></tr>
	</table>
</td></tr>
<tr><td class="second">	
<!--- 
<a href="#" onclick="printTab(); return false;" class="iprint">PRINT</a> --->
<div id="pagetabs">
	<a id="columnstab" href="#" class="pagetab on" onclick="switchTab('columns'); return false;">Columns</a><cfif not isdefined("url.v")>
	<a id="indexestab" href="#" class="pagetab" onclick="switchTab('indexes'); return false;">Indexes</a>
	<a id="keystab" href="#" class="pagetab" onclick="switchTab('keys'); return false;">Keys</a>
	<a id="referencestab" href="#" class="pagetab" onclick="switchTab('references'); return false;">References</a></cfif>
	<a id="dependenciestab" href="#" class="pagetab" onclick="switchTab('dependencies'); return false;">Dependencies</a><cfif not isdefined("url.v")>
	<a id="triggerstab" href="#" class="pagetab" onclick="switchTab('triggers'); return false;">Triggers</a>
	<a id="spacetab" href="#" class="pagetab" onclick="switchTab('space'); return false;">Space</a><cfif not issys>
	<a id="fulltexttab" href="#" class="pagetab" onclick="switchTab('fulltext'); return false;">Fulltext</a></cfif></cfif>
	<a id="extpropstab" href="#" class="pagetab" onclick="switchTab('extprops'); return false;">Ext Props</a>
	<a id="ddltab" href="#" class="pagetab" onclick="switchTab('ddl'); return false;">DDL</a><cfif val(dbx.dataSampleRows)>
	<a id="datasampletab" href="#" class="pagetab" onclick="switchTab('datasample'); return false;">Data Sample</a></cfif>
</div>
</td></tr>
<tr><td class="third" id="third">
	<div id="columnsdiv" class="pagediv">
	<form name="codeInclude" id="codeInclude">
	<table border="0" cellpadding="0" cellspacing="1" class="stable" id="column-info">
	<!--- <tr><td class="beveled" colspan="<cfif sqlserverVersion neq "7">7<cfelse>6</cfif>">COLUMN DATA</td></tr> --->
	<thead>
		<tr><th class="stableh c sorter-false"><a href="#" onclick="toggleCodeCheckboxes(); return false;" title="Select/De-select all checkboxes">CODE</a></th><th class="stableh c">POS</th><th class="stableh">COLUMN NAME</th><th class="stableh">DATATYPE</th><th class="stableh c">NULL</th><th class="stableh c">DEFAULT VALUE</th><th class="stableh c">EXT</th><th class="stableh">Description</th></tr>
	</thead>
	<tbody>
	<cfset rowByteTotal = 0>
	<cfoutput query="getobject">
				<tr>
						<td class="stableh c" width="1%"><input type="checkbox" class="checkbox" name="include" value="#evaluate(ordinal_position-1)#" checked onclick="doQuickCopy();"></td>
						<td align="right" width="6%">#ordinal_position#&nbsp;</td>
<cfsetting enablecfoutputonly="yes">

	<!--- get col specific ext prop info --->
	<cfquery dbtype="query" name="extproptemp">
		SELECT * FROM getobject_extprops WHERE objname = '#column_name#' 
	</cfquery>
	<cfquery dbtype="query" name="extprop">
		SELECT * FROM extproptemp WHERE name != 'MS_Description' 
	</cfquery>
	<cfquery dbtype="query" name="extpropdesc">
		SELECT * FROM extproptemp WHERE name = 'MS_Description' 
	</cfquery>
	<cfset ispk = false>
	<cfif getobject_indexes.recordcount>
		<cfquery dbtype="query" name="findpk">
			SELECT index_keys FROM getobject_indexes 
			WHERE is_primary_key = 1
		</cfquery>
		<cfif findpk.recordcount>
			<cfset pkcols = replace(findpk.index_keys,", ",",","all")>
			<cfif listfindnocase(pkcols,column_name)>
				<cfset ispk = true>
			</cfif>
		</cfif>
	</cfif>

<cfsetting enablecfoutputonly="no">
						<td width="20%">&nbsp;#column_name#<cfif ispk> <sup class="heavy warning">PK</sup></cfif></td>
						<td width="20%">&nbsp;#type_name#(<cfif listfindnocase("varchar,nvarchar",type_name) and precision gt 8000>max<cfelse>#precision#</cfif>)</td><cfset rowByteTotal = rowByteTotal + length>
						<td align="center" width="5%"><cfif nullable>NULL<cfelse>NO</cfif></td>
						<td width="15%">&nbsp;<cfif len(column_def)>#column_def#<cfelse>&nbsp;</cfif></td>
						<td width="1%" align="center" nowrap><cfif extprop.recordcount><a href="##" onmouseover="APP.showGenericDiv('ep#ordinal_position#',window.name);" onmouseout="APP.hideGenericDiv('ep#ordinal_position#',window.name);" onclick="return false;" class="button">~</a><div id="ep#ordinal_position#" class="detaildiv"><table border="0" cellpadding="2" cellspacing="1" class="fly"><tr><td class="flyh" colspan="3">EXTENDED PROPERTIES - #column_name#</td></tr><tr><td class="flyh2">NAME</td><td class="flyh2">VALUE</td></tr><cfloop query="extprop"><tr><td>#name#</td><td>#value#</td></tr></cfloop></table></div><cfelse>&nbsp;</cfif></td>
						<td width="31%">&nbsp;<cfif extpropdesc.recordcount>#extpropdesc.value#</cfif></td>
				</tr>
	</cfoutput>
	</tbody>
	<tfoot>
	<tr>
		<td colspan="<cfif sqlServerVersion neq "7">3<cfelse>2</cfif>" align="right">TOTAL ROW SIZE</td><td colspan="5"><cfoutput>#rowByteTotal# bytes</cfoutput></td>
	</tr>
	</tfoot>
	</table>
	</form>
<cfif isdefined("url.v")><cfoutput><form name="code_form" id="code_form" action="#dbxr.fullfilepathprefix#?cv=1" target="_blank" method="post"><input type="hidden" name="itemname" value="#getobject.table_name#"></cfoutput><input type="hidden" name="code" value="<cfoutput query="tvschema">#replace(text,'"','&quot;','all')#</cfoutput>"></form>
</cfif>
<cfsetting enablecfoutputonly="yes">

<!--- sp generator --->
<cfinclude template="../../generator/storedprocs/i_procgenerators.cfm">

<cfsetting enablecfoutputonly="no">
<cfoutput><form name="spgencode_form" id="spgencode_form" action="#dbxr.fullfilepathprefix#?cv=1" target="_blank" method="post"><input type="hidden" name="itemname" value="Generated Stored Procs for #getobject.table_name#"><input type="hidden" name="code" value="#spgeneratorContent#"></form></cfoutput>
<cfsetting enablecfoutputonly="yes">

<!--- cfc arg generator --->
<cfinclude template="../../generator/cfcs/i_arggenerators.cfm">

<cfsetting enablecfoutputonly="no">
<cfoutput><form name="arggencode_form" id="arggencode_form" action="#dbxr.fullfilepathprefix#?cv=1" target="_blank" method="post"><input type="hidden" name="itemname" value="Generated CFC Arguments for #oidname#"><input type="hidden" name="codetype" value="cfml"><input type="hidden" name="code" value="#arggeneratorContent#"></form></cfoutput>
	</div>
	<cfif not isdefined("url.v")>
	<div id="indexesdiv" class="pagediv">
	<cfif getobject_indexes.recordcount>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<tr>
		<td class="stableh">INDEX NAME</td>
		<td class="stableh">COLUMNS</td><cfif sqlServerVersion neq 2000>
		<td class="stableh">INCL COLUMNS</td></cfif>
		<td class="stableh">DESCRIPTION</td>
	</tr>
	<cfoutput query="getobject_indexes">
	<tr>
		<td>#index_name#</td>
		<td>#index_keys#</td><cfif sqlServerVersion neq 2000>
		<td>#included_columns#</td></cfif>
		<td>#index_description#</td>
	</tr>
	</cfoutput>
	</table>
	<cfelse>
	<div class="stableh">None</div>
	</cfif>
	</div>
	</cfif>
	<cfif not isdefined("url.v")>
	<div id="keysdiv" class="pagediv">
	<cfif getobject_keys.recordcount>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<tr>
		<td class="stableh">NAME</td>
		<td class="stableh">KEY COLS</td>
		<td class="stableh c">ADD'L</td>
		<td class="stableh">REF TABLE</td>
		<td class="stableh">REF KEY</td>
		<td class="stableh">REF COLS</td>
	</tr>
	<cfoutput query="getobject_keys">
	<cfscript>
		keyColList = "";
		for ( i=1; i lte 16; i = i+1 ) {
			if( len(trim(getobject_keys["cKeyCol#i#"][currentrow])) ) {
				keyColList = listappend(keyColList,trim(getobject_keys["cKeyCol#i#"][currentrow]));
			}
		}
		
		refColList = "";
		for ( i=1; i lte 16; i = i+1 ) {
			if( len(trim(getobject_keys["cRefCol#i#"][currentrow])) ) {
				refColList = listappend(refColList,trim(getobject_keys["cRefCol#i#"][currentrow]));
			}
		}
		
		cascadeList = "";
		if(val(cDeleteCascade)) {
			cascadeList = listappend(cascadeList,"Delete");
		}
		if(val(cUpdateCascade)) {
			cascadeList = listappend(cascadeList,"Update");
		}
	</cfscript>
	<tr>
		<td valign="top">#cName#&nbsp;</td>
		<td valign="top">#keyColList#&nbsp;</td>
		<!--- <td>#cColCount#&nbsp;</td> --->
		<!--- prep info string --->
		<cfscript>
			infoString = "";
			if(val(cFillFactor)) {
				infoString = infoString & '<tr><td class="td4" width="50%">Fill Factor:</td><td class="td4" width="50%">#cFillFactor#</td></tr>';
			}
			if(len(cascadeList)) {
				infoString = infoString & '<tr><td class="td4">Cascade:</td><td class="td4">#cascadeList#</td></tr>';
			}
			if(val(cIndexID)) {
				infoString = infoString & '<tr><td class="td4">Index ID:</td><td class="td4">#cIndexID#</td></tr>';
			}
			cRefOwner = rereplace(listfirst(cRefTable,"."),'(\[|\])','','all'); 
			cRefName = rereplace(listrest(cRefTable,"."),'(\[|\])','','all'); 
		</cfscript>
		<td align="center" valign="top"><cfif len(infoString)><a href="##" onmouseover="APP.showGenericDiv('cN#currentrow#',window.name);" onmouseout="APP.hideGenericDiv('cN#currentrow#',window.name);" onclick="return false;" class="button">~</a><div id="cN#currentrow#" class="detaildiv"><table border="0" cellpadding="2" cellspacing="1" class="fly"><tr><td class="flyh" colspan="3">ADDITIONAL PROPERTIES - #cName#</td></tr>#infoString#</table></div><cfelse>&nbsp;</cfif></td>
		<td valign="top">#formatObjectLink(text=cRefName,type="TABLE",owner=cRefowner,target="detail")#&nbsp;</td>
		<td valign="top">#cRefKey#&nbsp;</td>
		<td valign="top">#refColList#&nbsp;</td>
	</tr>
	</cfoutput>
	</table>
	<cfelse>
	<cfset keyColList = "">
	<cfset refColList = "">
	<div class="stableh"> None</div>
	 </cfif>
	
<cfsetting enablecfoutputonly="yes">

<!--- xml generator, this must be here to pick up on the key info above --->
<cfinclude template="../../generator/xml/i_xmlgenerators.cfm">

<cfsetting enablecfoutputonly="no">
<cfoutput><form name="xmlgencode_form" id="xmlgencode_form" action="#dbxr.fullfilepathprefix#?cv=1" target="_blank" method="post"><input type="hidden" name="itemname" value="Generated XML for #oidname#"><input type="hidden" name="codetype" value="xml"><input type="hidden" name="code" value="#xmlgeneratorContent#"></form></cfoutput>

	</div>
	</cfif>
	<cfif not isdefined("url.v")>
	<div id="referencesdiv" class="pagediv">
	<cfif getobject_refs.recordcount>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<tr>
		<td class="stableh">NAME</td>
	</tr>
	<cfoutput query="getobject_refs">
	<tr>
		<cfset cRefOwner = rereplace(listfirst(candidate_table,"."),'(\[|\])','','all')>
		<cfset cRefName = rereplace(listrest(candidate_table,"."),'(\[|\])','','all')>
		<td>#formatObjectLink(text=cRefName,type="TABLE",owner=cRefowner,target="detail")#&nbsp;</td>
	</tr>
	</cfoutput>
	</table>
	<cfelse>
	<div class="stableh">None</div>
	</cfif>
	</div>
	</cfif>
	<div id="dependenciesdiv" class="pagediv">	
	
	<div class="stableh"><cfoutput>[#getobject.table_name#]</cfoutput> DEPENDS UPON</div>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<cfif getobject_deps.recordcount>
	<tr>
		<td class="prepad"><pre><cfoutput query="getobject_deps"><cfif isdefined("oObjName")>#formatObjectLink(text=oObjName,type="TABLE",owner=oOwner,target="detail")#&nbsp;<cfelse>Unable to get object dependency data</cfif><cfif currentrow neq getobject_deps.recordcount>#chr(10)#</cfif></cfoutput></pre></td>
	</tr>
		<cfelse>
	<tr>
		<td>None</td>
	</tr>
	</cfif>
	</table>
	
	<cfif not isdefined("url.v")>
	<div class="stableh">OBJECTS DEPENDING UPON <cfoutput>[#getobject.table_name#]</cfoutput></div>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<cfif getobject_depstree.recordcount and getobject_depstree.recordcount gt 1>
	<tr><td class="prepad"><pre><cfoutput query="getobject_depstree"><cfset cRefOwner = rereplace(listfirst(treeitem,"."),'(\[|\])','','all')><cfset cRefName = rereplace(listrest(treeitem,"."),'(\[|\])','','all')>#treeitemspace##formatObjectLink(text=cRefName,type="TABLE",owner=cRefowner,target="detail",linkclass="#(getobject_depstree.currentrow eq 1 ? 'heavy' : '')#")##chr(10)#</cfoutput></pre></td></tr>
	<cfelse>
	<tr><td>None</td></tr>
	</cfif>
	</table>	
	
	
	<div class="stableh">OBJECTS DEPENDING UPON <cfoutput>[#getobject.table_name#]</cfoutput>'S COLUMNS</div>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<cfif getobject_coldeps.recordcount>
	<tr><td class="prepad"><pre><cfoutput query="getobject_coldeps" group="colName">#colName##chr(10)#<cfoutput>   |-- #formatObjectLink(text=depObj,type=depObjType,owner=depObjOwner,target="detail")# [<cfif depObjType eq "p">Procedure<cfelseif listfindnocase("fn,tf,if",depObjType)>Function<cfelseif depObjType eq "tr">Trigger<cfelseif depObjType eq "s">System Table<cfelseif depObjType eq "u">Table<cfelse>#depObjType#</cfif>]<cfif currentrow neq getobject_coldeps.recordcount>#chr(10)#</cfif></cfoutput><cfif currentrow neq getobject_coldeps.recordcount>#chr(10)#</cfif></cfoutput></pre></td></tr>
	<cfelse>
	<tr><td>None</td></tr>
	</cfif>
	</table>
	
	</cfif>
	</div>
	<cfif not isdefined("url.v")>
	<div id="spacediv" class="pagediv">
	<cfif getobject_space.recordcount>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<tr>
		<td class="stableh" align="center">ROWS</td>
		<td class="stableh" align="center">DATA SPACE USED</td>
		<td class="stableh" align="center">INDEX SPACE USED</td>
	</tr>
	<cfoutput query="getobject_space">
	<tr>
		<td align="right">#numberformat(Rows)#&nbsp;</td>
		<td align="right">#formatSize(DataSpaceUsed,"kb","composite")#&nbsp;</td>
		<td align="right">#formatSize(IndexSpaceUsed,"kb","composite")#&nbsp;</td>
	</tr>
	</cfoutput>
	</table>
	<cfelse>
	<div class="stableh">Unavailable</div>
	</cfif>
	</div>
	</cfif>
	<cfif not isdefined("url.v")>
	<div id="triggersdiv" class="pagediv">
	<cfif getobject_triggers.recordcount>
	<cfsilent><!--- in order to handle massive trigger text which sqlserver splits up, massage the query into a struct to concatenate split up data --->
		<cfset trigStruct = structnew()>
		<cfloop query="getobject_triggers">
			<cfif not structkeyexists(trigStruct,getobject_triggers.name)>
				<cfset trigStruct[getobject_triggers.name] = trim(getobject_triggers.text)>
			<cfelse>
				<cfset trigStruct[getobject_triggers.name] = trigStruct[getobject_triggers.name] & trim(getobject_triggers.text)>
			</cfif>
		</cfloop>
		<cfset trigStructList = listsort(structkeylist(trigStruct),"textnocase","asc")>
	</cfsilent>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<tr>
		<td class="stableh">NAME</td><td class="stableh">TEXT</td>
	</tr>
	<cfoutput>
	<cfloop list="#trigStructList#" index="name">
	<cfset thisidid = "#rereplace(name,'([^[:alnum:]])','','all')##randrange(1,10000)#">
	<tr>
		<td valign="top">#name#</td><td valign="top"><a href="##" onclick="viewFormCode('code_form_#thisidid#','detailtop'); return false;">View Schema</a></td><form name="code_form_#thisidid#" id="code_form_#thisidid#" action="#dbxr.fullfilepathprefix#?cv=1" target="_blank" method="post"><input type="hidden" name="itemname" value="#name#"><input type="hidden" name="code" value="#htmleditformat(trigStruct[name])#"></form>
	</tr>
	</cfloop>
	</cfoutput>
	</table>
	<cfelse>
	<div class="stableh">None</div>
	</cfif>
	</div>
	<cfif not issys>
	<div id="fulltextdiv" class="pagediv">
	<cfif getobject_fulltext.recordcount>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<tr>
		<td class="stableh">COLID</td><td class="stableh">COLUMN NAME</td><td class="stableh">LANGUAGE</td>
	</tr>
	<cfoutput query="getobject_fulltext">
	<tr>
		<td>#fulltext_colid#</td>
		<td>#fulltext_column_name#</td>
		<td>#fulltext_language#</td>
	</tr>
	</cfoutput>
	</table>
	<cfelse>
	<div class="stableh">None</div>
	</cfif>
	</div>
	<cfelse>
	<div class="stableh">None</div>
	</cfif>
	</cfif>
	<div id="extpropsdiv" class="pagediv">
	<cfif getobject_extprops.recordcount>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<tr>
		<td class="stableh">OBJECT</td><td class="stableh">NAME</td><td class="stableh">VALUE</td><td class="stableh">RETRIEVAL SQL</td>
	</tr>
	<cfoutput query="getobject_extprops">
	<tr>
		<td>#objname# [#lcase(objtype)#]</td>
		<td>#name#</td>
		<td>#value#</td>
		<td>SELECT value<br>FROM <cfif sqlServerVersion eq 2000>::</cfif>fn_listextendedproperty(null, 'user', '#getobject.table_owner#', '<cfif not isdefined("url.v")>table<cfelse>view</cfif>', '#trim(url.oid)#', <cfif objtype eq "column">'column','#objname#'<cfelse>null, null</cfif>)<br>WHERE [name] = '#name#'</td>
	</tr>
	</cfoutput>
	</table>
	<cfelse>
	<div class="stableh">None</div>
	</cfif>
	</div>
	<div id="ddldiv" class="pagediv">
	<cfif isdefined("tvddl") and tvddl.recordcount>
	<!--- allows us to trim the ddl --->
	<cfsavecontent variable="thistvddl"><cfoutput query="tvddl">#FieldValue#</cfoutput><cfif getobject_extprops.recordcount><cfoutput query="getobject_extprops">
EXEC <cfif sqlServerVersion neq 2000>sys.</cfif>sp_addextendedproperty @name=N'#replace(name,"'","''","all")#', @value=N'#replace(value,"'","''","all")#', @level0type=N'<cfif sqlServerVersion neq 2000>SCHEMA<cfelse>USER</cfif>', @level0name=N'#getobject.table_owner#', @level1type=N'<cfif not isdefined("url.v")>TABLE<cfelse>VIEW</cfif>', @level1name=N'#trim(url.oid)#', <cfif objtype eq "column">@level2type=N'COLUMN', @level2name=N'#objname#'<cfelse>@level2type=NULL, @level2name=NULL</cfif>;
	</cfoutput>
	</cfif>
	</cfsavecontent>
	<textarea id="ddldisplay" onfocus="this.select();" style="margin-top: 10px;"><cfoutput>#trim(thistvddl)#</cfoutput></textarea>
	<cfelse>
	<div class="c">Could not generate the DDL statements for this object.</div>
	</cfif>
	</div><cfif val(dbx.dataSampleRows)>
	<div id="datasamplediv" class="pagediv">
	<cfif getobject_datasample.recordcount>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<tr><cfoutput query="getobject"><td class="stableh">#column_name#</td></cfoutput></tr>
	<cfoutput query="getobject_datasample"><cfset gdsrow = currentrow>
	<tr><cfloop query="getobject"><td>#htmleditformat(getobject_datasample[column_name][gdsrow])#</td></cfloop></tr>
	</cfoutput>
	</table>
	<cfelse>
	<div class="stableh c">This object contains no data</div>
	</cfif>
	</div>
	</cfif>
</td></tr>
<cfelse><!--- sp --->
<tr><td class="first">
	<table border="0" cellspacing="0" class="navbar2">
	<tr><td><div class="tab"><cfoutput>#oidname#</cfoutput> <cfif not isdefined("url.fn")>[Procedure]<cfelse>[Function]</cfif></div></td><td class="r"><a href="#" onclick="viewFormCode('code_form','detailtop'); return false;" class="nav" title="View this procedure's schema">VIEW SCHEMA</a><cfif not isdefined("url.fn")><a href="#" onclick="viewFormCode('arggencode_form','detailtop'); return false;" class="nav" title="Generate CFC arguments">GENERATE CFC ARGS</a></cfif><cfif not dbx.guestmode><cfoutput><a href="##" onclick="addExtProperty('#urlencodedformat(trim(url.oid))#',<cfif not isdefined("url.fn")>'sp=1'<cfelse>'fn=1'</cfif>,'extpropmgr'); return false;" class="nav" title="Manage Extended Properties">EXT PROP MANAGER</a></cfoutput></cfif><a href="#" onclick="printTab(); return false;" class="nav" title="Print currently open tab">Print</a></td></tr>
	</table>
</td></tr>
<tr><td class="second">
<!--- <a href="#" onclick="printTab(); return false;" class="iprint">PRINT</a> --->
<div id="pagetabs">
	<a id="parameterstab" href="#" class="pagetab on" onclick="switchTab('parameters'); return false;">Parameters</a>
	<a id="extpropstab" href="#" class="pagetab" onclick="switchTab('extprops'); return false;">Ext Properties</a>
	<a id="ddltab" href="#" class="pagetab" onclick="switchTab('ddl'); return false;">DDL</a>
</div>
</td></tr>
<tr><td class="third" id="third">
	<div id="parametersdiv" class="pagediv">
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<tr><td class="stableh" align=center>POS</td><td class="stableh">PARAM NAME</td><cfif sqlserverVersion neq "7"><td class="stableh" align="center">EXT</td></cfif><td class="stableh">PARAM TYPE</td><td class="stableh">DATATYPE</td><td class="stableh" align="center">NULL</td></tr>
	<cfoutput query="getobject">
				<tr>
						<td align=right>#ordinal_position#&nbsp;</td>
						<cfif sqlserverVersion neq "7">
						<td>&nbsp;#column_name#</td>
<cfsetting enablecfoutputonly="yes">
	<!--- get col specific ext prop info --->
	<cfquery dbtype="query" name="extprop">
		SELECT * FROM getobject_extprops WHERE objname = '#column_name#'<!--- <cfif getobject_extprops.recordcount>objname = '#column_name#'<cfelse>1=0</cfif>  --->
	</cfquery>
<cfsetting enablecfoutputonly="no">
						<td width="5%" align="center" nowrap><cfif extprop.recordcount><a href="##" onmouseover="APP.showGenericDiv('ep#ordinal_position#',window.name);" onmouseout="APP.hideGenericDiv('ep#ordinal_position#',window.name);" onclick="return false;" class="button">~</a><div id="ep#ordinal_position#" class="detaildiv"><table border="0" cellpadding="2" cellspacing="1" class="fly"><tr><td class="flyh" colspan="3">EXTENDED PROPERTIES - #column_name#</td></tr><tr><td class="flyh2">NAME</td><td class="flyh2">VALUE</td></tr><cfloop query="extprop"><tr><td>#name#</td><td>#value#</td></tr></cfloop></table></div><cfelse>&nbsp;</cfif></td>
						<cfelse>
						<td>&nbsp;#column_name#</td>
						</cfif>
						<td>&nbsp;
						<cfswitch expression="#column_type#">
							<cfcase value="1">IN</cfcase>
							<cfcase value="2">OUT</cfcase>
							<cfcase value="3">RESULT COL</cfcase>
							<cfcase value="4">OUTPUT</cfcase>
							<cfcase value="5">RETURN VAL</cfcase>
						<cfdefaultcase>?</cfdefaultcase>
						</cfswitch></td>
						<td>&nbsp;#type_name#(#precision#)</td>
						<td align="center"><cfif nullable>NULL<cfelse>NO</cfif></td>
						
				</tr>
	</cfoutput>
	</table>
	</div>
	<div id="extpropsdiv" class="pagediv">
	<cfif getobject_extprops.recordcount>
	<table border="0" cellpadding="0" cellspacing="1" class="stable">
	<tr>
		<td class="stableh">OBJECT</td><td class="stableh">NAME</td><td class="stableh">VALUE</td><td class="stableh">RETRIEVAL SQL</td>
	</tr>
	<cfoutput query="getobject_extprops">
	<tr>
		<td>#objname# [#lcase(objtype)#]</td>
		<td>#name#</td>
		<td>#value#</td>
		<td>SELECT value<br>FROM <cfif sqlServerVersion eq 2000>::</cfif>fn_listextendedproperty(null, 'user', '#url.owid#', '<cfif not isdefined("url.fn")>procedure<cfelse>function</cfif>', '#trim(url.oid)#', <cfif objtype eq "parameter">'parameter','#objname#'<cfelse>null, null</cfif>)<br>WHERE [name] = '#name#'</td>
	</tr>
	</cfoutput>
	</table>
	<cfelse>
	<div class="stableh">None</div>
	</cfif>
	</div>
	<div id="ddldiv" class="pagediv">
	<cfif isdefined("spddl") and spddl.recordcount>
	<cfsavecontent variable="thisspddl">
	<cfoutput>#spddl.text#</cfoutput>
	</cfsavecontent>
	<cfoutput><textarea id="ddldisplay" onfocus="this.select();" style="margin-top: 10px;">#trim(thisspddl)#</textarea></cfoutput>
	<cfelse>
	<div class="c">Could not generate the DDL statements for this object.</div>
	</cfif>
	</div>
<cfoutput><form name="code_form" id="code_form" action="#dbxr.fullfilepathprefix#?cv=1" target="_blank" method="post"><input type="hidden" name="itemname" value="#oidname#"></cfoutput><input type="hidden" name="code" value="<cfoutput query="spschema">#replace(text,'"','&quot;','all')#</cfoutput>"></form>
<cfsetting enablecfoutputonly="yes">

<!--- cfc arg generator --->
<cfinclude template="../../generator/cfcs/i_arggenerators.cfm">

<cfsetting enablecfoutputonly="no">
<cfoutput><form name="arggencode_form" id="arggencode_form" action="#dbxr.fullfilepathprefix#?cv=1" target="_blank" method="post"><input type="hidden" name="itemname" value="Generated CFC Arguments for #oidname#"><input type="hidden" name="codetype" value="cfml"><input type="hidden" name="code" value="#arggeneratorContent#"></form></cfoutput>
</cfif>
</table>
</body>
</html>