<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
------------------------------------------------------------------ --->

<cfif isdefined("url.dolist")>
		<cftry>
			<!--- try master objects --->
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="masterObjects">
			SELECT ltrim(rtrim(master..sysobjects.name)) as name, ltrim(rtrim(master..sysobjects.type)) as type, ltrim(rtrim(master..sysobjects.status)) as status, ltrim(rtrim(master..sysusers.name)) AS owner FROM master..sysobjects INNER JOIN master..sysusers ON master..sysobjects.uid = master..sysusers.uid ORDER BY type, name
			</cfquery>
		
			<cfcatch>
				<cfset masterObjects = querynew("name,type,status,owner")>
			</cfcatch>
		</cftry>
</cfif>

<cfsetting enablecfoutputonly="no">
<!--- master list page --->
<html>
<head>
	<title>DBX</title><cfoutput>
	<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>
	<script>
	APP = top;
	<cfif isdefined("url.dolist")>
	APP.writeStatus(3);
	</cfif>
	function doList() {
		okRender = confirm('DBX is about to render the master database objects in the object tree.\n\nDepending on your CPU and available memory, rendering all objects in the master database can take up to a minute, since the object tree is DHTML based and rendering is entirely within the browser context. \n\nClick OK to continue the process or Cancel to abort.');
		if(!okRender) { return false; }
		else {<cfoutput>location.href='#dbxr.fullfilepathprefix#?frame=listmaster&dolist=1';</cfoutput>}
	}
	</script>
	
	<cfif isdefined("url.dolist")><cfoutput>
	<script type="text/javascript" src="#dbxr.fullpathprefix#tree/cooltree.js"></script></cfoutput>

	<script type="text/javascript">
	var NAVMASTER_NODES = [
		['Master Objects', null, null,
			['SYSTEM TABLES', null, null,<cfset isSome = 0>
			<cfoutput query="masterobjects"><cfif type eq "S"><cfif not isSome><cfset isSome = 1></cfif>['[#owner#] #name#', '#dbxr.fullfilepathprefix#?frame=detail&oid=#urlencodedformat(name)#&owid=#owner#&master=1', 'detail'],</cfif>
			</cfoutput><cfif not isSome>['none', null, null]</cfif>
			],
			['SYSTEM VIEWS', null, null,<cfset isSome = 0>
			<cfoutput query="masterobjects"><cfif type eq "V"><cfif not isSome><cfset isSome = 1></cfif>['[#owner#] #name#', '#dbxr.fullfilepathprefix#?frame=detail&oid=#urlencodedformat(name)#&owid=#owner#&v=1&master=1', 'detail'],</cfif>
			</cfoutput><cfif not isSome>['none', null, null]</cfif>
			],
			['SYSTEM PROCS', null, null,<cfset isSome = 0>
			<cfoutput query="masterobjects"><cfif type eq "P"><cfif not isSome><cfset isSome = 1></cfif>['[#owner#] #name#', '#dbxr.fullfilepathprefix#?frame=detail&oid=#urlencodedformat(name)#&owid=#owner#&sp=1&master=1', 'detail'],</cfif>
			</cfoutput><cfif not isSome>['none', null, null]</cfif>
			],
			['EXTENDED PROCS', null, null,<cfset isSome = 0>
			<cfoutput query="masterobjects"><cfif type eq "X"><cfif not isSome><cfset isSome = 1></cfif>['[#owner#] #name#', '#dbxr.fullfilepathprefix#?frame=detail&oid=#urlencodedformat(name)#&owid=#owner#&sp=1&master=1', 'detail'],</cfif>
			</cfoutput><cfif not isSome>['none', null, null]</cfif>
			],
			['SYSTEM FUNCTIONS', null, null,<cfset isSome = 0>
			<cfoutput query="masterobjects"><cfif type eq "FN"><cfif not isSome><cfset isSome = 1></cfif>['[#owner#] #name#', '#dbxr.fullfilepathprefix#?frame=detail&oid=#urlencodedformat(name)#&owid=#owner#&sp=1&fn=1', 'detail'],</cfif>
			</cfoutput><cfif not isSome>['none', null, null]</cfif>
			],
		]
	];
		var NAVMASTER_FORMAT = [10,10,true,["tree/c3.gif", "tree/e3.gif", "tree/b.gif"],[16,16,0],false,[],[16,16],[0,16,32,48,64,80,96,112,128,144,160,176,192,208,224,240,256,272],"","clsNode",[],false,[0,0],];
	</script>
	</cfif>
</head>

<body class="list" onload="APP.writeStatus(0);">
<cfif isdefined("url.dolist")>

<script type="text/javascript">
	var navmaster = new COOLjsTree ("NAVMASTER", NAVMASTER_NODES, NAVMASTER_FORMAT);
	navmaster.expandNode(0);
</script>

<cfelse><form>
<table class="full" style="height: 100%;">
<tr><td class="c vm">Master Object Tree is not yet initialized<br><br><input type="button" class="button" value="RENDER NOW" onclick="doList(); return false;"></td></tr>
</table></form>
</cfif>
</body>
</html>