<!--- this template should not catch errors but should throw a hard exception --->

<cfparam name="attributes.dbdsn" type="string" default="">
<cfparam name="attributes.dbuser" type="string" default="">
<cfparam name="attributes.dbpass" type="string" default="">

<!--- database level check --->
<cfquery datasource="#attributes.dbdsn#" username="#attributes.dbuser#" password="#attributes.dbpass#" name="testlogin">
	-- run a db specific dmv; if login doesn't have permissions, it'll throw an exception	
	SELECT TOP 1 * 
	FROM sys.dm_exec_query_stats qs 
		cross apply sys.dm_exec_sql_text(qs.sql_handle) as qt 
		inner join sys.objects so on qt.objectid = so.[object_id]  
	WHERE qt.dbid = DB_ID()  
</cfquery>
	
