<cfset dbx = structnew()>

<!--- ~~~~~~~~~~~ CONFIGURE THE FOLLOWING VARIABLES ~~~~~~~~~~~ --->

		<!--- LOGINPASS: 
				password for accessing this template.  change to empty string "" for unrestricted access. --->
	
<cfset dbx.loginpass = "dbx">

		<!--- IPMASKS: 
				This is a comma delimited list of ip masks to which to restrict access. Access attempts that do not 
				match the patterns are rejected.
				Use * for wildcards.  Valid examples are: 121.22.223.14 or 121.22.*.*.  Can have multiple masks 
				entered in as a list: 200.*.*.*,192.168.*.*
				Leave as empty string "" for unrestricted access. --->
	
<cfset dbx.ipmasks = "">

		<!--- GUESTMODE: 
				Guest mode is a mode of running DBX that reduces overall functionality and features.  If you are 
				in a situation where you need to give another developer view only access into your database and 
				would like to limit the interactive features, turn this on.  
			  
			  With guest mode on, the following features are disabled:
			  	- DSN drop down (the user must enter the dsn name and login info manually)
				- Master DB Objects (this pane, below the user db objects, is not shown)
				- Exec SQL Window (disabled)
				- Script Generator (disabled) 
			
				For standard development work, leave this set to false. --->
	
<cfset dbx.guestmode = false><!--- false - off / true - on --->
		
		<!--- SHOWMASTEROBJECTS: 
				if you want to include the master db's objects in the nav tree, set this to true. 
				This is automatically turned off if guestmode is on.
				WARNING: This will negatively impact performance of the tree load and operation and 
				provides a view into sensitive system information that could help a user compromise your 
				server.  Use it at your own risk. --->
	
<cfset dbx.showMasterObjects = false><!--- false - off / true - on --->

		<!--- SHOWEXECSQL: 
				if you want to include a simple form based sql execution window (for interactively entering 
				sql statements against the datasource) set this to true.  This is automatically turned off if guestmode 
				is on.
				WARNING: This is potentially a security risk and could help a user compromise your 
				server.  Use it at your own risk. --->
	
<cfset dbx.showExecSQL = true><!--- false - off / true - on --->		
		
		<!--- DEBUGGING: 
				if you have debugging turned on for this ip, suppress it if desired (it whacks the js object tree when on) --->
	
<cfset dbx.debugging = false><!--- false - off / true - on --->
		
		<!--- ENCRYPTION KEY: 
				this is the value used in encrypting cookie data; can not be empty; 
				update the value to whatever you wish, but if it is changed, know that any cookies set with the previous
				value will be considered invalid and purged; so, set it and don't change it again if possible --->
				
<cfset dbx.enckey = "dbx123">

		<!--- TOP X ITEMS FOR TUNING TAB: 
				this is the number of items to return in the tuning tab queries --->
				
<cfset dbx.tuningTopX = "25">

		<!--- DEFAULT NAME FOR EXTENDED PROPERTIES: 
				this is used to prepopulate the name attribute of an extended property in the ext prop manager window --->
				
<cfset dbx.defaultExtPropName = "Label">

		<!--- DATA SAMPLING ROW COUNT: 
				number of rows to show in Data Sample tab for tables/views; set to 0 to disable data sampling entirely --->
				
<cfset dbx.dataSampleRows = 50>

