<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
------------------------------------------------------------------ --->

<!--- used for resetting db scope in case an uncaught error (with viewing master objects) loses the db focus --->
	<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="resetDB">
		SELECT db_name() AS theDBName;
	</cfquery>
	
	<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="ver">
		SELECT ServerProperty('ProductVersion') AS theVersion
	</cfquery>
	
	<!--- parse the version --->
	<cfset dsnSqlVersion = "">
	<cfset tempVersion = listfirst(ver.theVersion,".")>
	<cfif tempVersion eq "10">
		<cfset dsnSqlVersion = " [SQL2008]">
	<cfelseif tempVersion eq "9">
		<cfset dsnSqlVersion = " [SQL2005]">
	<cfelseif tempVersion eq "8">
		<cfset dsnSqlVersion = " [SQL2000]">
	</cfif>
	
<cfsetting enablecfoutputonly="no">
<html>
<head><cfoutput>
	<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css">
	<script type="text/javascript" src="#dbxr.fullpathprefix#js/dbx_local.js"></script></cfoutput>
	<script>
	APP = top;
	<cfoutput>
		function about() {
			alertText = "DBX - DB Schema Descriptor\n";
			alertText += "Version: #dbx.version# - #dbx.versiondate#\n\n";
			alertText += "Copyright 2002-#year(now())# Kevin J. Miller and websolete.com\n";
			alertText += "All rights reserved worldwide.\n\n";
			alertText += "http://www.websolete.com";
			alert(alertText);
		}</cfoutput>
		
		function getRand() {
			return Math.random();
		}
		
		function launchSQLExecWindow() {
			var winName = getRand().toString();
			winName = 'sqlexec' + winName.substr(2);
			<cfoutput>openWindow('#dbxr.fullfilepathprefix#?se=1',winName);</cfoutput>
		}
		
		function launchTuningManager(objwinname) {
			<cfoutput>openPopup('#dbxr.fullfilepathprefix#?tuning=1',objwinname,700,1200);</cfoutput>
		}
	</script>
</head>
<body>

<div class="tabbar"><cfif len(dbx.loginpass)><div class="flr"><cfoutput><a href="#dbxr.fullfilepathprefix#?lo=1" target="_parent" id="logout" title="Logout from DBX" onmouseover="window.status='Logout';return true;" onmouseout="window.status='';return true;">LOGOUT</a></cfoutput></div></cfif>DBX <cfoutput>#dbx.version#</cfoutput></div>
<table cellspacing="0" border="0" class="navbar">
<tr><td><div class="tab">ACTIVE DSN: <cfoutput><span class="w">#dbdsn#</span>#dsnSqlVersion#</cfoutput></div></td><td class="r nowrap"><cfoutput><a href="#dbxr.fullfilepathprefix#?sw=1" target="_parent" id="switchdsn" title="Switch to another Datasource">DATASOURCE</a><cfif not dbx.guestmode><a href="#dbxr.fullfilepathprefix#?frame=detail&cfg=1" target="detail" id="servercrv" onclick="APP.writeStatus(1);" title="Server Information">SERVER</a><a href="#dbxr.fullfilepathprefix#?frame=detail&dbcfg=1" target="detail" id="dbcfg" onclick="APP.writeStatus(1);" title="Database Information">DATABASE</a><cfif tempVersion gte 9><a href="##" onclick="launchTuningManager('tuningmanager'); return false;" id="tuning" title="Tuning">TUNING</a></cfif><a href="#dbxr.fullfilepathprefix#?frame=detail&reports=1" target="detail" id="reports" title="Reports">REPORTS</a><!--- <a href="#dbxr.fullfilepathprefix#?frame=detail&sg=1" target="detail" id="scriptgen" title="Script Generator">GENERATOR</a> ---><cfif dbx.showExecSQL><a href="##" onclick="launchSQLExecWindow(); return false;" id="execsql" title="SQL Execution Window">EXEC SQL</a></cfif></cfif><a href="#dbxr.fullfilepathprefix#?frame=detail&search=1" target="detail" id="objsearch" title="Object Search">SEARCH</a><a href="#dbxr.fullfilepathprefix#?resetdb=#urlencodedformat(resetdb.theDBName)#" target="_parent" id="reload" title="Reload DBX">RELOAD</a><a href="#dbxr.fullfilepathprefix#?frame=detail" target="detail" id="help" title="Help">HELP</a><a href="##" onclick="about(); return false;" id="about" title="About DBX">ABOUT</a></cfoutput></td></tr>
</table>
</body>
</html>