<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
------------------------------------------------------------------ --->

<cftry>
	
	<!--- verify version --->
	<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="ver">
		SELECT ServerProperty('ProductVersion') AS theVersion
	</cfquery>
	
	<!--- parse the version --->
	<cfset dsnSqlVersion = "">
	<cfset tempVersion = listfirst(ver.theVersion,".")>
	<cfif val(tempVersion) gte 11>
		<cfset dsnSqlVersion = " [SQL2012]">
	<cfelseif tempVersion eq "10">
		<cfset dsnSqlVersion = " [SQL2008]">
	<cfelseif tempVersion eq "9">
		<cfset dsnSqlVersion = " [SQL2005]">
	<cfelseif tempVersion eq "8">
		<cfset dsnSqlVersion = " [SQL2000]">
	<cfelse>
		<!--- UNSUPPORTED VERSION --->
		<cfinclude template="../sqlserver/i_unsupported.cfm">
	</cfif>
	
	<cfstoredproc procedure="sp_tables" datasource="#dbxr.trydsn#" username="#form.dbuser#" password="#form.dbpass#">
		<cfprocresult name="getobjects" resultset="1">
	</cfstoredproc> 	

	<cfcatch>
		<cfset dbxr.dsnok = false>
	</cfcatch>		
</cftry>
				
<cfsetting enablecfoutputonly = "no">