<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
		9.0.8 - 5/25/2007 - Kevin Miller - updated for sql2005 in specific locations
		9.0.9 - 6/9/2007 - Kevin Miller - updates for sql2005 compatibility issues found
------------------------------------------------------------------ --->

<cfset issys = false>
<cfif isdefined("url.sys")>
	<cfset issys = true>
</cfif>

<cfhtmlhead text="<script>if(window.APP) { APP.clearErrors(); }</script>">

		<!--- we need this to set the db back to the default dsn db after querying master objects --->
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="defaultdb">
			SELECT DB_NAME() AS name;
		</cfquery>
		
		<!--- verify version --->
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="ver">
			SELECT ServerProperty('ProductVersion') AS theVersion
		</cfquery>
		
		<!--- parse the version --->
		<cfset sqlServerVersion = "">
		<cfset tempVersion = listfirst(ver.theVersion,".")>
		<cfif val(tempVersion) gte 11>
			<cfset sqlServerVersion = "2012">
		<cfelseif tempVersion eq "10">
			<cfset sqlServerVersion = "2008">
		<cfelseif tempVersion eq "9">
			<cfset sqlServerVersion = "2005">
		<cfelseif tempVersion eq "8">
			<cfset sqlServerVersion = "2000">
		<cfelse>
			<!--- UNSUPPORTED VERSION --->
			<cfinclude template="../sqlserver/i_unsupported.cfm">
		</cfif>

		<cfinclude template="#sqlServerVersion#/objectqueries.cfm">

<cfsetting enablecfoutputonly = "no">