<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
------------------------------------------------------------------ --->

<cfparam name="reportNAME" type="string" default="">

<cfinclude template="i_getdbversion.cfm">

<cfsetting enablecfoutputonly = "no">

<cfif not isdefined("url.gen")><!--- not generating, show options page --->
<html>
<head>
	<title>DBX</title><cfoutput>
	<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>
	<script type="text/javascript">
		APP = top; 

			// page tabs
			var proftabs = new Array('reports');
			var activetab = 'reports'; 
			
			function switchTab(which) { 
				var which = (which != null) ? which : activetab; 
				
				for(var i=0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div') /* && document.getElementById(proftabs[i] + 'tab') */) { 
						if(proftabs[i] == which) { 
							document.getElementById(proftabs[i] + 'div').className = 'pagedivon'; 
							// document.getElementById(proftabs[i] + 'tab').className = 'pagetab on';
							activetab = which; 
						}
						else { 
							document.getElementById(proftabs[i] + 'div').className = 'pagediv'; 
							// document.getElementById(proftabs[i] + 'tab').className = 'pagetab';		
						}
					}
				}
			}
	
			function setDivScrollers() { 
				var thirdheight = document.getElementById('third').offsetHeight; 
				for(var i = 0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div')) { 
							document.getElementById(proftabs[i] + 'div').style.height = thirdheight; 
					}
				}
			}
	
			function doresize() { 
				for(var i = 0; i < proftabs.length; i++) { 
					if(document.getElementById(proftabs[i] + 'div')) { 
						document.getElementById(proftabs[i] + 'div').style.height = '1px'; 
					}
				}
				setDivScrollers(); 
				switchTab(activetab); 
			}
			onresize = doresize;
	</script>
</head>

<body onload="APP.writeStatus(0); setDivScrollers(); switchTab(activetab);">

<table id="sourcelayout" border="0" cellpadding="0" cellspacing="0">
<tr><td class="first">
	<table border="0" cellspacing="0" class="navbar2">
	<tr><td><div class="tab">Reports</div></td></tr>
	</table>
</td>
</tr>
<tr><td class="third" id="third">
<div id="reportsdiv" class="pagediv">
	
<!--- 3 column blank report --->
<table border="0" cellpadding="3" cellspacing="0" align="center" width="100%">
<tr><td colspan="3"><div class="stitle">3 Column Blank Object Listing Report (Print-style)</div></td></tr>
<tr><td colspan="3"><p>
This report returns a tabular listing of the database objects selected below, opened in a new window.  The report has three empty columns for your own use, and is intended for printing.</p><p>This report is useful for printing out a listing of current database objects in a format that allows you to make handwritten notes regarding steps you may need to do or have done (I find this useful for performing upgrades or maintenance and want to keep track of what I've done as I go).</p>
</td></tr>
<cfoutput><form action="#dbxr.fullfilepathprefix#?frame=detail&reports=1&gen=1" method="post" target="_blank"></cfoutput>
<tr><td colspan="3" align="center"><br><span class="heavy">Select Objects to Include:</span><input type="text" name="ssr" placeholder="Optional object name filter" style="width: 180px; margin-left: 20px;"></td></tr>
<tr><td valign="top" align="right">
<table border="0" cellpadding="3" cellspacing="0">
<tr><td><label for="a1">User Tables:</label></td><td><input type="checkbox" id="a1" name="inclUserTables" value="1" checked></td></tr>
<tr><td><label for="a2">User Views:</label></td><td><input type="checkbox" id="a2" name="inclUserViews" value="1" checked></td></tr>
<tr><td><label for="a3">User Procedures:</label></td><td><input type="checkbox" id="a3" name="inclUserProcs" value="1" checked></td></tr>
<tr><td><label for="a4">User Functions:</label></td><td><input type="checkbox" id="a4" name="inclUserFunctions" value="1" checked></td></tr>
</table>
</td>
<td width="20">&nbsp;</td>
<td valign="top">
<table border="0" cellpadding="3" cellspacing="0">
<tr><td><label for="a5">System Tables:</label></td><td><input type="checkbox" id="a5" name="inclSysTables" value="1"></td></tr>
<tr><td><label for="a6">System Views:</label></td><td><input type="checkbox" id="a6" name="inclSysViews" value="1"></td></tr>
<tr><td><label for="a7">System Procedures:</label></td><td><input type="checkbox" id="a7" name="inclSysProcs" value="1"></td></tr>
</table>
</td></tr>
<tr><td colspan="3" align="center"><br><input type="hidden" name="reportNAME" value="3colblank"><input type="submit" value=" Generate Report " class="button"></td></tr>
</form>
</table>
<br>
<hr size="1" width="100%" style="color: #333333">
<br>
<!--- generic schema report --->
<table border="0" cellpadding="3" cellspacing="0" align="center" width="100%">
<cfoutput><form action="#dbxr.fullfilepathprefix#?frame=detail&reports=1&gen=1" method="post" target="_blank"></cfoutput>
<tr><td colspan="3"><div class="stitle">Generic Object Schema Report (Print-style)</div></td></tr>
<tr><td colspan="3"><p>
The report shows column/param values for each item, opened in a new window. This report is useful for printing out a listing of current database object schema's for use in external documents, and is very similar to the standard detail view used for viewing table/view/proc/function schemata elsewhere in DBX.</p><p>Output can be either in a table format, with columns of data, or a simpler text output of data, or formatted for copy/paste into Confluence (using Markup macro), selectable below.</p>
</td></tr>
<tr><td valign="top" align="right">
<table border="0" cellpadding="3" cellspacing="0">
<tr><td colspan="2"><br><span class="heavy">Select Objects to Include:</span><br><br></td><td rowspan="5" valign="top"><br><input type="text" name="ssr" placeholder="Optional object name filter" style="width: 180px; margin-left: 20px;"><br><br></td></tr>
<tr><td><label for="a8">User Tables:</label></td><td><input type="checkbox" id="a8" name="inclUserTables" value="1" checked></td></tr>
<tr><td><label for="a9">User Views:</label></td><td><input type="checkbox" id="a9" name="inclUserViews" value="1"></td></tr>
<tr><td><label for="a10">User Procedures:</label></td><td><input type="checkbox" id="a10" name="inclUserProcs" value="1"></td></tr>
<tr><td><label for="a11">User Functions:</label></td><td><input type="checkbox" id="a11" name="inclUserFunctions" value="1"></td></tr>
</table>
</td>
<td width="20">&nbsp;</td>
<td valign="top">
<table border="0" cellpadding="3" cellspacing="0">
<tr><td colspan="2"><br><span class="heavy">Output Style:</span></td></tr>
<tr><td><label for="ot1">Output in table, columnar:</label></td><td><input type="radio" id="ot1" name="outputType" value="table" checked></td></tr>
<tr><td><label for="ot2">Output in text, tabbed:</label></td><td><input type="radio" id="ot2" name="outputType" value="tab"></td></tr>
<tr><td><label for="ot3">Output in Confluence markup:</label></td><td><input type="radio" id="ot3" name="outputType" value="confluence"></td></tr>
<tr><td><label for="ot4">Output in MediaWiki markup:</label></td><td><input type="radio" id="ot4" name="outputType" value="mediawiki"></td></tr>
</table>
<table border="0" cellpadding="3" cellspacing="0">
<tr><td colspan="2"><br><span class="heavy">Miscellaneous:</span></td></tr>
<tr><td><label for="sri">Show index info for tables (columns):</label></td><td><input type="checkbox" id="sri" name="showIndexes" value="1" checked></td></tr> 
<tr><td><label for="srt">Show row size totals (tables):</label></td><td><input type="checkbox" id="srt" name="showRowTotal" value="1"></td></tr> 
<tr><td><label for="srn">Add Notes column for table output:</label></td><td><input type="checkbox" id="srn" name="addNotes" value="1"></td></tr> 
</table>
</td>
</tr>
<tr><td align="center" colspan="3"><br><input type="hidden" name="reportNAME" value="genericschema"><input type="submit" value=" Generate Report " class="button"></td></tr>
</form>
</table>
<br>
<hr size="1" width="100%" style="color: #333333">
<br>
<!--- current index report --->
<table border="0" cellpadding="3" cellspacing="0" align="center" width="100%">
<tr><td colspan="3"><div class="stitle">Index Report (Print-style)</div></td></tr>
<tr><td colspan="3"><p>
The report shows current index information for each table, opened in a new window. This report is useful for printing out a listing of current indexes for review during tuning efforts. (SQL2005 and higher only)</p>
</td></tr>
<tr><td valign="top" align="center">
<cfoutput><form action="#dbxr.fullfilepathprefix#?frame=detail&reports=1&gen=1" method="post" target="_blank"></cfoutput>
<table border="0" cellpadding="3" cellspacing="0" style="width: 25%; margin: 0 auto;">
<tr><td colspan="2"><br><span class="heavy">Output Style:</span></td></tr>
<tr><td><label for="iot1">Output in table, columnar:</label></td><td><input type="radio" id="iot1" name="outputType" value="table" checked></td></tr>
<tr><td><label for="iot3">Output in Confluence markup:</label></td><td><input type="radio" id="iot3" name="outputType" value="confluence"></td></tr>
<tr><td><label for="iot4">Output in MediaWiki markup:</label></td><td><input type="radio" id="iot4" name="outputType" value="mediawiki"></td></tr>
</table>

<br><input type="hidden" name="reportNAME" value="index"><input type="submit" value=" Generate Report " class="button"<cfif sqlServerVersion lte 2000> disabled</cfif>></form></td></tr>

</table>

</div>
</td></tr>
</table>
</body>
</html>
<cfelse><!--- generating report --->

	<!--- optional search string --->
	<cfparam name="ssr" type="string" default="">
	<cfset ssr = trim(ssr)>

	<cfinclude template="udf/udf_FindList.cfm">
	
		<!--- much better routine 5/10/2003 --->
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="allObjects">
		SELECT ltrim(rtrim(s.name)) as name, ltrim(rtrim(s.type)) as type, ltrim(rtrim(s.status)) as status, ltrim(rtrim(su.name)) AS owner, s.id AS object_id FROM sysobjects s INNER JOIN sysusers su ON s.uid = su.uid ORDER BY type, name
		</cfquery>
			
<html>
<head>
	<title>DBX</title>
	<style>
			body { background-color: #ffffff; font-family : sans-serif; font-size : 10px; color : #000000; }	
			table,ul,p,li,div,span { font-family : sans-serif; font-size : 11px; color : #000000; }
			td.header { background-color: #f3f3f3; font-family : sans-serif; font-size : 9pt; color : #666666; font-weight: bold; padding: 4px; }
			table.bordered { background-color: #cccccc; }	
			/*table.bordered td { vertical-align: top; }*/
			td { background-color: #ffffff; font-family : sans-serif; font-size : 11px; color : #000000; vertical-align: middle; }
			.heavy { font-weight: bold; }
			.label { font-size: 12px; line-height: 16px; } 
			.r { text-align: right; } 
			.c { text-align: center; } 
			sup { color: #999999;  } 
			.d { color: #000000 !important; background: #e9e9e9 !important; }
			span.warning, span.warning span { color: #ff0000 !important; }
	</style>
	<body>

	<cfswitch expression="#reportName#">
		<cfcase value="3colblank">
			<cfinclude template="i_reports_3colblank.cfm">
		</cfcase>
		<cfcase value="genericschema">
			<cfinclude template="i_reports_genericschema.cfm">
		</cfcase>	
		<cfcase value="index">
			<cfinclude template="i_reports_indexes.cfm">	
		</cfcase>
		<cfdefaultcase>
			<!--- nothing --->
		</cfdefaultcase>
	</cfswitch>	
		
</body>
</html>
</cfif>
<cfif not dbx.debugging>
	<cfsetting showdebugoutput="no">
</cfif>