<cftry>
<span class="heavy">OBJECT SCHEMA: <cfoutput>#dbdsn#</cfoutput></span>
	
	<cfif isdefined("form.inclUserTables")>
	<br><br>
	<span class="heavy">USER TABLES</span>
	<br><br>
	<cfloop query="allobjects"><cfif not len(ssr) or findlist(ssr,name)>
	<cfif type eq "U" and status gte 0>
	
	<cfsetting enablecfoutputonly="yes">
		<cfset tname = trim(name)>
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject">
			EXEC sp_columns '#trim(name)#';
		</cfquery>		

		<!--- compensate for crappy handling of (n)varchar(max) datatypes --->
		<cfloop query="getobject">
			<cfif getobject.DATA_TYPE eq -1>

				<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getupdateobject">
					SELECT   
						c.DATA_TYPE,  
						c.CHARACTER_MAXIMUM_LENGTH 
					FROM INFORMATION_SCHEMA.COLUMNS c
						JOIN sys.columns sc ON c.TABLE_NAME = OBJECT_NAME(sc.object_id) AND c.COLUMN_NAME = sc.Name 
						JOIN sys.types st ON COALESCE(c.DOMAIN_NAME,c.DATA_TYPE) = st.name
						LEFT OUTER JOIN sys.objects dobj ON dobj.object_id = sc.default_object_id AND dobj.type = 'D' 
					WHERE c.TABLE_NAME = <cfqueryparam cfsqltype="cf_sql_varchar" value="#tname#" null="false"> 
						AND c.COLUMN_NAME = <cfqueryparam cfsqltype="cf_sql_varchar" value="#trim(getobject.COLUMN_NAME)#" null="false"> 
				</cfquery>

				<cfif getupdateobject.recordcount>
					<cfset querysetcell(getobject,"TYPE_NAME",getupdateobject.DATA_TYPE,getobject.currentrow)>
					<cfset querysetcell(getobject,"LENGTH",getupdateobject.CHARACTER_MAXIMUM_LENGTH,getobject.currentrow)>
					<!--- <cfif listfindnocase("varchar,nvarchar",getupdateobject.DATA_TYPE)>
						<cfset querysetcell(getobject,"PRECISION","max",getobject.currentrow)>
					</cfif> --->
				</cfif>

			</cfif> 
		</cfloop>
		
	<cfsetting enablecfoutputonly="no">
	<cfset icols = 5>
	<cfif isdefined("form.showIndexes") and val(form.showIndexes)>
	<cfset icols = icols + 1>
	</cfif>
	<cfif isdefined("form.addNotes") and val(form.addNotes)>
	<cfset icols = icols + 1>
	</cfif>
	<cfset rowByteTotal = 0>
	<cfif form.outputType eq "table">
	<table border="0" cellpadding="2" cellspacing="1" class="bordered" width="100%">
	<tr><cfoutput><td class="header d" colspan="#icols#">#owner#.#name#</cfoutput></td></tr>
	<tr>
		<td class="header" align="center" width="5%">POS</td>
		<td class="header" width="20%">COLUMN NAME</td>
		<td class="header" width="10%">DATATYPE</td>
		<td class="header" align="center" width="5%">NULL</td>
		<td class="header" width="20%">DEFAULT VALUE</td><cfif isdefined("form.showIndexes") and val(form.showIndexes)>
		<td class="header">INDEXES</td></cfif><cfif isdefined("form.addNotes") and val(form.addNotes)>
		<td class="header" width="20%">NOTES</td></cfif>
	</tr><cfset tname = name>
	<cfoutput query="getobject">
	<cfif isdefined("form.showIndexes") and val(form.showIndexes)>
			<!--- 
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="index_details">
			EXEC sp_helpindex '#trim(name)#';
		</cfquery>
		 --->
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_indexes">
			SELECT 
				so.name AS tableName, 
				si.name AS indexName, 
				si.rows, 
				sc.name AS colName, 
				sik.indid,
				sik.keyno 
			FROM 
				sys.sysobjects so
				INNER JOIN sys.sysindexes si ON so.id = si.id 
				INNER JOIN sys.sysindexkeys sik ON so.id = sik.id 
				INNER JOIN sys.syscolumns sc ON so.id = sc.id AND sik.colid = sc.colid AND sik.indid = si.indid 
			WHERE so.name = '#tname#' AND sc.name = '#column_name#' 
				AND so.type = 'U'  
				AND si.name NOT LIKE '_wa_sys%'
				AND si.impid <> -1 
			ORDER BY so.name, sc.colorder, sik.indid, si.name, sik.keyno 
		</cfquery>
		
	</cfif>
	<tr>
			<td class="r">#ordinal_position#&nbsp;</td>
			<td>&nbsp;#column_name#</td>
			<td>&nbsp;#type_name#(<cfif listfindnocase("varchar,nvarchar",type_name) and precision gt 8000>max<cfelse>#precision#</cfif>)</td><cfset rowByteTotal = rowByteTotal + length>
			<td class="c"><cfif nullable>NULL<cfelse>NO</cfif></td>
			<td>&nbsp;<cfif len(column_def)>#column_def#<cfelse>&nbsp;</cfif></td><cfif isdefined("form.showIndexes") and val(form.showIndexes)>
			<td><cfif getobject_indexes.recordcount><cfloop query="getobject_indexes">#getobject_indexes.indexName# <sup>(#getobject_indexes.keyno#)</sup><br></cfloop></cfif></td>
			</cfif><cfif isdefined("form.addNotes") and val(form.addNotes)>
			<td>&nbsp;</td></cfif>
	</tr>
	</cfoutput>
	<cfif isdefined("form.showRowTotal")>
	<tr><td colspan="2" align="right" class="header">Row Total Size (bytes)</td><cfoutput><td colspan="#(icols-2)#">#rowByteTotal#</cfoutput></td>
	</cfif>
	</table>
	<cfelseif form.outputType eq "tab">
	<pre><span class="heavy"><cfoutput>#owner#.#name#</cfoutput></span><cfset tname = name><cfoutput query="getobject"><cfsilent>
	<cfif isdefined("form.showIndexes") and val(form.showIndexes)>
			<!--- 
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="index_details">
			EXEC sp_helpindex '#trim(name)#';
		</cfquery>
		 --->
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_indexes">
			SELECT 
				so.name AS tableName, 
				si.name AS indexName, 
				si.rows, 
				sc.name AS colName, 
				sik.indid,
				sik.keyno 
			FROM 
				sys.sysobjects so
				INNER JOIN sys.sysindexes si ON so.id = si.id 
				INNER JOIN sys.sysindexkeys sik ON so.id = sik.id 
				INNER JOIN sys.syscolumns sc ON so.id = sc.id AND sik.colid = sc.colid AND sik.indid = si.indid 
			WHERE so.name = '#tname#' AND sc.name = '#getobject.column_name#' 
				AND so.type = 'U'  
				AND si.name NOT LIKE '_wa_sys%'
				AND si.impid <> -1 
			ORDER BY so.name, sc.colorder, sik.indid, si.name, sik.keyno 
		</cfquery>
		
	</cfif></cfsilent>#chr(10)##chr(9)#<span class="heavy">#column_name#</span> #type_name#(#precision#) <cfif nullable>NULL<cfelse>NOT NULL</cfif> <cfif len(column_def)>#column_def#</cfif><cfif icols eq 6 and getobject_indexes.recordcount> [ #getobject_indexes.indexName# (#getobject_indexes.keyno#) ]</cfif><cfset rowByteTotal = rowByteTotal + length></cfoutput><cfif isdefined("form.showRowTotal")><cfoutput>#chr(10)##chr(9)##repeatstring("-",50)##chr(10)##chr(9)#<span class="heavy">Row Total Size (bytes):</span> #rowByteTotal#</cfoutput></cfif>
	</pre>
	<cfelseif form.outputType eq "confluence">
<pre>h3. <cfoutput>#owner#.#name#</cfoutput>
||POS||COLUMN NAME||DATATYPE||NULL||DEFAULT VALUE||<cfif isdefined("form.showIndexes") and val(form.showIndexes)>INDEXES||</cfif><cfif isdefined("form.addNotes") and val(form.addNotes)>NOTES||</cfif><cfset tname = name><cfoutput query="getobject"><cfsilent>
	<cfif isdefined("form.showIndexes") and val(form.showIndexes)>
			<!--- 
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="index_details">
			EXEC sp_helpindex '#trim(name)#';
		</cfquery>
		 --->
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_indexes">
			SELECT 
				so.name AS tableName, 
				si.name AS indexName, 
				si.rows, 
				sc.name AS colName, 
				sik.indid,
				sik.keyno 
			FROM 
				sys.sysobjects so
				INNER JOIN sys.sysindexes si ON so.id = si.id 
				INNER JOIN sys.sysindexkeys sik ON so.id = sik.id 
				INNER JOIN sys.syscolumns sc ON so.id = sc.id AND sik.colid = sc.colid AND sik.indid = si.indid 
			WHERE so.name = '#tname#' AND sc.name = '#column_name#' 
				AND so.type = 'U'  
				AND si.name NOT LIKE '_wa_sys%'
				AND si.impid <> -1 
			ORDER BY so.name, sc.colorder, sik.indid, si.name, sik.keyno 
		</cfquery>
		
	</cfif>
	<cfset rowByteTotal = rowByteTotal + length>
	</cfsilent>
|#ordinal_position#|#column_name#|#type_name#(#precision#)|<cfif nullable>NULL<cfelse>NO</cfif>|<cfif len(column_def)>#column_def#</cfif> |<cfif isdefined("form.showIndexes") and val(form.showIndexes)><cfif getobject_indexes.recordcount><cfloop query="getobject_indexes">#getobject_indexes.indexName# ^(#getobject_indexes.keyno#)^ \\ </cfloop></cfif> |</cfif><cfif isdefined("form.addNotes") and val(form.addNotes)> |</cfif></cfoutput></pre>
	<cfelseif form.outputType eq "mediawiki">
<pre>===<cfoutput>#owner#.#name#</cfoutput>===
{| class="wikitable"
!POS!!COLUMN NAME!!DATATYPE!!NULL!!DEFAULT VALUE<cfif isdefined("form.showIndexes") and val(form.showIndexes)>!!INDEXES</cfif><cfif isdefined("form.addNotes") and val(form.addNotes)>!!NOTES</cfif><cfset tname = name><cfoutput query="getobject"><cfsilent>
	<cfif isdefined("form.showIndexes") and val(form.showIndexes)>
			<!--- 
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="index_details">
			EXEC sp_helpindex '#trim(name)#';
		</cfquery>
		 --->
		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject_indexes">
			SELECT 
				so.name AS tableName, 
				si.name AS indexName, 
				si.rows, 
				sc.name AS colName, 
				sik.indid,
				sik.keyno 
			FROM 
				sys.sysobjects so
				INNER JOIN sys.sysindexes si ON so.id = si.id 
				INNER JOIN sys.sysindexkeys sik ON so.id = sik.id 
				INNER JOIN sys.syscolumns sc ON so.id = sc.id AND sik.colid = sc.colid AND sik.indid = si.indid 
			WHERE so.name = '#tname#' AND sc.name = '#column_name#' 
				AND so.type = 'U'  
				AND si.name NOT LIKE '_wa_sys%'
				AND si.impid <> -1 
			ORDER BY so.name, sc.colorder, sik.indid, si.name, sik.keyno 
		</cfquery>
		
	</cfif>
	<cfset rowByteTotal = rowByteTotal + length>
	</cfsilent>
|-
|#ordinal_position#
|#column_name#
|#type_name#(#precision#)
|<cfif nullable>NULL<cfelse>NO</cfif>
|<cfif len(column_def)>#column_def#</cfif> 
|<cfif isdefined("form.showIndexes") and val(form.showIndexes)><cfif getobject_indexes.recordcount><cfloop query="getobject_indexes">#getobject_indexes.indexName# <sup>(#getobject_indexes.keyno#)</sup>
</cfloop></cfif> </cfif><cfif isdefined("form.addNotes") and val(form.addNotes)>
| </cfif></cfoutput>
|}
</pre>
	</cfif>
	<br>
	</cfif></cfif>
	</cfloop>
	</cfif>
	
	<cfif isdefined("form.inclUserViews")>
	<br><br>
	<span class="heavy">USER VIEWS</span>
	<br><br>
	<cfloop query="allobjects"><cfif not len(ssr) or findlist(ssr,name)>
	<cfif type eq "V" and status gte 0>
	
	<cfsetting enablecfoutputonly="yes">

		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject">
			EXEC sp_columns '#trim(name)#';
		</cfquery>
		
	<cfset icols = 4> 
	<cfif isdefined("form.addNotes") and val(form.addNotes)>
	<cfset icols = icols + 1>
	</cfif>

	<cfsetting enablecfoutputonly="no">
	<cfif form.outputType eq "table">
	<table border="0" cellpadding="2" cellspacing="1" class="bordered" width="100%">
	<tr><cfoutput><td class="header" colspan="#icols#">#owner#.#name#</cfoutput></td></tr>
	<tr>
		<td class="header" align="center">POS</td>
		<td class="header">COLUMN NAME</td>
		<td class="header">DATATYPE</td>
		<td class="header" align="center">NULL</td><cfif isdefined("form.addNotes") and val(form.addNotes)>
		<td class="header">NOTES</td></cfif>
	</tr>
	<cfoutput query="getobject">
	<tr>
			<td align="right" width="3%">#ordinal_position#&nbsp;</td>
			<td width="47%">&nbsp;#column_name#</td>
			<td width="25%">&nbsp;#type_name#(#precision#)</td>
			<td align="center" width="5%"><cfif nullable>NULL<cfelse>NO</cfif></td><cfif isdefined("form.addNotes") and val(form.addNotes)>
			<td width="20%">&nbsp;</td></cfif>
	</tr>
	</cfoutput>
	</table>
	<cfelseif form.outputType eq "tab">
	<pre><span class="heavy"><cfoutput>#owner#.#name#</cfoutput></span><cfoutput query="getobject">#chr(10)##chr(9)#<span class="heavy">#column_name#</span> #type_name#(#precision#) <cfif nullable>NULL<cfelse>NOT NULL</cfif> </cfoutput>
	</pre>
	<cfelseif form.outputType eq "confluence">
<pre>h3. <cfoutput>#owner#.#name#</cfoutput>
||POS||COLUMN NAME||DATATYPE||NULL||<cfif isdefined("form.addNotes") and val(form.addNotes)>NOTES||</cfif><cfoutput query="getobject">
|#ordinal_position#|#column_name#|#type_name#(#precision#)|<cfif nullable>NULL<cfelse>NO</cfif>|<cfif isdefined("form.addNotes") and val(form.addNotes)> |</cfif></cfoutput></pre>
	</cfif>
	<br>
	</cfif></cfif>
	</cfloop>
	</cfif>
	
	<cfif isdefined("form.inclUserProcs")>
	<br><br>
	<span class="heavy">USER PROCEDURES</span>
	<br><br>
	<cfloop query="allobjects"><cfif not len(ssr) or findlist(ssr,name)>
	<cfif type eq "P" and status gte 0>
		<cfsetting enablecfoutputonly="yes">
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject">
					EXEC sp_sproc_columns '#trim(name)#';
			</cfquery>
		
			<cfset icols = 4> 
			<cfif isdefined("form.addNotes") and val(form.addNotes)>
			<cfset icols = icols + 1>
			</cfif>
		<cfsetting enablecfoutputonly="no">
	<cfif form.outputType eq "table">
	<table border="0" cellpadding="2" cellspacing="1" width="100%" class="bordered">
	<tr><cfoutput><td class="header" colspan="#icols#">#owner#.#name#</cfoutput></td></tr>
	<tr>
		<td class="header" align="center">POS</td>
		<td class="header">PARAM NAME</td>
		<td class="header">PARAM TYPE</td>
		<td class="header">DATATYPE</td><cfif isdefined("form.addNotes") and val(form.addNotes)>
		<td class="header">NOTES</td></cfif>
	</tr>
	<cfoutput query="getobject">
	<tr>
		<td align="right" width="3%">#ordinal_position#&nbsp;</td>
		<td width="47%">&nbsp;#column_name#</td>
		<td width="10%">&nbsp;
			<cfswitch expression="#column_type#">
				<cfcase value="1">IN</cfcase>
				<cfcase value="2">OUT</cfcase>
				<cfcase value="3">RESULT COL</cfcase>
				<cfcase value="4">OUTPUT</cfcase>
				<cfcase value="5">RETURN VAL</cfcase>
			<cfdefaultcase>?</cfdefaultcase>
			</cfswitch></td>
			<td>&nbsp;#type_name#(#precision#)</td><cfif isdefined("form.addNotes") and val(form.addNotes)>
			<td width="20%">&nbsp;</td></cfif>
		</tr>
	</cfoutput>
	</table>	
	<cfelseif form.outputType eq "tab">
	<pre><span class="heavy"><cfoutput>#owner#.#name#</cfoutput></span><cfoutput query="getobject">#chr(10)##chr(9)#<span class="heavy">#column_name#</span> <cfswitch expression="#column_type#"><cfcase value="1">IN</cfcase><cfcase value="2">OUT</cfcase><cfcase value="3">RESULT COL</cfcase><cfcase value="4">OUTPUT</cfcase><cfcase value="5">RETURN VAL</cfcase><cfdefaultcase>?</cfdefaultcase></cfswitch> #type_name#(#precision#)</cfoutput></pre>
	<cfelseif form.outputType eq "confluence">
<pre>h3. <cfoutput>#owner#.#name#</cfoutput>
||POS||PARAM NAME||PARAM TYPE||DATATYPE||<cfif isdefined("form.addNotes") and val(form.addNotes)>NOTES||</cfif><cfoutput query="getobject">
|#ordinal_position#|#column_name#|<cfswitch expression="#column_type#"><cfcase value="1">IN</cfcase><cfcase value="2">OUT</cfcase><cfcase value="3">RESULT COL</cfcase><cfcase value="4">OUTPUT</cfcase><cfcase value="5">RETURN VAL</cfcase><cfdefaultcase>?</cfdefaultcase></cfswitch>|#type_name#(#precision#)|<cfif isdefined("form.addNotes") and val(form.addNotes)> |</cfif></cfoutput></pre>
	</cfif>
	<br>
	</cfif></cfif>
	</cfloop>
	</cfif>
	
	<cfif isdefined("form.inclUserFunctions")>
	<br><br>
	<span class="heavy">USER DEFINED FUNCTIONS</span>
	<br><br>
	<cfloop query="allobjects"><cfif not len(ssr) or findlist(ssr,name)>
	<cfif listfindnocase("FN,TF,IF",type) and status gte 0>
		<cfsetting enablecfoutputonly="yes">
			<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="getobject">
					EXEC sp_sproc_columns '#trim(name)#';
			</cfquery>
		
			<cfset icols = 4> 
			<cfif isdefined("form.addNotes") and val(form.addNotes)>
			<cfset icols = icols + 1>
			</cfif>
		<cfsetting enablecfoutputonly="no">
	<cfif form.outputType eq "table">
	<table border="0" cellpadding="2" cellspacing="1" width="100%" class="bordered">
	<tr><cfoutput><td class="header" colspan="#icols#">#owner#.#name#</cfoutput></td></tr>
	<tr>
		<td class="header" align="center">POS</td>
		<td class="header">PARAM NAME</td>
		<td class="header">PARAM TYPE</td>
		<td class="header">DATATYPE</td><cfif isdefined("form.addNotes") and val(form.addNotes)>
		<td class="header">NOTES</td></cfif>
	</tr>
	<cfoutput query="getobject">
	<tr>
		<td align="right" width="3%">#ordinal_position#&nbsp;</td>
		<td width="47%">&nbsp;#column_name#</td>
		<td width="10%">&nbsp;
			<cfswitch expression="#column_type#">
				<cfcase value="1">IN</cfcase>
				<cfcase value="2">OUT</cfcase>
				<cfcase value="3">RESULT COL</cfcase>
				<cfcase value="4">OUTPUT</cfcase>
				<cfcase value="5">RETURN VAL</cfcase>
			<cfdefaultcase>?</cfdefaultcase>
			</cfswitch></td>
			<td>&nbsp;#type_name#(#precision#)</td><cfif isdefined("form.addNotes") and val(form.addNotes)>
			<td width="20%">&nbsp;</td></cfif>
		</tr>
	</cfoutput>
	</table>	
	<cfelseif form.outputType eq "tab">
	<pre><span class="heavy"><cfoutput>#owner#.#name#</cfoutput></span><cfoutput query="getobject">#chr(10)##chr(9)#<span class="heavy">#column_name#</span> <cfswitch expression="#column_type#"><cfcase value="1">IN</cfcase><cfcase value="2">OUT</cfcase><cfcase value="3">RESULT COL</cfcase><cfcase value="4">OUTPUT</cfcase><cfcase value="5">RETURN VAL</cfcase><cfdefaultcase>?</cfdefaultcase></cfswitch> #type_name#(#precision#)</cfoutput>
	</pre>
	<cfelseif form.outputType eq "confluence">
<pre>h3. <cfoutput>#owner#.#name#</cfoutput>
||POS||PARAM NAME||PARAM TYPE||DATATYPE||<cfif isdefined("form.addNotes") and val(form.addNotes)>NOTES||</cfif><cfoutput query="getobject">
|#ordinal_position#|#column_name#|<cfswitch expression="#column_type#"><cfcase value="1">IN</cfcase><cfcase value="2">OUT</cfcase><cfcase value="3">RESULT COL</cfcase><cfcase value="4">OUTPUT</cfcase><cfcase value="5">RETURN VAL</cfcase><cfdefaultcase>?</cfdefaultcase></cfswitch>|#type_name#(#precision#)|<cfif isdefined("form.addNotes") and val(form.addNotes)> |</cfif></cfoutput></pre>
	</cfif>
	<br>
	</cfif></cfif>
	</cfloop>
	</cfif>
	
	<cfcatch><cfdump var="#cfcatch#"></cfcatch>
</cftry>