<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
		9.0.2 - 5/8/2006 - Kevin Miller - added crud option for table/view codegen
------------------------------------------------------------------ --->

<cfsetting enablecfoutputonly = "no">

<!--- viewing the source page --->
<html>
<head>
	<title>DBX</title><cfoutput>
	<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>
	<cfset oidname = url.oid>
	<script>
			APP = top; 
	</script>
	
	<script>
		AUX = parent.detailtop;
		bottomLoaded = false; 
		checkLoaded = null;

		function checkFrames() {
			returnVal = false;
			if(bottomLoaded && parent.detailtop.topLoaded) {
				returnVal = true;
			}
			return returnVal;
		}
		
		function doLoad() {
			if(checkFrames()) {
				clearTimeout(checkLoaded);
				parent.detailbottom.document.qcform.qc.options[0].selected=true; 
				setQC();
				AUX.doQuickCopy();
			}
			else {
				checkLoaded = setTimeout('doLoad()',200);
			}
		}
		
			function setQC() { 
				var thirdheight = document.getElementById('third').offsetHeight; 
				document.getElementById('QuickCopy').style.height = thirdheight; 
			}

			function doresize() { 
				document.getElementById('QuickCopy').style.height = '1px'; 
				setQC(); 
				AUX.doQuickCopy();
			}
			onresize = doresize;
			
		function getElement(id){
			if (document.getElementById)
				return document.getElementById(id);
			if (document.all)
				return document.all[id];
			
			return null;
		}
		
		function initTab(id){
			oTA = getElement(id);
			if (oTA.attachEvent)
				oTA.attachEvent("onkeydown",function (event) { if (event.keyCode==9) { document.selection.createRange().text="\t"; return false; } });
			if (oTA.addEventListener)
				oTA.addEventListener(
				"keypress",
				function (event) {
					if (event.keyCode==9) {
						var oTA=this,
							iStart=oTA.selectionStart;
		
						oTA.value=this.value.substring(0,iStart)+"\t"+this.value.substr(oTA.selectionEnd);
						// setTimeout(function () { oTA.focus(); oTA.selectionStart=iStart+1; oTA.selectionEnd=iStart+1; },1);
						oTA.selectionStart=iStart+1; 
						oTA.selectionEnd=iStart+1;
						event.preventDefault()
					}
				},
				false
			)
		}
	</script>

</head>

<body onload="<cfif not isdefined("url.fn")>initTab('QuickCopy');</cfif> bottomLoaded = true;<cfif not isdefined("url.fn")>doLoad();</cfif>">
<cfif not isdefined("url.sp") and not isdefined("url.fn")><!--- table or view --->

<cfparam name="qc" type="string" default="select0">
<cfparam name="usetabs" type="string" default="0">
<cfparam name="usebrackets" type="string" default="0">
<cfparam name="usecf" type="string" default="1"><!--- value 2 is cfscript --->
<cfparam name="qualifiers" type="string" default="0">
<cfparam name="placeholders" type="string" default="2">
<cfparam name="scopeprefix" type="string" default="None">
<cfparam name="nullhandler" type="string" default="false">
<cftry>
<cfif isdefined("cookie.QUICKCOPY")>
	<cfset usetabs = listgetat(cookie.QUICKCOPY,1,"|")>
	<cfset usebrackets = listgetat(cookie.QUICKCOPY,2,"|")>
	<cfset usecf = listgetat(cookie.QUICKCOPY,3,"|")>
	<cfset qualifiers = listgetat(cookie.QUICKCOPY,4,"|")>
	<cfif listlen(cookie.QUICKCOPY,"|") gte 5>
		<cfset placeholders = listgetat(cookie.QUICKCOPY,5,"|")>
	</cfif>
	<cfif listlen(cookie.QUICKCOPY,"|") gte 6>
		<cfset qc = listgetat(cookie.QUICKCOPY,6,"|")>
	</cfif>
	<cfif listlen(cookie.QUICKCOPY,"|") gte 7>
		<cfset scopeprefix = listgetat(cookie.QUICKCOPY,7,"|")>
	</cfif>
	<cfif listlen(cookie.QUICKCOPY,"|") gte 8>
		<cfset nullhandler = listgetat(cookie.QUICKCOPY,8,"|")>
	</cfif>
</cfif>
<cfcatch>
<!--- nothing --->
</cfcatch>
</cftry>
<cftry>
	<cfinclude template="../../customizable/scope_prefixes.cfm"><!--- read in the list of variable prefixes --->
<cfcatch>
	<cfset scopes = "">
</cfcatch>
</cftry>

	<form name="qcform">
<table id="sourcelayout" border="0" cellpadding="0" cellspacing="0">
	<tr><td class="first">
		<table border="0" cellspacing="0" class="navbar2">
		<tr><td><div class="tab">CF Code Generator</div></td><td></td><td class="r"><a href="#" id="btnClip" class="nav" onclick="APP.copyToClipboard('QuickCopy',window.name);" title="Copy code to clipboard">&raquo; CLIPBOARD</a></td></tr>
		</table>
	</td></tr>
	<tr><td class="second">
<select name="qc" onChange="AUX.doQuickCopy();" title="Choose the type of code to be generated">
<option value="select0"<cfif qc eq "select0"> selected</cfif>>SELECT (Multiline)</option>
<option value="update0"<cfif qc eq "update0"> selected</cfif>>UPDATE (Multiline)</option>
<option value="insert0"<cfif qc eq "insert0"> selected</cfif>>INSERT (Multiline)</option>
<option value="select1"<cfif qc eq "select1"> selected</cfif>>SELECT (Inline)</option>
<option value="update1"<cfif qc eq "update1"> selected</cfif>>UPDATE (Inline)</option>
<option value="insert1"<cfif qc eq "insert1"> selected</cfif>>INSERT (Inline)</option>
<option value="all"<cfif qc eq "all"> selected</cfif>>ALL (CRUD)</option>
</select><select name="usecf" onChange="AUX.doQuickCopy();" title="Include CF code with generated SQL?"><option value="1"<cfif usecf eq 1> selected</cfif>>CFML+SQL</option><!--- <option value="2"<cfif usecf eq 2> selected</cfif>>CFSCRIPT+SQL (CF11+/LC4.5+)</option> ---><option value="0"<cfif usecf eq 0> selected</cfif>>SQL Only</option></select><select name="usetabs" onChange="AUX.doQuickCopy();" title="Indent code?"><option value="2"<cfif usetabs eq 2> selected</cfif>>No Indent</option><option value="1"<cfif usetabs eq 1> selected</cfif>>Indent/Tab</option><option value="0"<cfif usetabs eq 0> selected</cfif>>Indent/Space</option></select>
<select name="usebrackets" onChange="AUX.doQuickCopy();" title="Wrap values in brackets?"><option value="0"<cfif usebrackets eq 0> selected</cfif>>Brackets Off</option><option value="1"<cfif usebrackets eq 1> selected</cfif>>Brackets [On]</option></select><select name="qualifiers" onChange="AUX.doQuickCopy();" title="Choose the verbosity of the object qualifiers"><option value="0"<cfif qualifiers eq 0> selected</cfif>>Simple Naming</option><option value="1"<cfif qualifiers eq 1> selected</cfif>>Table.Column</option><option value="2"<cfif qualifiers eq 2> selected</cfif>>Owner.Table.Column</option><option value="3"<cfif qualifiers eq 3> selected</cfif>>Owner.Table.Column + Alias</option></select><select name="placeholders" onChange="AUX.doQuickCopy();" title="Insert variable placeholder text?"><option value="0"<cfif placeholders eq 0> selected</cfif>>No Placeholders</option><option value="1"<cfif placeholders eq 1> selected</cfif>>Column Name</option><option value="2"<cfif placeholders eq 2> selected</cfif>>CFQueryparam</option></select><select name="scopeprefix" onChange="AUX.doQuickCopy();" title="Prefix variable placeholders?"><option value="None"<cfif scopeprefix eq "None"> selected</cfif>>No Value</option><option value="Colname"<cfif scopeprefix eq "Colname"> selected</cfif>>COLNAME</option><cfoutput><cfloop list="#scopes#" index="s"><option value="#s#"<cfif scopeprefix eq s> selected</cfif>>#s#.COLNAME</option></cfloop></cfoutput></select><select name="nullhandler" onChange="AUX.doQuickCopy();"><option value="false"<cfif nullhandler eq "false"> selected</cfif>>Null Handling OFF</option><option value="true"<cfif nullhandler eq "true"> selected</cfif>>Null Handling ON</option></select></td></tr>
<tr><td class="third" id="third">
<textarea id="QuickCopy"></textarea>
</td></tr>
</table>
</form>

<cfelse><!--- sp --->

<cfparam name="usetabs" type="string" default="0">
<cfparam name="placeholders" type="string" default="2">
<cfparam name="scopeprefix" type="string" default="None">
<cfparam name="procstyle" type="string" default="cfstoredproc">
<cfparam name="nullhandler" type="string" default="false">
<cftry>
<cfif isdefined("cookie.QUICKCOPY")>
	<cfset usetabs = listgetat(cookie.QUICKCOPY,1,"|")>
	<cfif listlen(cookie.QUICKCOPY,"|") gte 5>
		<cfset placeholders = listgetat(cookie.QUICKCOPY,5,"|")>
	</cfif>
	<cfif listlen(cookie.QUICKCOPY,"|") gte 7>
		<cfset scopeprefix = listgetat(cookie.QUICKCOPY,7,"|")>
	</cfif>
	<cfif listlen(cookie.QUICKCOPY,"|") gte 8>
		<cfset nullhandler = listgetat(cookie.QUICKCOPY,8,"|")>
	</cfif>
</cfif>
<cfcatch>
<!--- nothing --->
</cfcatch>
</cftry>
<cftry>
	<cfinclude template="../../customizable/scope_prefixes.cfm"><!--- read in the list of variable prefixes --->
<cfcatch>
	<cfset scopes = "">
</cfcatch>
</cftry>
<cfif not isdefined("url.fn")>
	<form name="qcform">
<table id="sourcelayout" border="0" cellpadding="0" cellspacing="0">
	<tr><td class="first">
		<table border="0" cellspacing="0" class="navbar2">
		<tr><td><div class="tab">CF Code Generator</div></td><td class="r"><a href="#" id="btnClip" class="nav" onclick="APP.copyToClipboard('QuickCopy',window.name);">&raquo; CLIPBOARD</a></td></tr>
		</table>
	</td></tr>	
	<tr><td class="second">
<select name="qc" onChange="AUX.doQuickCopy();">
<option value="cfstoredproc"<cfif procstyle eq "cfstoredproc"> selected</cfif>>CFSTOREDPROC</option>
<option value="cfquery_multi"<cfif procstyle eq "cfquery_multi"> selected</cfif>>CFQUERY (Multi)</option>
<option value="cfquery"<cfif procstyle eq "cfquery"> selected</cfif>>CFQUERY (Single)</option>
</select>
<select name="usetabs" onChange="AUX.doQuickCopy();"><option value="2">No Indent</option><option value="1" selected>Indent/Tab</option><option value="0">Indent/Space</option></select><cfoutput>&nbsp;&nbsp;&nbsp;Add <select name="resulttags" onChange="AUX.doQuickCopy();"><option value="0" selected>0</option><cfloop from="1" to="20" index="p"><option value="#p#">#p#</option></cfloop></select> CFPROCRESULT tags&nbsp;&nbsp;&nbsp;</cfoutput>
<select name="placeholders" onChange="AUX.doQuickCopy();"><option value="0"<cfif placeholders eq 0> selected</cfif>>No Placeholders</option><option value="1"<cfif placeholders eq 1> selected</cfif>>Variable Name</option><option value="2"<cfif placeholders eq 2> selected</cfif>>CFQueryparam</option></select>
<select name="scopeprefix" onChange="AUX.doQuickCopy();"><option value="None"<cfif scopeprefix eq "None"> selected</cfif>>No Value Placeholder</option><option value="Colname"<cfif scopeprefix eq "Colname"> selected</cfif>>VARNAME</option><cfoutput><cfloop list="#scopes#" index="s"><option value="#s#"<cfif scopeprefix eq s> selected</cfif>>#s#.VARNAME</option></cfloop></cfoutput></select><select name="nullhandler" onChange="AUX.doQuickCopy();"><option value="false"<cfif nullhandler eq "false"> selected</cfif>>Null Handling OFF</option><option value="true"<cfif nullhandler eq "true"> selected</cfif>>Null Handling ON</option></select>
</td></tr>
<tr><td class="third" id="third">
<textarea id="QuickCopy"></textarea>
</td></tr>
</table>
</form>
	<cfelse>
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr><td valign="middle" align="center">There is no Code Generator view associated with a Function</td></tr>
	</table>
	</cfif>
</cfif>

</body>
</html>