<cfsetting enablecfoutputonly = "yes">

<!--- --------------------------------------------------------------- 
	@author:		Kevin Miller
	@date:		5/9/2005
	@version:	9.0 
	
	@description: 	
   		
		
	@changelog: 
		[version - date - author - comment]
		9.0.1 - 5/9/2005 - Kevin Miller - creation 
------------------------------------------------------------------ --->

		<cfquery datasource="#dbdsn#" username="#dbuser#" password="#dbpass#" name="allObjects">
		SELECT ltrim(rtrim(s.name)) as name, ltrim(rtrim(s.type)) as type, ltrim(rtrim(s.status)) as status, ltrim(rtrim(su.name)) AS owner FROM sysobjects s INNER JOIN sysusers su ON s.uid = su.uid ORDER BY type, name
		</cfquery>

		<cfparam name="ss" type="string" default="">
		<cfset ss = trim(ss)>

		<cfinclude template="udf/udf_FindList.cfm">
		
<cfsetting enablecfoutputonly="no">
<!--- main list page --->
<html>
<head>
	<title>DBX</title><cfoutput>
	<link rel="stylesheet" type="text/css" href="#dbxr.fullpathprefix#styles/style.css"></cfoutput>
	<script>
		APP = top;
		APP.writeStatus(2);
	</script>
	<cfoutput>
	<script type="text/javascript" src="#dbxr.fullpathprefix#tree/cooltree.js"></script></cfoutput>

	<script type="text/javascript">
	var USER_TABLES = [];
	var USER_VIEWS = [];
	var USER_PROCS = [];
	var USER_FUNCTIONS = [];
	var SYSTEM_TABLES = [];
	var SYSTEM_VIEWS = [];
	var SYSTEM_PROCS = [];
	var SYSTEM_FUNCTIONS = [];

	<cfoutput query="allobjects">
		<cfif not len(ss) or findlist(ss,name)>
			<cfif type eq "U" and status gte 0>USER_TABLES.push({"owner":"#owner#","name":"#name#","target":"detail"});
			<cfelseif type eq "V" and status gte 0>USER_VIEWS.push({"owner":"#owner#","name":"#name#","target":"detail"});
			<cfelseif type eq "P" and status gte 0><cfset ppfok = true><cfif listlen(dbx.procprefixfilter)><cfloop list="#dbx.procprefixfilter#" index="p"><cfif left(name,len(p)) eq p><cfset ppfok = false><cfbreak></cfif></cfloop></cfif><cfif ppfok>USER_PROCS.push({"owner":"#owner#","name":"#name#","target":"detail"});</cfif>
			<cfelseif listfindnocase("FN,TF,IF",type) and status gte 0>USER_FUNCTIONS.push({"owner":"#owner#","name":"#name#","target":"detail"});
			<cfelseif type eq "S" or (type eq "U" and status lt 0)>SYSTEM_TABLES.push({"owner":"#owner#","name":"#name#","target":"detail"});
			<cfelseif type eq "V" and status lt 0>SYSTEM_VIEWS.push({"owner":"#owner#","name":"#name#","target":"detail"});
			<cfelseif type eq "P" and status lt 0>SYSTEM_PROCS.push({"owner":"#owner#","name":"#name#","target":"detail"});
		</cfif></cfif></cfoutput>
	
	<cfoutput>
	var fpprefix = '#dbxr.fullfilepathprefix#';</cfoutput>

	var USER_OBJECTS = ['User Objects<cfif len(ss)><cfoutput> <span style="color: ##993300;">(filtered for: % <b>#htmleditformat(ss)#</b> %)</span></cfoutput></cfif>', null, null];

	var temp = ['TABLES',null,null]; 
	if(USER_TABLES.length == 0) { 
		temp.push(['none', null, null]); 
	} 
	else { 
		for(var i = 0; i < USER_TABLES.length; i++) {
			temp.push(['[' + USER_TABLES[i].owner + '] ' + USER_TABLES[i].name,fpprefix + '?frame=' + USER_TABLES[i].target + '&owid=' + USER_TABLES[i].owner + '&oid=' + encodeURI(USER_TABLES[i].name),USER_TABLES[i].target]);
		}
	} 
	USER_OBJECTS.push(temp);
	
	temp = ['VIEWS',null,null]; 
	if(USER_VIEWS.length == 0) { 
		temp.push(['none', null, null]); 
	} 
	else { 
		for(var i = 0; i < USER_VIEWS.length; i++) {
			temp.push(['[' + USER_VIEWS[i].owner + '] ' + USER_VIEWS[i].name,fpprefix + '?frame=' + USER_VIEWS[i].target + '&owid=' + USER_VIEWS[i].owner + '&oid=' + encodeURI(USER_VIEWS[i].name) + '&v=1',USER_VIEWS[i].target]);
		}
	} 
	USER_OBJECTS.push(temp);
	
	temp = ['STORED PROCS',null,null]; 
	if(USER_PROCS.length == 0) { 
		temp.push(['none', null, null]); 
	} 
	else { 
		for(var i = 0; i < USER_PROCS.length; i++) {
			temp.push(['[' + USER_PROCS[i].owner + '] ' + USER_PROCS[i].name,fpprefix + '?frame=' + USER_PROCS[i].target + '&owid=' + USER_PROCS[i].owner + '&oid=' + encodeURI(USER_PROCS[i].name) + '&sp=1',USER_PROCS[i].target]);
		}
	} 
	USER_OBJECTS.push(temp);
	
	temp = ['USER DEFINED FUNCTIONS',null,null]; 
	if(USER_FUNCTIONS.length == 0) { 
		temp.push(['none', null, null]); 
	} 
	else { 
		for(var i = 0; i < USER_FUNCTIONS.length; i++) { 
			temp.push(['[' + USER_FUNCTIONS[i].owner + '] ' + USER_FUNCTIONS[i].name,fpprefix + '?frame=' + USER_FUNCTIONS[i].target + '&owid=' + USER_FUNCTIONS[i].owner + '&oid=' + encodeURI(USER_FUNCTIONS[i].name) + '&sp=1&fn=1',USER_FUNCTIONS[i].target]); 
		} 
	} 
	USER_OBJECTS.push(temp);

	var SYSTEM_OBJECTS = ['System Objects', null, null];

	temp = ['TABLES',null,null]; 
	if(SYSTEM_TABLES.length == 0) { 
		temp.push(['none', null, null]); 
	} 
	else { 
		for(var i = 0; i < SYSTEM_TABLES.length; i++) {
			temp.push(['[' + SYSTEM_TABLES[i].owner + '] ' + SYSTEM_TABLES[i].name,fpprefix + '?frame=' + SYSTEM_TABLES[i].target + '&owid=' + SYSTEM_TABLES[i].owner + '&oid=' + encodeURI(SYSTEM_TABLES[i].name),SYSTEM_TABLES[i].target]);
		}
	} 
	SYSTEM_OBJECTS.push(temp);
	
	temp = ['VIEWS',null,null]; 
	if(SYSTEM_VIEWS.length == 0) { 
		temp.push(['none', null, null]); 
	} 
	else { 
		for(var i = 0; i < SYSTEM_VIEWS.length; i++) {
			temp.push(['[' + SYSTEM_VIEWS[i].owner + '] ' + SYSTEM_VIEWS[i].name,fpprefix + '?frame=' + SYSTEM_VIEWS[i].target + '&owid=' + SYSTEM_VIEWS[i].owner + '&oid=' + encodeURI(SYSTEM_VIEWS[i].name) + '&v=1',SYSTEM_VIEWS[i].target]);
		}
	} 
	SYSTEM_OBJECTS.push(temp);
	
	temp = ['STORED PROCS',null,null]; 
	if(SYSTEM_PROCS.length == 0) { 
		temp.push(['none', null, null]); 
	} 
	else { 
		for(var i = 0; i < SYSTEM_PROCS.length; i++) {
			temp.push(['[' + SYSTEM_PROCS[i].owner + '] ' + SYSTEM_PROCS[i].name,fpprefix + '?frame=' + SYSTEM_PROCS[i].target + '&owid=' + SYSTEM_PROCS[i].owner + '&oid=' + encodeURI(SYSTEM_PROCS[i].name) + '&sp=1',SYSTEM_PROCS[i].target]);
		}
	} 
	SYSTEM_OBJECTS.push(temp);

	var NAV_NODES = [USER_OBJECTS,SYSTEM_OBJECTS];

	<!--- 
	var NAV_NODES = [
		['User Objects', null, null,
			['TABLES', null, null,<cfset isSome = 0>
			<cfoutput query="allobjects"><cfif type eq "U" and status gte 0><cfif not isSome><cfset isSome = 1></cfif>['[#owner#] #name#', '#dbxr.fullfilepathprefix#?frame=detail&oid=#urlencodedformat(name)#&owid=#owner#', 'detail'],</cfif>
			</cfoutput><cfif not isSome>['none', null, null]</cfif>
			],
			['VIEWS', null, null,<cfset isSome = 0>
			<cfoutput query="allobjects"><cfif type eq "V" and status gte 0><cfif not isSome><cfset isSome = 1></cfif>['[#owner#] #name#', '#dbxr.fullfilepathprefix#?frame=detail&oid=#urlencodedformat(name)#&owid=#owner#&v=1', 'detail'],</cfif>
			</cfoutput><cfif not isSome>['none', null, null]</cfif>
			],
			['STORED PROCS', null, null,<cfset isSome = 0>
			<cfoutput query="allobjects"><cfset ppfok = true><cfif listlen(dbx.procprefixfilter)><cfloop list="#dbx.procprefixfilter#" index="p"><cfif left(name,len(p)) eq p><cfset ppfok = false><cfbreak></cfif></cfloop></cfif><cfif type eq "P" and status gte 0 and ppfok><cfif not isSome><cfset isSome = 1></cfif>['[#owner#] #name#', '#dbxr.fullfilepathprefix#?frame=detail&oid=#urlencodedformat(name)#&owid=#owner#&sp=1', 'detail'],</cfif>
			</cfoutput><cfif not isSome>['none', null, null]</cfif>
			],
			['USER DEFINED FUNCTIONS', null, null,<cfset isSome = 0>
			<cfoutput query="allobjects"><cfif listfindnocase("FN,TF,IF",type) and status gte 0><cfif not isSome><cfset isSome = 1></cfif>['[#owner#] #name#', '#dbxr.fullfilepathprefix#?frame=detail&oid=#urlencodedformat(name)#&owid=#owner#&sp=1&fn=1', 'detail'],</cfif>
			</cfoutput><cfif not isSome>['none', null, null]</cfif>
			],
		],
		['System Objects', null, null,
			['SYSTEM TABLES', null, null,<cfset isSome = 0>
			<cfoutput query="allobjects"><cfif type eq "S" or (type eq "U" and status lt 0)><cfif not isSome><cfset isSome = 1></cfif>['[#owner#] #name#', '#dbxr.fullfilepathprefix#?frame=detail&oid=#urlencodedformat(name)#&owid=#owner#&sys=true', 'detail'],</cfif>
			</cfoutput><cfif not isSome>['none', null, null]</cfif>
			],
			['SYSTEM VIEWS', null, null,<cfset isSome = 0>
			<cfoutput query="allobjects"><cfif type eq "V" and status lt 0><cfif not isSome><cfset isSome = 1></cfif>['[#owner#] #name#', '#dbxr.fullfilepathprefix#?frame=detail&oid=#urlencodedformat(name)#&owid=#owner#&v=1&sys=true', 'detail'],</cfif>
			</cfoutput><cfif not isSome>['none', null, null]</cfif>
			],
			['SYSTEM PROCS', null, null,<cfset isSome = 0>
			<cfoutput query="allobjects"><cfif type eq "P" and status lt 0><cfif not isSome><cfset isSome = 1></cfif>['[#owner#] #name#', '#dbxr.fullfilepathprefix#?frame=detail&oid=#urlencodedformat(name)#&owid=#owner#&sp=1&sys=true', 'detail'],</cfif>
			</cfoutput><cfif not isSome>['none', null, null]</cfif>
			],
		]
	];
	--->
		var NAV_FORMAT = [10,10,true,["tree/c3.gif", "tree/e3.gif", "tree/b.gif"],[16,16,0],false,[],[16,16],[0,16,32,48,64,80,96,112,128,144,160,176,192,208,224,240,256,272],"","clsNode",[],false,[0,0],];
	</script>
	
</head>

<body class="list" onload="APP.writeStatus(0);">
<script type="text/javascript">
	var nav = new COOLjsTree ("NAV", NAV_NODES, NAV_FORMAT);
	nav.expandNode(0);
	<cfif len(ss)>nav.expandNode(1);</cfif>
</script>
</body>
</html>